var TEST_MODE = true; // 테스트 모드(true:테스트, false:상용)

(function (GC, $, undefined) {

    // 구매내역 조회(main)
    GC.A001 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customor id', request.cid)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  		    = request.cid;

        handleAjax("POST", SERVER_URL+"/goods/card/list", params, callbackSuccess, callbackFail);
    }

    // 상품 목록 조회
    GC.A002 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.query_type  		= '1';
        params.sort_type        = '2';

        handleAjax("POST", SERVER_URL+"/goods/list", params, callbackSuccess, callbackFail);
    }

    // 상품 정보 조회
    GC.A003 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('goods code', request.goods_code)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.goods_code  		= request.goods_code;

        handleAjax("POST", SERVER_URL+"/goods/detail", params, callbackSuccess, callbackFail);
    }

    // 주문
    GC.A004 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customor id', request.cid)
         || isEmptyParameter('pay type', request.pay_type)
         || isEmptyParameter('buy type', request.buy_type)
         || isEmptyParameter('orders', request.orders)
         || isEmptyParameter('delivery', request.delivery_yn)
         || isEmptyParameter('payments', request.payments)
         || isEmptyParameter('trx_no', request.trx_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid              = request.cid;
        params.pay_type         = request.pay_type;
        params.buy_type         = request.buy_type;
        params.buyer_name       = request.buyer_name;
        params.orders           = request.orders;
        params.delivery_yn      = request.delivery_yn;
        params.payments         = request.payments;
        params.trx_no           = request.trx_no

        handleAjax("POST", SERVER_URL+"/goods/order", params, callbackSuccess, callbackFail);
    }

    // TREEPAY용 해시키 획득을 위한 API
    GC.A005 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('pay_type', request.pay_type)
         || isEmptyParameter('order_no', request.order_no)
         || isEmptyParameter('trade_mony', request.trade_mony)
         || isEmptyParameter('site_cd', request.site_cd)
         || isEmptyParameter('user_id', request.user_id)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.pay_type                 = request.pay_type;
        params.order_no                 = request.order_no;
        params.trade_mony               = request.trade_mony;
        params.site_cd                  = SITE_CD;
        params.user_id                  = request.user_id;
        params.bill_end_ymd             = request.bill_end_ymd;
        params.bill_frequency           = request.bill_frequency;

        handleAjax("POST", SERVER_URL+"/treepay/hash", params, callbackSuccess, callbackFail);
    }

    // 구매내역 상세조회
    GC.A006 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customer id', request.cid)
         || isEmptyParameter('ticket no', request.ticket_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  	       	= request.cid;
        params.ticket_no  		= request.ticket_no;
        params.goods_code  		= request.goods_code;

        handleAjax("POST", SERVER_URL+"/goods/issue/detail", params, callbackSuccess, callbackFail);
    }

    // 티켓별 사용내역 조회
    GC.A007 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customer id', request.cid)
         || isEmptyParameter('ticket no', request.ticket_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  	       	= request.cid;
        params.ticket_no  		= request.ticket_no;
        params.page_no          = request.page_no;
        params.page_disp_cnt    = request.page_disp_cnt;

        handleAjax("POST", SERVER_URL+"/goods/trx/list", params, callbackSuccess, callbackFail);
    }

    // 선물내역 조회
    GC.A008 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customer id', request.cid)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  	       	= request.cid;
        params.page_no  	    = request.page_no;
        params.page_disp_cnt  	= request.page_disp_cnt;

        handleAjax("POST", SERVER_URL+"/goods/send/list", params, callbackSuccess, callbackFail);
    }

    // 카드 등록
    GC.A009 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customer id', request.cid)
         || isEmptyParameter('ticket', request.ticket_no)
         || isEmptyParameter('card number', request.card_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  	       	   = request.cid;
        params.ticket_no  	       	= request.ticket_no;
        params.card_no  	       	= request.card_no;

        handleAjax("card", SERVER_URL+"/goods/card/add", params, callbackSuccess, callbackFail);
    }

    // 카드 해지
    GC.A010 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customer id', request.cid)
         || isEmptyParameter('ticket', request.ticket_no)
         || isEmptyParameter('card number', request.card_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  	       	   = request.cid;
        params.ticket_no  	       	= request.ticket_no;
        params.card_no  	       	= request.card_no;

        handleAjax("card", SERVER_URL+"/goods/card/del", params, callbackSuccess, callbackFail);
    }

    // 티켓 취소(발급취소)
    GC.A011 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customer id', request.cid)
         || isEmptyParameter('aprv number', request.aprv_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  	       	   = request.cid;
        params.trx_no  	       	= request.aprv_no;

        handleAjax("card", SERVER_URL+"/goods/cancelCoupon", params, callbackSuccess, callbackFail);
    }

    // 발급
    GC.A012 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customer id', request.cid)
         || isEmptyParameter('order number', request.order_no)
         || isEmptyParameter('payment amount', request.payment_amt)
         || isEmptyParameter('payment', request.payments)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  	       	   = request.cid;
        params.order_no  	       	= request.order_no;
        params.payment_amt  	       	= request.payment_amt;
        params.payments  	       	= request.payments;

        handleAjax("POST", SERVER_URL+"/goods/issue", params, callbackSuccess, callbackFail);
    }

    // 상태조회
    GC.A013 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('order_no', request.order_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.order_no  	= request.order_no;

        handleAjax("POST", SERVER_URL+"/goods/trx/status", params, callbackSuccess, callbackFail);
    }

    // 티켓 상세 조회
    GC.A014 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('customer id', request.cid)
         || isEmptyParameter('ticket_no', request.ticket_no)
          || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.cid  	   = request.cid;
        params.ticket_no  	= request.ticket_no;

        handleAjax("POST", SERVER_URL+"/goods/issue/ticketDetail", params, callbackSuccess, callbackFail);
    }

    // 선물 받은 기프트카드의 핀번호를 본인껄로 만들기 위해 등록
    GC.A015 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('recv_cid', request.recv_cid)
         || isEmptyParameter('pin_no', request.pin_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.recv_cid  	   = request.recv_cid;
        params.pin_no  	        = request.pin_no;

        handleAjax("POST", SERVER_URL+"/goods/pin/regist", params, callbackSuccess, callbackFail);
    }

    // 노출 여부 변경
    GC.A016 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('ticket_no', request.ticket_no)
         || isEmptyParameter('success callback', callbackSuccess)
         || isEmptyParameter('fail callback', callbackFail)) {
            return;
        }

        var params = new Object();
        params.ticket_no  	        = request.ticket_no;

        handleAjax("POST", SERVER_URL+"/goods/changeDisp", params, callbackSuccess, callbackFail);
    }

    GC.A017 = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter('ticket_no', request.ticket_no)
         || isEmptyParameter('aprv_no', request.aprv_no)
         || isEmptyParameter('brand_id', request.brand_id)
         || isEmptyParameter('mcnt_id', request.mcnt_id)
         || isEmptyParameter('callbackSuccess', callbackSuccess)
    	 || isEmptyParameter('callbackFail', callbackFail)) {
    		return;
    	}

    	var params = new Object();
        params.ticket_no	= request.ticket_no;
        params.aprv_no		= request.aprv_no;
        params.brand_id		= request.brand_id;
        params.mcnt_id		= request.mcnt_id;
        params.trx_use_cd   = request.trx_use_cd;
        params.stamp_no     = request.stamp_no;
        params.use_amt      = request.use_amt;
        params.cid          = request.cid;
        params.use_div_cd   = request.use_div_cd;
        params.device_no    = request.device_no;
        params.trx_no       = request.trx_no;
        params.use_type     = request.pay_mthd;
        params.pay_no       = request.pay_no;

    	handleAjax("POST", SERVER_URL+"/manager/use", params, callbackSuccess, callbackFail);
    }

    GC.A018 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter('use_price', request.use_price)
         || isEmptyParameter('brand_id', request.brand_id)
         || isEmptyParameter('aprv_no', request.aprv_no)
         || isEmptyParameter('callbackSuccess', callbackSuccess)
    	 || isEmptyParameter('callbackFail', callbackFail)) {
    		return;
    	}

    	var params = new Object();
    	params.ticket_no		= request.ticket_no;
        params.use_price		= request.use_price;
        params.brand_id			= request.brand_id;
        params.mcnt_id			= request.mcnt_id;
        params.aprv_no			= request.aprv_no;
        params.stamp_no         = request.stamp_no;
        params.device_no        = request.device_no;
        params.use_div_cd       = request.use_div_cd;
        params.use_type         = request.pay_mthd;

    	handleAjax("POST", SERVER_URL+"/manager/useCancel", params, callbackSuccess, callbackFail);
    }


    function isEmptyParameter(key, value) {
        if(value === undefined || value === null || value === '') {
            showAlert(key +' is required', MESSAGE_CLOSE, function() {});
            return true;
        }
		return false;
	}

    function handleAjax(type, url, params, callbackSuccess, callbackFail, alphaFlag) {
        params.lang = LANGUAGE;
        params.channel = CHANNEL;
        console.log('[' + url + '] PARAMETER :: ', params);

        var headers = {};

        if(type == 'card') {
            headers = {
                'Content-Type'  : 'Application/json',
                'type'          : 'C'
            }
        }

    	$.ajax({
            type: 'POST',
            url: url,
            contentType: "Application/json",
            headers: headers,
    		data: JSON.stringify(params),
    		cache: false,
            crossDomain : true,
            success: function(data) {
        		if (data.resCd == "0000") {
                    console.log('[' + url + '] RESULT :: ', data.result);
                    callbackSuccess(data.result);
        		} else {
        			callbackFail(data.resCd, data.resMsg);
        		}
            },
            error: function (xhr, textStatus, errorThrown) {
                callbackFail(textStatus, errorThrown);
            }
        });
    }

}(window.GC = window.GC = {}, jQuery));

function getCurrentDate() {
	var now = new Date();
	var yyyy = '' + now.getFullYear();
	var mm = (now.getMonth() + 1) > 9 ? '' + (now.getMonth() + 1) : '0' + (now.getMonth() + 1);
	var dd = now.getDate() > 9 ? '' + now.getDate() : '0' + now.getDate();
	return yyyy + mm + dd;
}

// file:///Users/hyun/Workspace/Mobile/voucher/TB_32/html/purchase_confirm.html?ch=5f3b141d763c45e5b7bdfafadf8b92a5&cid=1386889361408801&lt=2&gt=1&bt=2&type=%201&ga=%EA%B0%90%EC%9E%90%ED%83%95%EB%A9%B4%201%EB%B4%89%EC%A7%80%5EG17103100109%5E1%5E1500%7C&ca=G17103100109%5E%EB%B0%95%ED%98%84%EC%9B%85%5E01045340415%7C
