var TEST_MODE = false; // 테스트 모드(true:테스트, false:상용)

// var CHANNEL = '003d876d24fe46d5a343ba51ddde0e6a';
var CHANNEL = 'b37b9c74dbef416ea4c790d8ad61c4bc';

function API_KEY() {

    var TEST_API_KEY = 'dd680552da8164404a2e0101fe4e1658c';
    var LIVE_API_KEY = 'p9d3aa94deb714a5fb90030d2a486a6dc';

    return TEST_MODE ? TEST_API_KEY : LIVE_API_KEY;
}

(function (GC, $, undefined) {
    var TEST_SERVER_URL = "http://61.35.35.203:45340/giftcard";
	var LIVE_SERVER_URL = "https://gc-api.echoss.co.kr/giftcard";

    var SERVER_URL = TEST_MODE ? TEST_SERVER_URL : LIVE_SERVER_URL;
 
    GC.generateGiftCard = function(request, callbackSuccess, callbackFail) {
        var params = new Object();
        params.channel		= CHANNEL;
        params.cid  		= request.cid;
        params.trx_no       = request.trx_no;
        params.goods_code   = "G17072100001";
        params.sale_amt     = "50000";
        params.gift_amt     = "50000";
        params.recv_info    = "01000000000";

        handleAjax("POST", SERVER_URL+"/goods/sendCoupon", params, callbackSuccess, callbackFail);
    }
 
    // 스탬프 인증
    GC.accuStamp = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.eq)
    	 || isEmptyParameter(request.s)
     	 || isEmptyParameter(request.p)
     	 || isEmptyParameter(request.c)
         || isEmptyParameter(request.version)
         || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
    	params.eq			= request.eq;
        params.s  			= request.s;
        params.p            = request.p;
        params.c            = request.c;
        params.version      = request.version;
        params.brnd_id      = request.brnd_id;


    	handleAjax("POST", SERVER_URL+"/manager/stampAuth", params, callbackSuccess, callbackFail);
    }

    // 티켓 상세내역 가져오기
    GC.getDetailTicket = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.ticket_no)
         || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
        params.cid  			= request.cid;
        params.ticket_no		= request.ticket_no;


    	handleAjax("POST", SERVER_URL+"/goods/issue/ticketDetail", params, callbackSuccess, callbackFail);
    }

    // 거래내역 가져오기
    GC.goodsTrxList = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.ticket_no)
         || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
        params.cid  			= request.cid;
        params.ticket_no		= request.ticket_no;


    	handleAjax("POST", SERVER_URL+"/goods/trx/list", params, callbackSuccess, callbackFail);
    }

    // otp 사용전 정보조회
    GC.managerMcntPrepayInfo = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.ticket_no)
         || isEmptyParameter(request.cid)
         || isEmptyParameter(request.brand_id)
         || isEmptyParameter(request.mcnt_id)
         || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
        params.mcnt_id      = request.mcnt_id;
        params.ticket_no	= request.ticket_no;
        params.cid			= request.cid;
        params.brand_id		= request.brand_id;


    	handleAjax("POST", SERVER_URL+"/manager/mcntPrepayInfo", params, callbackSuccess, callbackFail);
    }

    // otp 사용전 정보조회
    GC.managerInitMcntPrepayInfo = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.brand_id)
         || isEmptyParameter(request.mcnt_id)
         || isEmptyParameter(request.goods_code)
         || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
        params.mcnt_id      = request.mcnt_id
        // params.ticket_no	= request.ticket_no;
        params.cid			= request.cid;
        params.brand_id		= request.brand_id;
        params.goods_code   = request.goods_code;


    	handleAjax("POST", SERVER_URL+"/manager/initMcntPrepayInfo", params, callbackSuccess, callbackFail);
    }

    // otp 사용
    GC.managerOtpUse = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.ticket_no)
         || isEmptyParameter(request.cid)
         || isEmptyParameter(request.aprv_no)
         || isEmptyParameter(request.brand_id)
         || isEmptyParameter(request.mcnt_id)
         || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
        params.ticket_no	= request.ticket_no;
        params.cid			= request.cid;
        params.aprv_no		= request.aprv_no;
        params.brand_id		= request.brand_id;
        params.mcnt_id		= request.mcnt_id;
        params.seq_no       = request.seq_no;
        params.trx_div_cd   = request.trx_div_cd;
        params.trx_use_cd   = request.trx_use_cd;


    	handleAjax("POST", SERVER_URL+"/manager/otp/use", params, callbackSuccess, callbackFail);
    }

    // otp 사용
    GC.merchantEquipotpCharge = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.goods_code)
         || isEmptyParameter(request.sale_amt)
         || isEmptyParameter(request.gift_amt)
         || isEmptyParameter(request.recv_info)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.cid			   = request.cid;
        params.trx_no	       = request.trx_no;
        params.goods_code	   = request.goods_code;
        params.sale_amt		   = request.sale_amt;
        params.gift_amt		   = request.gift_amt;
        params.buyer_name      = request.buyer_name;
        params.recv_info       = request.recv_info;
        params.mcnt_id		   = request.mcnt_id;
        params.trx_use_cd      = request.trx_use_cd;
        params.seq_no          = request.seq_no;


        handleAjax("POST", SERVER_URL+"/merchant/equip/otpcharge", params, callbackSuccess, callbackFail);
    }

    // 사용 취소
    GC.managerUseCancel = function(request, callbackSuccess, callbackFail) {

        console.log(mcnt_id);

    	if (isEmptyParameter(request.use_price)
         || isEmptyParameter(request.brand_id)
         || isEmptyParameter(request.aprv_no)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();

    	params.ticket_no		= request.ticket_no;
        params.use_price		= request.use_price;
        params.brand_id			= request.brand_id;
        params.mcnt_id			= request.mcnt_id;
        params.aprv_no			= request.aprv_no;


    	handleAjax("POST", SERVER_URL+"/manager/useCancel", params, callbackSuccess, callbackFail);
    }


    // 발급 취소 (정액권)
    GC.issueCancel = function(request, callbackSuccess, callbackFail) {

    	if (isEmptyParameter(request.cancel_price)
         || isEmptyParameter(request.aprv_no)
         || isEmptyParameter(request.mcnt_id)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();

    	params.ticket_no		= request.ticket_no;
        params.cancel_price		= request.use_price;
        params.aprv_no			= request.aprv_no;
        params.stamp            = request.stamp;
        params.mcnt_id          = request.mcnt_id;


    	handleAjax("POST", SERVER_URL+"/goods/issue/cancel", params, callbackSuccess, callbackFail);
    }

    // 발급 취소 (충전권)
    GC.orderCancel = function(request, callbackSuccess, callbackFail) {

    	if (isEmptyParameter(request.order_no)
         || isEmptyParameter(request.aprv_no)
         || isEmptyParameter(request.mcnt_id)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();

        params.order_no		    = request.order_no;
        params.aprv_no			= request.aprv_no;
        params.stamp            = request.stamp;
        params.mcnt_id          = request.mcnt_id;


    	handleAjax("POST", SERVER_URL+"/goods/order/cancel", params, callbackSuccess, callbackFail);
    }

    function isEmptyParameter(parameter) {
		return parameter === undefined || parameter === null || parameter === '';
	}

    function handleAjax(type, url, params, callbackSuccess, callbackFail) {
            params.lang = 'en';
            params.channel = CHANNEL;

    	$.ajax({
            type: type,
            url: url,
            contentType : "application/json",
    		data: JSON.stringify(params),
    		cache: false,
            crossDomain : true,
            success: function(data) {
        		if (data.resCd == "0000") {
    				callbackSuccess(data.result);
        		}
        		else {
        			callbackFail(data.resCd, data.resMsg);
        		}
            },
            error: function (xhr, textStatus, errorThrown) {
                callbackFail(textStatus, errorThrown);
            }
        });
    }
}(window.GC = window.GC = {}, jQuery));

function getCurrentDate() {
	var now = new Date();
	var yyyy = '' + now.getFullYear();
	var mm = (now.getMonth() + 1) > 9 ? '' + (now.getMonth() + 1) : '0' + (now.getMonth() + 1);
	var dd = now.getDate() > 9 ? '' + now.getDate() : '0' + now.getDate();
	return yyyy + mm + dd;
}
