var callback_stamp_on = function(){}

function cssTransitionDelay(sec) {
	return {
		'-webkit-transition-delay': sec+'s',
		'-moz-transition-delay': sec+'s',
		'-ms-transition-delay': sec+'s',
		'-o-transition-delay': sec+'s',
		'transition-delay': sec+'s'
	}
}
function cssTransform(property) {
	return {
		'-webkit-transform': property
		, '-moz-transform': property
		, '-ms-transform': property
		, '-o-transform': property
		, 'transform': property
	}
}
function cssTransition(property) {
	return {
		'-webkit-transition': property
		, '-moz-transition': property
		, '-ms-transition': property
		, '-o-transition': property
		, 'transition': property
	}
}

var zIndex = 1000;
var windowWidth = 360;
var windowHeight = 720;

window.requestAnimFrame = (function(callback) {
	return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame ||
		function(callback) {
			window.setTimeout(callback, 1000 / 60);
		};
})();

$(document)
	.on('initTouchMove', function(e) {
		e.stopPropagation();

		var isMoving = false;

		var param = {
			posStart: {}
			, posCur: {}
			, obj: null
			, startTime: 0
			, transform: 'none'
			, speed:{}
		};

		$(document)
			.on('touchstart', '.touchmove', function(e) {
				e.preventDefault();
				e.stopPropagation();

				isMoving = true;
				param.obj = $(this);
				param.posStart = param.posCur = {
					x: e.originalEvent.touches[0].clientX
					, y: e.originalEvent.touches[0].clientY
				};

				param.transform = $(this).css('transform');
				param.startTime = new Date().getTime();

				//console.log('touchstart', param);
				param.obj.trigger('start', param);
			})
			.on('touchmove', function(e) {
				if(isMoving) {
					e.preventDefault();

					param.posCur = {
						x: e.originalEvent.touches[0].clientX
						, y: e.originalEvent.touches[0].clientY
					};

					//console.log('touchmove', param);
					param.obj.trigger('move', param);
				}
			})
			.on('touchend', function(e) {
				if(isMoving) {
					e.preventDefault();

					isMoving = false;

					var t = new Date().getTime();
					param.speed = {
						x:Math.abs(param.posCur.x-param.posStart.x)/(t-param.startTime)*100
						, y:Math.abs(param.posCur.y-param.posStart.y)/(t-param.startTime)*100
					};

					param.transform = param.obj.css('transform');
					//console.log(param.speed);
					//console.log('touchend', param);
					param.obj.trigger('end', param);

					param.obj = null;
				}
			})
	})
	.on('init', '#main', function(e) {
		e.stopPropagation();

		var $main = $(this);

		//slide
		var slideWidth = 0;
		var $slide1 = $main.find('.slide1');	//.css({width:windowWidth-(windowWidth-146)/2});
		var $slide2 = $main.find('.slide2');	//.css({width:windowWidth-(windowWidth-146)/2});
		var $slideImg = $main.find('.slide1 img, .slide2 img');
		var slideImgCount = 0;
		var slide1Threshold = 0;
		var slide2Threshold = 0;
		var slide3Threshold = 0;
		var slideSize = 146;
		var slideSpeedThreshold = 40;

		$(document)
			/*
			* 메인 이동시 호출
			* getDetailTicket() 을 호출해서 기프트카드의 전체 금액과 사용가능금액 최신화
			*/
			.on('show', '#main', function(e, delay) {
				e.stopPropagation();

				$('#main_history_back').show();

				if(typeof delay === 'undefined') {
					delay = 1;
				}

				clearTimeout($main.data('timeout'));
				console.log('main show');
				getDetailTicket();

				$main.data('timeout', setTimeout(function() {
					$slide1.addClass('show');
					$slide2.addClass('show');
					// $slide3.addClass('show');

					$main.find('.menu, .card, .price-wrap').addClass('show');
				}, delay));
			})
			/*
			* 메인페이지에서 다른 페이지로 이동시 호출
			*/
			.on('hide', '#main', function(e) {

				$('#main_history_back').hide();

				e.stopPropagation();

				$slide1.removeClass('show');
				$slide2.removeClass('show');
				// $slide3.removeClass('show');

				$main.find('.menu, .card, .price-wrap').removeClass('show');
			})

			/*
			* 스탬프 찍기위한 페이지 호출
			*/
			.on('move', '#main .slide1 .handle', function(e, param) {
				e.stopPropagation();

				var $handle = $(this);
				if(!$handle.hasClass('animate')) {
					var translate = 0;
					if(param.transform == 'none') {
						translate = 0;
					} else {
						translate = (/\(.+,.+,.+,.+,(.+),.+\)/gi).exec(param.transform);
						if(translate && translate.length == 2) {
							translate = parseInt(translate[1]);
						} else {
							translate = 0;
						}
					}
					var x = param.posStart.x-param.posCur.x - translate;
					if(x>=0) {
						$handle.css(cssTransform('translate3d(-'+x+'px, 0, 0)'));
					} else {
						$handle.css(cssTransform('translate3d(0,0,0)'));
					}
				}
			})
			/*
			* 사용내역 조회 페이지 호출
			*/
			.on('move', '#main .slide2 .handle', function(e, param) {
				e.stopPropagation();

				var $handle = $(this);

				if(!$handle.hasClass('animate')) {
					var translate = 0;
					if (param.transform == 'none') {
						translate = 0;
					} else {
						translate = (/\(.+,.+,.+,.+,(.+),.+\)/gi).exec(param.transform);
						if (translate && translate.length == 2) {
							translate = parseInt(translate[1]);
						} else {
							translate = 0;
						}
					}
					var x = param.posCur.x - param.posStart.x + translate;
					if (x >= 0) {
						$handle.css(cssTransform('translate3d(' + x + 'px, 0, 0)'));
					} else {
						$handle.css(cssTransform('translate3d(0,0,0)'));
					}
				}
			})
			/*
			* 메인페이지에서 stamp버튼을 슬라이드하면 호출
			*/
			.on('end', '#main .slide1 .handle', function(e, param) {
				e.stopPropagation();

				var $handle = $(this);

				var translate = 0;
				if(param.transform == 'none') {
					translate = 0;
				} else {
					translate = (/\(.+,.+,.+,.+,(.+),.+\)/gi).exec(param.transform);
					if(translate && translate.length == 2) {
						translate = parseInt(translate[1]);
					} else {
						translate = 0;
					}
				}

				$handle.addClass('animate');
				if(param.speed.x<slideSpeedThreshold && Math.abs(translate) < slide1Threshold) {
					$handle.animate({'transform':'translate3d(0,0,0)'}, 400, 'easeOutQuart', function() {
						$handle.removeClass('animate').css(cssTransition('disabled'));
					});
				} else {
					var speed = (slideWidth+translate)/param.speed.x*100;
					speed = speed > 400 ? 400 : speed;
					$handle.animate({'transform':'translate3d(-'+slideWidth+'px, 0, 0'}, speed, function(e) {
						$handle.removeClass('animate').css(cssTransition('disabled'));
						$('#stamp').trigger('show');
					})
				}
			})
			/*
			* 메인페이지에서 use record 버튼을 슬라이드하면 호출
			* 슬라이드가 완료되면 getUseList() 호출
			*/
			.on('end', '#main .slide2 .handle', function(e, param) {
				e.stopPropagation();

				var $handle = $(this);

				var translate = 0;
				if(param.transform == 'none') {
					translate = 0;
				} else {
					translate = (/\(.+,.+,.+,.+,(.+),.+\)/gi).exec(param.transform);
					if(translate && translate.length == 2) {
						translate = parseInt(translate[1]);
					} else {
						translate = 0;
					}
				}

				$handle.addClass('animate');
				if(param.speed.x<slideSpeedThreshold && Math.abs(translate) < slide2Threshold) {
					$handle.animate({'transform':'translate3d(0,0,0)'}, 400, 'easeOutQuart', function() {
						$handle.removeClass('animate').css(cssTransition('disabled'));
					});
				} else {
					var speed = (slideWidth-translate)/param.speed.x*100;
					speed = speed > 400 ? 400 : speed;
					$handle.animate({'transform':'translate3d('+slideWidth+'px, 0, 0'}, speed, function(e) {
						$handle.removeClass('animate').css(cssTransition('disabled'));
						// $('#barcode').trigger('show');
						getUseList();
					})
				}
			})
		;

		$slideImg
			.on('load', function(e) {
				slideImgCount++;

				if(slideImgCount >= 2) {
					slideWidth = windowWidth-(windowWidth-slideSize)/2;
					$slide1.css({width:slideWidth});
					$slide2.css({width:slideWidth});
					slide2Threshold = slide1Threshold = (slideWidth -slideSize) * 8 / 10;
					// slide3Threshold = (88 - 60) * 8 / 10;

					$main.trigger('show');
				}
			})
			.each(function() {
				$(this).attr('src', $(this).data('src'));
			});
	})
	.on('init', '#history', function(e) {
		e.stopPropagation();

		var $history = $(this);

		$(document)
			/*
			* 사용내역 페이지를 열기 위해서 호출
			*/
			.on('show', '#history', function(e, delay) {
				e.stopPropagation();

				clearTimeout($history.data('timeout'));

				var transitionDelay = 0;
				var transitionDelaySize = 50;
				var $title = $history.find('.title');
				var $back = $history.find('.back');
				var $ul = $history.find('ul');

				$history.addClass('show');

				$($ul.find('li').get().reverse()).each(function() {
					transitionDelay+=transitionDelaySize;
					$(this).css(cssTransitionDelay((transitionDelay/1000)) )
				});
				transitionDelay+=transitionDelaySize;
				var transitionDelayCss = cssTransitionDelay((transitionDelay/1000));
				$back.css(transitionDelayCss);
				$title.css(transitionDelayCss);

				if(typeof delay === 'undefined') {
					delay = 100;
				}

				$history.data('timeout', setTimeout(function() {
					$back.addClass('show');
					$title.addClass('show');
					$ul.addClass('show');

					setTimeout(function () {
						$('#main .slide2 .handle').css(cssTransform('translate3d(0,0,0)'));
					}, 400);

				}, delay));
			})
			/*
			* 사용내역을 종료할때 호출
			*/
			.on('hide', '#history', function(e) {
				e.stopPropagation();

				clearTimeout($history.data('timeout'));

				var transitionDelay = 0;
				var transitionDelaySize = 50;
				var $title = $history.find('.title');
				var $back = $history.find('.back');
				var $ul = $history.find('ul');

				transitionDelay+=transitionDelaySize;
				var transitionDelayCss = cssTransitionDelay((transitionDelay/1000));
				$back.css(transitionDelayCss);
				$title.css(transitionDelayCss);

				$ul.find('li').each(function() {
					transitionDelay+=transitionDelaySize;
					$(this).css(cssTransitionDelay((transitionDelay/1000)));
				});

				$back.removeClass('show detail');
				$title.removeClass('show detail');
				$ul.removeClass('show detail');
				$history.data('timeout', setTimeout(function() {
					$history.removeClass('show');
				}, 600));
			})
			/*
			* 사용내역 페이지에서 단건 상세조회때 호출
			*/
			.on('showDetail', '#history', function(e) {
				e.stopPropagation();

				clearTimeout($history.data('timeout'));

				var transitionDelay = 0;
				var transitionDelaySize = 50;
				var $title = $history.find('.title');
				var $back = $history.find('.back');
				var $ul = $history.find('ul');

				$($ul.find('li').get().reverse()).each(function() {
					transitionDelay+=transitionDelaySize;
					$(this).css(cssTransitionDelay((transitionDelay/1000)));
				});

				transitionDelay+=transitionDelaySize;
				var transitionDelayCss = cssTransitionDelay((transitionDelay/1000));
				$back.css(transitionDelayCss);
				$title.css(transitionDelayCss);

				$back.removeClass('show').addClass('detail');
				$title.removeClass('show').addClass('detail');
				$ul.removeClass('show').addClass('detail');
			})
			/*
			* 사용내역 페이지에서 단건 상세조회 종료시 호출
			*/
			.on('hideDetail', '#history', function(e) {
				e.stopPropagation();

				clearTimeout($history.data('timeout'));

				var transitionDelay = 0;
				var transitionDelaySize = 50;
				var $title = $history.find('.title');
				var $back = $history.find('.back');
				var $ul = $history.find('ul');

				transitionDelay+=transitionDelaySize;
				var transitionDelayCss = cssTransitionDelay((transitionDelay/1000));
				$back.css(transitionDelayCss);
				$title.css(transitionDelayCss);

				$ul.find('li').each(function() {
					transitionDelay+=transitionDelaySize;
					$(this).css(cssTransitionDelay((transitionDelay/1000)));
				});

				$history.data('timeout', setTimeout(function() {
					$back.addClass('show');
					$title.addClass('show');
					$ul.addClass('show');
				}, 600));
			})
			/*
			* 사용내역에서 li태그에 걸려있는 a 태그 터치시 사용
			*/
			.on('click', '#history a.back', function(e) {
				e.preventDefault();

				$history.trigger('hide');
				$('#main').trigger('show', 600);

				// getStampInfo(param.p);
			})
	})
	.on('init', '#payment_cancel_detail', function(e) {
		e.stopPropagation();

		var $payment_cancel_detail = $(this);

		$(document)
			/*
			* 사용내역 페이지를 열기 위해서 호출
			*/
			.on('show', '#payment_cancel_detail', function(e, delay) {
				e.stopPropagation();

				clearTimeout($payment_cancel_detail.data('timeout'));

				var transitionDelay = 0;
				var transitionDelaySize = 50;
				var $title = $payment_cancel_detail.find('.title');
				var $back = $payment_cancel_detail.find('.back');
				var $ul = $payment_cancel_detail.find('ul');
				var $contentwrap = $payment_cancel_detail.find('content_wrap');

				$payment_cancel_detail.addClass('show');

				$($ul.find('li').get().reverse()).each(function() {
					transitionDelay+=transitionDelaySize;
					$(this).css(cssTransitionDelay((transitionDelay/1000)) )
				});
				transitionDelay+=transitionDelaySize;
				var transitionDelayCss = cssTransitionDelay((transitionDelay/1000));
				$back.css(transitionDelayCss);
				$title.css(transitionDelayCss);
				$contentwrap.css(transitionDelayCss);

				if(typeof delay === 'undefined') {
					delay = 100;
				}

				$payment_cancel_detail.data('timeout', setTimeout(function() {
					$back.addClass('show');
					$title.addClass('show');
					$ul.addClass('show');
					$contentwrap.addClass('show');

					setTimeout(function () {
						$('#main .slide2 .handle').css(cssTransform('translate3d(0,0,0)'));
					}, 400);

				}, delay));
			})
			/*
			* 사용내역을 종료할때 호출
			*/
			.on('hide', '#payment_cancel_detail', function(e) {
				e.stopPropagation();

				clearTimeout($payment_cancel_detail.data('timeout'));

				var transitionDelay = 0;
				var transitionDelaySize = 50;
				var $title = $payment_cancel_detail.find('.title');
				var $back = $payment_cancel_detail.find('.back');
				var $ul = $payment_cancel_detail.find('ul');
				var $contentwrap = $payment_cancel_detail.find('content_wrap');

				transitionDelay+=transitionDelaySize;
				var transitionDelayCss = cssTransitionDelay((transitionDelay/1000));
				$back.css(transitionDelayCss);
				$title.css(transitionDelayCss);
				$contentwrap.css(transitionDelayCss);

				$ul.find('li').each(function() {
					transitionDelay+=transitionDelaySize;
					$(this).css(cssTransitionDelay((transitionDelay/1000)));
				});

				$back.removeClass('show detail');
				$title.removeClass('show detail');
				$ul.removeClass('show detail');
				$payment_cancel_detail.data('timeout', setTimeout(function() {
					$payment_cancel_detail.removeClass('show');
				}, 0));
			})
			.on('click', '#payment_cancel_detail a.back', function(e) {
				// echoss.icon.hideIcon();

				e.preventDefault();

				$('#stamp .back').trigger('click');
				$payment_cancel_detail.trigger('hide');
				$('#history').trigger('show', 330);
			})
	})
	.on('init', '#stamp', function(e) {
		e.stopPropagation();

		var $stamp = $(this);

		$(document)
			/*
			* 스탬프 페이지 호출시 자동호출
			* 스탬프 초기화 진행
			* 아이콘 초기화 진행
			*/
			.on('show', '#stamp', function(e) {
				e.stopPropagation();

				clearTimeout($stamp.data('timeout'));
				$stamp.addClass('ready').data('timeout', setTimeout(function() {
					$stamp.addClass('show');

					// *************************
					// echoss initialize
					// *************************
					echoss.setLanguageCode(echoss.Common.LANGUAGE_CODE_TYPE.ENGLISH);
					echoss.initialize(API_KEY(), echoss.REGION_CODE_TYPE.KOREA);

					$stamp.data('timeout', setTimeout(function() {
						$('#main .slide1 .handle').css(cssTransform('translate3d(0,0,0)'));
					}, 400));

					// callback
					callback_stamp_on();
				}, 100));
			})
			/*
			* 스탬프 페이지 종료시 호출
			*/
			.on('hide', '#stamp', function(e) {
				e.stopPropagation();

				clearTimeout($stamp.data('timeout'));
				$stamp.removeClass('show').data('timeout', setTimeout(function() {
					$stamp.removeClass('ready');
				}, 400));

				// callback
				callback_stamp_off();
			})
			/*
			* 스탬프 상세조회시 호출
			*/
			.on('showDetail', '#stamp', function(e) {
				e.stopPropagation();

				$('#main').trigger('hide');
				$stamp.addClass('detail');
				$('#receipt').data('target', 'stamp').trigger('show', 500);
			})
			/*
			* 스탬프 상세조회 종료시 호출
			*/
			.on('hideDetail', '#stamp', function(e) {
				e.stopPropagation();

				clearTimeout($stamp.data('timeout'));
				$stamp.addClass('no-anim').removeClass('detail').trigger('hide');
				$stamp.data('timeout', setTimeout(function() {
					$stamp.removeClass('no-anim');
				}, 100));
			})
			/*
			* 스탬프 화면을 종료할때 사용.
			* icon이미지도 숨겨야 하기때문에 echoss.Icon.hideIcon() 을 호출
			*/
			.on('click', '#stamp .back', function(e) {
				echoss.Icon.hideIcon();

				e.preventDefault();

				$stamp.trigger('hide');
			})
	})
	.on('init', '#receipt', function(e) {
		e.stopPropagation();

		var $receipt = $(this);

		$(document)

			/*
			* 사용내역 조회시 사용
			*/
			.on('show', '#receipt', function(e, delay) {
				e.stopPropagation();

				var $receipt = $(this);
				clearTimeout($receipt.data('timeout'));
				$receipt.addClass('ready');

				if(typeof delay === 'undefined') {
					delay = 50;
				}
				$receipt.data('timeout', setTimeout(function() {
					$receipt.css({zIndex:zIndex++}).addClass('show');

					//매장 이미지 조절
					var $storeImage = $receipt.find('.store-image');
					var $storeImageImg = $storeImage.find('img');
					$storeImageImg.on('load', function(e) {
						$storeImageImg.css({marginLeft:-($storeImageImg.outerWidth()-$storeImage.outerWidth())/2});
						$storeImage.addClass('ready');
					});
					$storeImageImg.attr('src', $storeImageImg.data('src'));
				}, delay));
			})
			/*
			* 사용내역 조회 종료시 사용
			*/
			.on('hide', '#receipt', function(e) {
				e.stopPropagation();

				var $receipt = $(this);
				clearTimeout($receipt.data('timeout'));
				$receipt.removeClass('show');
				$receipt.data('timeout', setTimeout(function() {
					$receipt.removeClass('ready');
				}, 900));
			})
			/*
			* 사용내역 내부에서 confirm 버튼 터치시 호출
			* 사용내역 자세히보기가 닫힘
			*/
			.on('click', '#receipt .confirm', function(e) {
				e.preventDefault();
				$receipt.trigger('hide');
				if($receipt.data('target') == 'history') {
					$receipt.removeClass('history');
					$('#history').trigger('hideDetail');
				} else
					if($receipt.data('target') == 'stamp') {
					$('#main').trigger('show', 400);
					$('#stamp').trigger('hideDetail');
				} else if($receipt.data('target') == 'barcode') {
					$('#main').trigger('show', 400);
					$('#barcode').trigger('hideDetail');
				}
			})
	})
	.on('init', '#receipt_com', function(e) {
		e.stopPropagation();

		var $receipt = $(this);

		$(document)
			/*
			* 스탬프 혹은 otp를 사용해서 인증 한 후 결제전 결제정보 미리보기 화면 진입시 호출
			*/
			.on('show', '#receipt_com', function(e, delay) {
				e.stopPropagation();

				var $receipt = $(this);
				clearTimeout($receipt.data('timeout'));
				$receipt.addClass('ready');

				if(typeof delay === 'undefined') {
					delay = 50;
				}
				$receipt.data('timeout', setTimeout(function() {
					$receipt.css({zIndex:zIndex++}).addClass('show');

					//매장 이미지 조절
					var $storeImage = $receipt.find('.store-image');
					var $storeImageImg = $storeImage.find('img');
					$storeImageImg.on('load', function(e) {
						$storeImageImg.css({marginLeft:-($storeImageImg.outerWidth()-$storeImage.outerWidth())/2});
						$storeImage.addClass('ready');
					});
					$storeImageImg.attr('src', $storeImageImg.data('src'));
				}, delay));
			})
			/*
			* 결제전 결제정보 미리보기 화면 종료시 호출
			*/
			.on('hide', '#receipt_com', function(e) {
				e.stopPropagation();

				var $receipt = $(this);

				if($receipt.data('target') == 'stamp') {
					// getStampInfo(param.p);

					$('#main').trigger('show', 400);
					$('#stamp').trigger('hideDetail')
				}
				clearTimeout($receipt.data('timeout'));
				$receipt.removeClass('show');
				$receipt.data('timeout', setTimeout(function() {
					$receipt.removeClass('ready');
				}, 900));
			})
			/*
			* 결제전 결제정보 미리보기 화면 오른쪽 pay 버튼시 사용
			* manageruse() 메소드 호출
			* managerUse()를 호출시 실제로 결제가 일어남
			*/
			.on('click', '#receipt_com .confirm_right', function(e) {
				e.preventDefault();
				managerUse();

			})
			/*
			* 결제전 결제정보 미리보기 화면 오른쪽 cancel 버튼시 사용
			* 메인페이지로 돌아감
			*/
			.on('click', '#receipt_com .cancel', function(e) {
				e.preventDefault();

				$receipt.trigger('hide');
				if($receipt.data('target') == 'history') {
					$receipt.removeClass('history');
					$('#history').trigger('hideDetail');
				} else if($receipt.data('target') == 'stamp') {
					// getStampInfo(param.p);

					$('#main').trigger('show', 400);
					$('#stamp').trigger('hideDetail')
				} else if($receipt.data('target') == 'barcode') {
					// getStampInfo(param.p);

					$('#main').trigger('show', 400);
					$('#barcode').trigger('hideDetail');
				}
			})
	})
	.on('init', '#alert', function(e) {
		e.stopPropagation();

		var $alert = $(this);
		var alertCallback = null;

		$(document)
			/*
			* 알럿메세지 호출
			* $('#alert').trigger('show', {msg:message, callback:function() { }}); 메세지로 호출
			* 화면에 표시될 메세지는 message에 넣음(string)
			* 애니메이션 컨트롤
			*/
			.on('show', '#alert', function(e, param) {
				e.stopPropagation();

				alertCallback = null;

				if(typeof param['msg'] !== 'undefined') {
					$alert.find('.msg').html(param['msg']);
				}

				if(typeof param['callback'] === 'function') {
					alertCallback = param['callback'];
				}

				clearTimeout($alert.data('timeout'));
				$alert.addClass('ready').data('timeout', setTimeout(function() {
					$alert.addClass('show');
				}, 100));
			})
			/*
			* 알럿메세지 내 버튼 클릭시 호출
			* $('#alert').trigger('show', {msg:message, callback:function() { }}); 메세지로 호출
			* callback function 안에 들어있는 메소드가 이때 호출됨
			* 애니메이션 컨트롤
			*/
			.on('click', '#alert .confirm', function(e) {
				e.preventDefault();

				clearTimeout($alert.data('timeout'));
				$alert.removeClass('show').data('timeout', setTimeout(function() {
					$alert.removeClass('ready');
					if(alertCallback)
						alertCallback();
				}, 600));

			})
	})
;

$(function() {
	windowWidth = $(window).outerWidth();

	$(document).trigger('initTouchMove');
	$('#main').trigger('init');
	$('#history').trigger('init');
	$('#payment_cancel_detail').trigger('init');
	$('#stamp').trigger('init');
	$('#barcode').trigger('init');
	$('#coupon').trigger('init');
	$('#receipt').trigger('init');
	$('#receipt_com').trigger('init');
	$('#alert').trigger('init');
});
