var TEST_MODE = true; // 테스트 모드(true:테스트, false:상용)

function API_KEY() {

    var TEST_API_KEY = 'dd680552da8164404a2e0101fe4e1658c';
    var LIVE_API_KEY = 'p9d3aa94deb714a5fb90030d2a486a6dc';

    return TEST_MODE ? TEST_API_KEY : LIVE_API_KEY;
}

function CHANNEL() {
    var TEST_CH = '003d876d24fe46d5a343ba51ddde0e6a';
    var LIVE_CH = 'b37b9c74dbef416ea4c790d8ad61c4bc';

    return TEST_MODE ? TEST_CH : LIVE_CH;
}

(function (GC, $, undefined) {
    var TEST_SERVER_URL = "http://61.35.35.203:45340/giftcard";
	var LIVE_SERVER_URL = "https://gc-api.echoss.co.kr/giftcard";

    var SERVER_URL = TEST_MODE ? TEST_SERVER_URL : LIVE_SERVER_URL;

    // 스탬프번호 조회
    GC.managerStampCheck = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.stamp)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
    	params.stamp			= request.stamp;


    	handleAjax("POST", SERVER_URL+"/manager/stampcheck", params, callbackSuccess, callbackFail);
    }

    // 스탬프 인증
    GC.managerStampAuth = function(request, callbackSuccess, callbackFail) {

        if (isEmptyParameter(request.stamp)
         || isEmptyParameter(request.mcnt_id)
         || isEmptyParameter(request.eq)
         || isEmptyParameter(request.s)
         || isEmptyParameter(request.p)
         || isEmptyParameter(request.c)
         || isEmptyParameter(request.version)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.stamp        = request.stamp;
        params.mcnt_id      = request.mcnt_id;
        params.eq			= request.eq;
        params.s  			= request.s;
        params.p            = request.p;
        params.c            = request.c;
        params.version		= request.version;


        handleAjax("POST", SERVER_URL+"/manager/stampAuth", params, callbackSuccess, callbackFail);
    }

    // 결제 승인
    GC.managerPrepayment = function(request, callbackSuccess, callbackFail) {

        if (isEmptyParameter(request.mcnt_id)
         || isEmptyParameter(request.use_price)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.use_price         = request.use_price;
        params.mcnt_id           = request.mcnt_id;
        params.trx_div_cd        = request.trx_div_cd;

        handleAjax("POST", SERVER_URL+"/manager/prepayment", params, callbackSuccess, callbackFail);
    }

    // 결제 승인
    GC.managerOtpPrepayment = function(request, callbackSuccess, callbackFail) {

        if (isEmptyParameter(request.mcnt_id)
         || isEmptyParameter(request.use_price)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.use_price    = request.use_price;
        params.mcnt_id        = request.mcnt_id;


        handleAjax("POST", SERVER_URL+"/manager/otp/prepayment", params, callbackSuccess, callbackFail);
    }

    // 고객앱에서 사용 조회
    GC.managerPaymentCheck = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.pay_aprv_no)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
    	params.pay_aprv_no			= request.pay_aprv_no;
        params.trx_div_cd           = request.trx_div_cd;

    	handleAjax("POST", SERVER_URL+"/manager/paymentcheck", params, callbackSuccess, callbackFail);
    }

    // 고객앱에서 사용 조회
    GC.managerPrepaymentCancel = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.pay_aprv_no)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
    	params.pay_aprv_no			= request.pay_aprv_no;

    	handleAjax("POST", SERVER_URL+"/manager/prepaymentCancel", params, callbackSuccess, callbackFail);
    }

    // 메인 페이지 조회
    GC.managerMain = function(request, callbackSuccess, callbackFail) {
    	if (isEmptyParameter(request.mcnt_id)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
    	params.mcnt_id			= request.mcnt_id;

    	handleAjax("POST", SERVER_URL+"/manager/main", params, callbackSuccess, callbackFail);
    }

    // 내역 조회
    GC.managerPayhis = function(request, callbackSuccess, callbackFail) {

        console.log(request.mcnt_id);
        console.log(request.start_dt);
        console.log(request.end_dt);
        console.log(request.aprv_no);

    	if (isEmptyParameter(request.mcnt_id)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();
    	params.mcnt_id			= request.mcnt_id;
    	params.start_dt			= request.start_dt;
        params.end_dt			= request.end_dt;
        params.aprv_no			= request.aprv_no;

        handleAjax("POST", SERVER_URL+"/manager/payhis", params, callbackSuccess, callbackFail);
    }

    // 사용 취소
    GC.managerUseCancel = function(request, callbackSuccess, callbackFail) {

        console.log(request.use_price);
        console.log(request.useInfo);
        console.log(request.brand_id);
        console.log(request.aprv_no);

    	if (isEmptyParameter(request.use_price)
         || isEmptyParameter(request.useInfo)
         || isEmptyParameter(request.brand_id)
         || isEmptyParameter(request.aprv_no)
    	 || isEmptyParameter(callbackSuccess)
    	 || isEmptyParameter(callbackFail)) {
    		callbackFail("E001", "You missed some parameter.");
    		return;
    	}

    	var params = new Object();

    	params.ticket_no		= request.ticket_no;
        params.use_price		= request.use_price;
        params.useInfo			= request.useInfo;
        params.brand_id			= request.brand_id;
        params.aprv_no			= request.aprv_no;


    	handleAjax("POST", SERVER_URL+"/manager/useCancel", params, callbackSuccess, callbackFail);
    }

    function isEmptyParameter(parameter) {
		return parameter === undefined || parameter === null || parameter === '';
	}

    function handleAjax(type, url, params, callbackSuccess, callbackFail) {

        params.channel = CHANNEL();

    	$.ajax({
            type: type,
            url: url,
            contentType : "application/json",
    		data: JSON.stringify(params),
    		cache: false,
            crossDomain : true,
            success: function(data) {
        		if (data.resCd == "0000") {
    				callbackSuccess(data.result);
        		}
        		else {
        			callbackFail(data.resCd, data.resMsg);
        		}
            },
            error: function (xhr, textStatus, errorThrown) {
                callbackFail(textStatus, errorThrown);
            }
        });
    }
}(window.GC = window.GC = {}, jQuery));

function getCurrentDate() {
	var now = new Date();
	var yyyy = '' + now.getFullYear();
	var mm = (now.getMonth() + 1) > 9 ? '' + (now.getMonth() + 1) : '0' + (now.getMonth() + 1);
	var dd = now.getDate() > 9 ? '' + now.getDate() : '0' + now.getDate();
	return yyyy + mm + dd;
}
