var stampPageFlag = false;
var payFlag = true;

function checkPayFlag() {
	// true-사용, false-충전
	return payFlag? '1' : '2';
}

function cssTransitionDelay(sec) {
	return {
		'-webkit-transition-delay': sec+'s',
		'-moz-transition-delay': sec+'s',
		'-ms-transition-delay': sec+'s',
		'-o-transition-delay': sec+'s',
		'transition-delay': sec+'s'
	}
}
function cssTransform(property) {
	return {
		'-webkit-transform': property
		, '-moz-transform': property
		, '-ms-transform': property
		, '-o-transform': property
		, 'transform': property
	}
}
function cssTransition(property) {
	return {
		'-webkit-transition': property
		, '-moz-transition': property
		, '-ms-transition': property
		, '-o-transition': property
		, 'transition': property
	}
}

Date.isLeapYear = function (year) {
	return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
};
Date.getDaysInMonth = function (year, month) {
	return [31, (Date.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
};
Date.prototype.isLeapYear = function () {
	return Date.isLeapYear(this.getFullYear());
};
Date.prototype.getDaysInMonth = function () {
	return Date.getDaysInMonth(this.getFullYear(), this.getMonth());
};
Date.prototype.addMonths = function (value) {
	var n = this.getDate();
	this.setDate(1);
	this.setMonth(this.getMonth() + value);
	this.setDate(Math.min(n, this.getDaysInMonth()));
	return this;
};
Date.prototype.format = function() {
	var year = this.getFullYear();
	var month = this.getMonth() + 1;
	var day = this.getDate();

	return year + '-'
		+ (month<10 ? '0' + month : month) + '-'
		+ (day<10 ? '0' + day : day);
};

var zIndex = 1000;
var windowWidth = 360;
var windowHeight = 720;

window.requestAnimFrame = (function(callback) {
	return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame ||
		function(callback) {
			window.setTimeout(callback, 1000 / 60);
		};
})();

/*
* 호출 방법
* $('#아이디').trigger('trigger', 500);
*/
$(document)
	.on('init', '#main', function(e) {
		e.stopPropagation();

		var $main = $(this);

		//market title
		var $market = $main.find('.market');
		var $marketSpan = $market.find('span');
		var marketSpanWidth = $marketSpan.outerWidth();
		var marketMargin = (windowWidth-marketSpanWidth)/2-29;
		$market.css({marginRight:marketMargin});


		$(document)
			/*
			* 메인페이지를 호출할때 사용
			* 애니메이션 컨트롤
			*/
			.on('show', '#main', function(e, delay) {
				selMainInfo();
				initPayment();

				e.stopPropagation();

				if(typeof delay === 'undefined') {
					delay = 100;
				}

				clearTimeout($main.data('timeout'));
				$main.addClass('ready').data('timeout', setTimeout(function() {
					$main.addClass('show');
				}, delay));
			})
			/*
			* 메인페이지를 숨김처리할때 사용
			* 애니메이션 컨트롤
			*/
			.on('hide', '#main', function(e) {
				e.stopPropagation();

				clearTimeout($main.data('timeout'));
				$main.removeClass('show');
				$main.data('timeout', setTimeout(function() {
					$main.removeClass('ready');
				}, 600));
			})
			/*
			* 메인페이지에서 사용내역페이지 호출할때 사용
			* 애니메이션 컨트롤
			* 메인페이지를 숨기고 #history를 보이게 한다.
			*/
			.on('click', '#main .history .title a', function(e) {
				e.preventDefault();

				$main.trigger('hide');
				$('#history').trigger('show', 500);
			})
			// .on('click', '#main .detail_his .title a', function(e) {
			// 	console.log('main to detail_his');
			// 	e.preventDefault();
			//
			// 	$main.trigger('hide');
			// 	$('#history_detail').trigger('show', 500);
			// })


			/*
			* 메인페이지에서 pay버튼을 터치할때 사용
			* 애니메이션 컨트롤
			* 메인페이지를 숨기고 #payment 보이게 함
			*/
			.on('click', '#main a.pay', function(e) {
				e.preventDefault();
				$('#payment #payBtn').html('Pay');
				payFlag = true;

				// $main.trigger('hide');
				// $('#payment').trigger('show', 600);
				//payment 서버 페이지 연동

				payment();
			})
			// .on('click', '#main a.recharge', function(e) {
			// 	e.preventDefault();
			// 	$('#payment #payBtn').html('Recharge');
			// 	payFlag = false;
			//
			// 	$main.trigger('hide');
			// 	$('#payment').trigger('show', 600);
			//
			// })
		;

		$main.trigger('show');
	})
	.on('init', '#history', function(e) {
		e.stopPropagation();

		var $history = $(this);
		$(document)

			/*
			* 사용내역 페이지를 호출할때 사용되는 메소드
			* 애니메이션 컨트롤
			*/
			.on('show', '#history', function(e, delay) {
				e.stopPropagation();

				clearTimeout($history.data('timeout'));

				var $form = $history.find('form');

				$history.addClass('show');

				if(typeof delay === 'undefined') {
					delay = 100;
				}

				setOtpData();

				$history.data('timeout', setTimeout(function() {
					$form.addClass('show');
					selUseList(1);

					echoss.Icon.disableIcon(false);
					echoss.Icon.showIcon();
				}, delay))
			})
			/*
			* 사용내역 페이지를 종료할때 사용되는 메소드
			* 애니메이션 컨트롤
			* interval이 작동시에는 interval 종료
			*/
			.on('hide', '#history', function(e) {
				e.stopPropagation();

				clearTimeout($history.data('timeout'));

				var $form = $history.find('form');
				var $list = $history.find('ul.list');
				var transitionDelay = 0;
				var transitionDelaySize = 50;

				$list.find('li').each(function() {
					transitionDelay+=transitionDelaySize;
					$(this).css(cssTransitionDelay((transitionDelay/1000)) )
				});

				echoss.Icon.disableIcon(true);
				echoss.Icon.hideIcon();

				$form.removeClass('show');
				$list.removeClass('show');
				$history.data('timeout', setTimeout(function() {
					$history.removeClass('show');
				}, 600));

			})
			/*
			* 사용내역 페이지내에서 사용내역 API를 통해 서버와 연동하는 메소드 사용되는 메소드
			* 각 버튼당 설정된 CLASS값에 따라 selUseList(구분코드) 를 호출
			*/
			.on('click', '#history .today', function(e) {
				e.preventDefault();
				selUseList(1);
				$('#search_aprv_input').val('');
				$('#search_aprv_input').html('');
			})
			.on('click', '#history .month1', function(e) {
				e.preventDefault();
				selUseList(3);
				$('#search_aprv_input').val('');
				$('#search_aprv_input').html('');
			})
			.on('click', '#history .month3', function(e) {
				e.preventDefault();
				selUseList(4);
				$('#search_aprv_input').val('');
				$('#search_aprv_input').html('');
			})
			.on('click', '#history .aprv_search', function(e) {
				e.preventDefault();
				console.log('검색버튼 누름');
				selUseList(5);
			})
			.on('click', '#history .back', function(e) {
				e.preventDefault();

				$history.trigger('hide');
				$('#main').trigger('show', 500);
			})
			.on('change', '#history input.start_dt, #history input.end_dt', function() {
				var $input = $(this);
				var dt = $input.val();
				if($input.hasClass('start_dt')) {
					$history.find('input.start').val(dt.replace(/\-/gi, '.'));
				} else {
					$history.find('input.end').val(dt.replace(/\-/gi, '.'));
				}
				selUseList(2);
//				$history.find('form').submit();
			})
		;
	})
	.on('init', '#receipt', function(e) {
		e.stopPropagation();

		var $receipt = $(this);

		$(document)
			/*
			* 결제 내역에서 상세보기 진입시 호출
			* 애니메이션 컨트롤
			*/
			.on('show', '#receipt', function(e, delay) {
				console.log('receipt show');
				e.stopPropagation();

				var $receipt = $(this);
				clearTimeout($receipt.data('timeout'));
				$receipt.addClass('ready');

				if(typeof delay === 'undefined') {
					delay = 50;
				}
				$receipt.data('timeout', setTimeout(function() {
					$receipt.css({zIndex:zIndex++}).addClass('show');

					//매장 이미지 조절
					var $storeImage = $receipt.find('.store-image');
					var $storeImageImg = $storeImage.find('img');
					$storeImageImg.on('load', function(e) {
						$storeImageImg.css({marginLeft:-($storeImageImg.outerWidth()-$storeImage.outerWidth())/2});
						$storeImage.addClass('ready');
					});
					$storeImageImg.attr('src', $storeImageImg.data('src'));
				}, delay));
			})
			/*
			* 결제 내역에서 상세보기 종료시 호출
			* 애니메이션 컨트롤
			*/
			.on('hide', '#receipt', function(e) {
				console.log('receipt hide');
				e.stopPropagation();

				var $receipt = $(this);
				clearTimeout($receipt.data('timeout'));
				$receipt.removeClass('show');
				$receipt.data('timeout', setTimeout(function() {
					$receipt.removeClass('ready');
				}, 900));
			})
			/*
			* 상세보기 페이지에서 confirm 버튼 터치시 호출
			* 상세보기 페이지 종료
			* 애니메이션 컨트롤
			*/
			.on('click', '#receipt .confirm_left', function(e) {
				console.log('receipt confirm_left');
				e.preventDefault();
				$receipt.trigger('hide');
				if($receipt.data('target') == 'history') {
					$receipt.removeClass('history');
					$('#history').trigger('hideDetail');
				} else
					if($receipt.data('target') == 'stamp') {
					$('#main').trigger('show', 400);
					$('#stamp').trigger('hideDetail');
				} else if($receipt.data('target') == 'barcode') {
					$('#main').trigger('show', 400);
					$('#barcode').trigger('hideDetail');
				}
			})
			/*
			* 상세보기 페이지에서 cancel payment 버튼 터치시 작동
			* main.html에 있는 메소드 호출해서 취소요청 후 상세보기 페이지 종료
			* 애니메이션 컨트롤
			*/
			.on('click', '#receipt .confirm_right', function(e) {
				console.log('receipt confirm_right');
				e.preventDefault();
			})

	})
	.on('init', '#alert', function(e) {
		e.stopPropagation();

		var $alert = $(this);
		var alertCallback = null;

		$(document)
			/*
			* 알럿메세지 호출
			* $('#alert').trigger('show', {msg:message, callback:function() { }}); 메세지로 호출
			* 화면에 표시될 메세지는 message에 넣음(string)
			* 애니메이션 컨트롤
			*/
			.on('show', '#alert', function(e, param) {
				e.stopPropagation();

				alertCallback = null;

				if(typeof param['msg'] !== 'undefined') {
					$alert.find('.msg').html(param['msg']);
				}

				if(typeof param['callback'] === 'function') {
					alertCallback = param['callback'];
				}

				clearTimeout($alert.data('timeout'));
				$alert.addClass('ready').data('timeout', setTimeout(function() {
					$alert.addClass('show');
				}, 100));
			})
			/*
			* 알럿메세지 내 버튼 클릭시 호출
			* $('#alert').trigger('show', {msg:message, callback:function() { }}); 메세지로 호출
			* callback function 안에 들어있는 메소드가 이때 호출됨
			* 애니메이션 컨트롤
			*/
			.on('click', '#alert .confirm', function(e) {
				e.preventDefault();

				clearTimeout($alert.data('timeout'));
				$alert.removeClass('show').data('timeout', setTimeout(function() {
					$alert.removeClass('ready');
					if(alertCallback)
						alertCallback();
				}, 600));

			})
	});

  	//drawPopup
  	var drawPopup = function(popupText, popupBtnType,callbackFn){
  		if (document.getElementById("defaulfPop") != null){
  			var removeTarget = document.getElementById("defaulfPop");
			if (!('remove' in Element.prototype)) {
				removeTarget.parentNode.removeChild(removeTarget);
			}else {
				console.log("remove")
				removeTarget.remove(0);
			}
  		}
	    	var popupDrawTarget = document.getElementsByTagName("body")[0];
	    	var popupContainer = document.createElement("div");
	    	popupContainer.id = "defaulfPop";
	    	popupContainer.className = "popup_wrap";
	    	popupContainer.style.display = "block";
		var popupHtmlStr ="";
			popupHtmlStr+= '<div class="popup_content">'
				+'<div class="popup_default">'
					+'<div class="popup_default_inner">'
						+'<p class="popup_default_p"><span id="spanPopupText">'+popupText+'</span></p>'
					+'</div>';
			if (popupBtnType == 2){
				popupHtmlStr+='<div class="popup_default_button type02" onclick="closePopup(this);">'
					+'<div><span>cancel</span></div>'
					+'<div id="popupBtnConfirm"><span>Confirm</span></div>';
			}else {
				popupHtmlStr+='<div class="popup_default_button" onclick="closePopup(this);">'
					+'<div id="popupBtnConfirm"><span>Confirm</span></div>';
			}
			popupHtmlStr+='</div>'
				+'</div>'
			+'</div>';
		popupContainer.innerHTML = popupHtmlStr;
		popupDrawTarget.appendChild(popupContainer);
		if ( typeof callbackFn == "function"){
			document.getElementById("popupBtnConfirm").addEventListener("click",callbackFn);
		}
	}
	// closePopup
	var closePopup = function(target){
		var target_this = target.parentNode;
		while (target_this.className != "popup_wrap") {
			target_this = target_this.parentNode;
		}
		if (!('remove' in Element.prototype)) {
			target_this.parentNode.removeChild(target_this);
		}else {
			target_this.remove(0);
		}
		return;
	};

$(function() {
	windowWidth = $(window).outerWidth();

	$('#main').trigger('init');
	$('#history').trigger('init');
	$('#receipt').trigger('init');
	$('#payment').trigger('init');
	$('#alert').trigger('init');

	//setTimeout(function() {
	//	$('#paymentTimer').trigger('start');
	//}, 1000)
});
