var SERVICE_NAME = 'kr-platform-point-prod';
//var SERVER_URL = 'https://platform-function.echoss.co.kr'; // Live
var SERVER_URL = 'http://mdev.echoss.co.kr'; // Dev

// Save data memory
function setData(name, data)
{
	localStorage.setItem(SERVICE_NAME + '.' + name, data);
}

// Import data memory
function getData(name)
{
	var v = localStorage.getItem(SERVICE_NAME + '.' + name);
	return v;
}

// Check storage availability
function availableLocalStorage() {
 	var testKey = 'test';
	try {
		// Browser is not supported if storage is undefined.
		// When setitem QuotaExceededError occurs, it is set to private browsing
		localStorage.setItem(testKey, '1');
		localStorage.removeItem(testKey);
		return true;
	} catch (e) {
		return false;
	}
}

// Add , at every three digit
function numberWithCommas(s) {
    var parts=s.split(".");
    return parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",") + (parts[1] ? "." + parts[1] : "");
}

// Return current time in the format of yyyy-MM-dd
function getTimeStamp() {
	var d = new Date();
	var s =
		leadingZeros(d.getFullYear(), 4) + '-' +
		leadingZeros(d.getMonth() + 1, 2) + '-' +
		leadingZeros(d.getDate(), 2);

	return s;
}

// Fill the blank with 0
function leadingZeros(n, digits) {
	var zero = '';
	n = n.toString();

	if (n.length < digits) {
		for (i = 0; i < digits - n.length; i++) {
			zero += '0';
		}
	}

	return zero + n;
}
