var Base64 = {

    // private property
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
    // public method for encoding
    encode: function(input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
                this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    // public method for decoding
    decode: function(input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode: function(string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode: function(utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

};

// JSON
/*
 * This document is licensed as free software under the terms of the
 * MIT License: <a href="http://www.opensource.org/licenses/mit-license.php" title="http://www.opensource.org/licenses/mit-license.php">http://www.opensource.org/licenses/mit-license.php</a>
 *
 * Adapted by Rahul Singla.
 *
 * Brantley Harris wrote this plugin. It is based somewhat on the JSON.org
 * website's <a href="http://www.json.org/json2.js" title="http://www.json.org/json2.js">http://www.json.org/json2.js</a>, which proclaims:
 * "NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.", a sentiment that
 * I uphold.
 *
 * It is also influenced heavily by MochiKit's serializeJSON, which is
 * copyrighted 2005 by Bob Ippolito.
 */

/**
 * jQuery.JSON.encode( json-serializble ) Converts the given argument into a
 * JSON respresentation.
 *
 * If an object has a "toJSON" function, that will be used to get the
 * representation. Non-integer/string keys are skipped in the object, as are
 * keys that point to a function.
 *
 * json-serializble: The *thing* to be converted.
 */
jQuery.JSON = {
    encode: function(o) {
        if (typeof(JSON) == 'object' && JSON.stringify)
            return JSON.stringify(o);

        var type = typeof(o);

        if (o === null)
            return "null";

        if (type == "undefined")
            return undefined;

        if (type == "number" || type == "boolean")
            return o + "";

        if (type == "string")
            return this.quoteString(o);

        if (type == 'object') {
            if (typeof o.toJSON == "function")
                return this.encode(o.toJSON());

            if (o.constructor === Date) {
                var month = o.getUTCMonth() + 1;
                if (month < 10)
                    month = '0' + month;

                var day = o.getUTCDate();
                if (day < 10)
                    day = '0' + day;

                var year = o.getUTCFullYear();

                var hours = o.getUTCHours();
                if (hours < 10)
                    hours = '0' + hours;

                var minutes = o.getUTCMinutes();
                if (minutes < 10)
                    minutes = '0' + minutes;

                var seconds = o.getUTCSeconds();
                if (seconds < 10)
                    seconds = '0' + seconds;

                var milli = o.getUTCMilliseconds();
                if (milli < 100)
                    milli = '0' + milli;
                if (milli < 10)
                    milli = '0' + milli;

                return '"' + year + '-' + month + '-' + day + 'T' + hours + ':' + minutes + ':' + seconds + '.' + milli + 'Z"';
            }

            if (o.constructor === Array) {
                var ret = [];
                for (var i = 0; i < o.length; i++)
                    ret.push(this.encode(o[i]) || "null");

                return "[" + ret.join(",") + "]";
            }

            var pairs = [];
            for (var k in o) {
                var name;
                var type = typeof k;

                if (type == "number")
                    name = '"' + k + '"';
                else if (type == "string")
                    name = this.quoteString(k);
                else
                    continue; // skip non-string or number keys

                if (typeof o[k] == "function")
                    continue; // skip pairs where the value is a function.

                var val = this.encode(o[k]);

                pairs.push(name + ":" + val);
            }

            return "{" + pairs.join(", ") + "}";
        }
    },

    /**
     * jQuery.JSON.decode(src) Evaluates a given piece of json source.
     */
    decode: function(src) {
        if (typeof(JSON) == 'object' && JSON.parse)
            return JSON.parse(src);
        return eval("(" + src + ")");
    },

    /**
     * jQuery.JSON.decodeSecure(src) Evals JSON in a way that is *more* secure.
     */
    decodeSecure: function(src) {
        if (typeof(JSON) == 'object' && JSON.parse)
            return JSON.parse(src);

        var filtered = src;
        filtered = filtered.replace(/\\["\\\/bfnrtu]/g, '@');
        filtered = filtered
            .replace(
                /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,
                ']');
        filtered = filtered.replace(/(?:^|:|,)(?:\s*\[)+/g, '');

        if (/^[\],:{}\s]*$/.test(filtered))
            return eval("(" + src + ")");
        else
            throw new SyntaxError("Error parsing JSON, source is not valid.");
    },

    /**
     * jQuery.JSON.quoteString(string) Returns a string-repr of a string, escaping
     * quotes intelligently. Mostly a support function for JSON.encode.
     *
     * Examples: >>> jQuery.JSON.quoteString("apple") "apple"
     *
     * >>> jQuery.JSON.quoteString('"Where are we going?", she asked.') "\"Where
     * are we going?\", she asked."
     */
    quoteString: function(string) {
        if (string.match(this._escapeable)) {
            return '"' + string.replace(this._escapeable, function(a) {
                var c = this._meta[a];
                if (typeof c === 'string')
                    return c;
                c = a.charCodeAt();
                return '\\u00' + Math.floor(c / 16).toString(16) + (c % 16).toString(16);
            }) + '"';
        }
        return '"' + string + '"';
    },

    _escapeable: /["\\\x00-\x1f\x7f-\x9f]/g,

    _meta: {
        '\b': '\\b',
        '\t': '\\t',
        '\n': '\\n',
        '\f': '\\f',
        '\r': '\\r',
        '"': '\\"',
        '\\': '\\\\'
    }
};
/**
 * JSON 데이터를 String으로 변환한다.
 **/
function jsonToString2(jsonObject) {
    var jsonText = JSON.stringify(jsonObject);
    jsonText = jsonText.replace(/\\"/g, "\"").replace(/\\\\/g, "\\").replace(/:"\[/g, ":[").replace(/\}\]"\}/g, "}]}");

    return jsonText;
}

function jsonToString(arg) {
    var rtStr = "";
    var flagStart = true;

    if (typeof(arg) == "object") {
        if (typeof(arg.length) == "number") {
            rtStr = "[";
            for (name in arg) {
                if (flagStart) {
                    flagStart = false;
                } else {
                    rtStr = rtStr + ","
                }
                rtStr = rtStr + jsonToString(arg[name]);
            }
            rtStr = rtStr + "]";
        } else {
            rtStr = "{";
            for (name in arg) {
                if (flagStart) {
                    flagStart = false;
                } else {
                    rtStr = rtStr + ","
                }
                rtStr = rtStr + '"' + name + '":';
                rtStr = rtStr + jsonToString(arg[name]);
            }
            rtStr = rtStr + "}";
        }
    } else {
        return '"' + arg + '"';
    }
    return rtStr;
}



/**
 * Form 데이터를 JSON으로 변환한다.
 **/
function toJson(trxCd, formObj, callBack) {
    var params = [];
    params[0] = {
        name: "function",
        value: trxCd
    };
    params[1] = {
        name: "callBack",
        value: callBack
    };

    if (formObj.elements != null && formObj.elements != undefined && formObj.elements.length != null && formObj.elements.length != undefined) {
        for (var i = 2; i < formObj.elements.length + 2; i++) {
            var obj = formObj.elements[i - 2];

            if (obj.type == "text" || obj.type == "hidden" || obj.type == "select-one") {
                if (obj.value != '') {
                    obj.value = replaceAll(obj.value, ".", "");
                }
                params[i] = {
                    name: obj.id,
                    value: obj.value
                };
            }
        }
    }
    return params;
}

/**
 * 문장에 들어간 문자 변환
 * ex ) targetString="요즘에 한 옛날에" str1="요즘에" str2="옛날에" return="옛날에 한 옛날에"
 */
function replaceAll(targetString, oldStr, newStr) {
    return targetString.split(oldStr).join(newStr);

    //
    //	var temp_str = this.trim( targetString );
    //
    //	if (temp_str != "" && oldStr != newStr)
    //	{
    //		var start = 0;
    //		do
    //		{
    //			start = temp_str.indexOf(oldStr, start);
    //			if(start == -1)
    //				break;
    //			temp_str = temp_str.replace(start, oldStr, newStr);
    //			start += newStr.length;
    //		} while(start > -1);
    //	}
    //	return temp_str;
}

/**
 * 공백을 제거 한다.(데이터의 앞자리에 들어간 공백만 제거)
 */
function trim(stringToTrim) {
    return stringToTrim.replace(/(^\s*)|(\s*$)|($\s*)/g, "");
}

/**
 * HTML 특수문자를 변환 한다.
 */
function htmlChars(htmlToChars) {
    var str = ((htmlToChars.replace('&', '&amp;')).replace('"', '&quot;')).replace('\'', '&#39;');
    return (str.replace('<', '&lt;')).replace('>', '&gt;');
}

function charsHtml(charsToHtml) {
    var str = ((charsToHtml.replace('&amp;', '&')).replace('&quot;', '"')).replace('&#39;', '\'');
    return (str.replace('&lt;', '<')).replace('&gt;', '>');
}

/**
 * Input Hidden을 생성한다.
 */
function addHiddenInput(f, n, v) {
	if (!f.elements[n]) {
        var i = document.createElement("input");
        i.type = "hidden";
        i.id = n;
        i.name = n;
        i.value = v;
        f.insertBefore(i, null);
    } else {
        var i = document.getElementById(n);
        i.id = n;
        i.name = n;
        i.value = v;
    }
}

/**
 * Form Object를 생성한다.
 */
function createForm(n) {
    if (document.getElementById(n) != null) {
        return document.getElementById(n);
    }

    var f = document.createElement("form");
    f.name = n;
    f.id = n;

    document.body.insertBefore(f, null);

    return f;
}

/**
 * 화면 메뉴페이지 이동
 * tabNo
 */
function callSubTab(tabNo) {
    var frmNm = "_tempAppFrm";
    createForm(frmNm);

    var frmObj = document.getElementById(frmNm);
    frmObj.action = "manager://requestPage=" + tabNo;
    frmObj.submit();
}

/**
 * Form 없는 서버 통신
 * trxCd
 * callBack
 */
function callApp(url, callBack) {
    var frmNm = "_tempAppFrm";
    createForm(frmNm);
    callAppForm(url, frmNm, callBack);
}


/**
 * Form의 값을 가지고 서버와 통신
 * trxCd
 * frmObj
 * callBack
 */
var times = 0;

function callAppForm(url, frmStr, callBack, callBackFailed) {
	if (frmStr == null) {
		frmStr = 'callAppForm';
		createForm(frmStr);
	}
    var frmObj = document.getElementById(frmStr);
    addHiddenInput(frmObj, "url" ,url);
    addHiddenInput(frmObj, "callBack" ,callBack);
    addHiddenInput(frmObj, "times", times++);	// 동일한 값으로 재전송시 구분을 위함
    if (callBackFailed != undefined) {
    	addHiddenInput(frmObj, "callBackFailed", callBackFailed);
    }

    frmObj.action = "manager://requestUrl";
    frmObj.submit();
}

function callAppFormNotCloseLoading_iphone(url, frmStr, callBack) {
    var frmObj = document.getElementById(frmStr);
    addHiddenInput(frmObj, "url" ,url);
    addHiddenInput(frmObj, "callBack" ,callBack);
    frmObj.action = "manager://requestUrl";
    var text = '';
    for (var i = 0; i < frmObj.elements.length; i++) {
        if (frmObj.elements[i].type == 'text' || frmObj.elements[i].type == 'textarea' || frmObj.elements[i].type == 'password' || frmObj.elements[i].type == 'email' || frmObj.elements[i].type == 'hidden' || frmObj.elements[i].type == 'select-one' || frmObj.elements[i].type == 'tel') {
            if (i != 0)
                text = text + "&";

            text = text + frmObj.elements[i].name + "=" + encodeURIComponent(frmObj.elements[i].value);
        }
    }
    location.href = frmObj.action + '?' + text;
}


function callAppFormNotCloseLoading(url, frmStr, callBack) {

    var ua = "" + navigator.userAgent;

    if (ua.toUpperCase().indexOf('IPHONE') != -1 || ua.toUpperCase().indexOf('IPAD') != -1) {
        callAppFormNotCloseLoading_iphone(url, frmStr, callBack);
        return;
    }

    var frmObj = document.getElementById(frmStr);
    frmObj.action = "manager://requestUrl";
    addHiddenInput(frmObj, "url" ,url);
    addHiddenInput(frmObj, "callBack" ,callBack);
    frmObj.submit();
}


function callAppFormNoLoading_iphone(url, frmStr, callBack) {
    var frmObj = document.getElementById(frmStr);
    addHiddenInput(frmObj, "url" ,url);
    addHiddenInput(frmObj, "callBack" ,callBack);
    frmObj.action = "manager://requestUrl";

    var text = '';
    for (var i = 0; i < frmObj.elements.length; i++) {
        if (frmObj.elements[i].type == 'text' || frmObj.elements[i].type == 'textarea' || frmObj.elements[i].type == 'password' || frmObj.elements[i].type == 'email' || frmObj.elements[i].type == 'hidden' || frmObj.elements[i].type == 'select-one' || frmObj.elements[i].type == 'tel') {
            if (i != 0)
                text = text + "&";

            text = text + frmObj.elements[i].name + "=" + encodeURIComponent(frmObj.elements[i].value);
        }
    }
    location.href = frmObj.action + '?' + text;
}

function callAppFormNoLoading(url, frmStr, callBack) {

    var ua = "" + navigator.userAgent;

    if (ua.toUpperCase().indexOf('IPHONE') != -1 || ua.toUpperCase().indexOf('IPAD') != -1) {
        callAppFormNoLoading_iphone(url, frmStr, callBack);
        return;
    }

    var frmObj = document.getElementById(frmStr);
    addHiddenInput(frmObj, "url" ,url);
    addHiddenInput(frmObj, "callBack" ,callBack);
    frmObj.action = "manager://requestUrl";
    frmObj.submit();
}

function startLoading(callback) {
    location.href = "manager://startLoading?" + callback;
}

function closeLoading(callback) {
    location.href = "manager://closeLoading?" + callback;
}

function callInputDialog(input_title, input_text, callBack) {
    location.href = "manager://movePage?dialog," + input_title + "," + input_text + "," + callBack;

}

// '-'로 구분된 listdata를 넣으면 선택팝업창이 뜨고, 선택된 텍스트를 콜백해 주는 함수.
function callSelectDialog(title, listdata, callBack) {
    location.href = "manager://movePage?selectdialog," + title + "," + listdata + "," + callBack;

}

function callConfirmDialog(title, message, callBack) {
    location.href = "manager://movePage?confirm," + title + "," + message + "," + callBack;

}

function callSms(address, message, callBack) {
    location.href = "manager://movePage?sendsms," + message + "&" + address + "&" + callBack;

}

function getToday() {
    var now = new Date();
    var today = "";
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var day = now.getDate();

    if (month < 10)
        month = "0" + month;
    if (day < 10)
        day = "0" + day;

    today = year + "" + month + "" + day;
    return today;
}

function getTodayDtTmStr() {
    var now = new Date();
    var today = "";
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var day = now.getDate();

    if (month < 10)
        month = "0" + month;
    if (day < 10)
        day = "0" + day;

    var hh =



        today = year + "." + month + "." + day + " " + now.getHours() + ":" + now.getMinutes() + ":" + now.getSeconds();
    return today;
}

function getDateTimeString(dateStr) {
    var dateString = "";
    var year = dateStr.substr(0, 4);
    var month = dateStr.substr(4, 2);
    var day = dateStr.substr(6, 2);

    var hh = dateStr.substr(8, 2);
    var mm = dateStr.substr(10, 2);
    var ss = dateStr.substr(12, 2);

    return year + "." + month + "." + day + " " + hh + ":" + mm;
}

function getDateStringWithDelim(date, delim) {
    var dateString = "";
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    var day = date.getDate();

    if (month < 10)
        month = "0" + month;
    if (day < 10)
        day = "0" + day;

    dateString = year + delim + month + delim + day;
    return dateString;
}

function dateStringWithDelim(dateStr, delim) {
    var dateString = "";
    var year = dateStr.substr(0, 4);
    var month = dateStr.substr(4, 2);
    var day = dateStr.substr(6, 2);

    dateString = year + delim + month + delim + day;
    return dateString;
}

function getTodayFormatted(delim) {
    var now = new Date();
    var today = "";
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var day = now.getDate();

    if (month < 10)
        month = "0" + month;
    if (day < 10)
        day = "0" + day;

    today = year + delim + month + delim + day;
    return today;
}


//세자리씩 , 넣기

function curFormat(obj) {

    // 여기서 부터 3자리마다 콤마를 찍어 준다.

    var txtNumber;



    if (obj == '[object]')
        txtNumber = obj.value;

    else

        txtNumber = obj;


    txtNumber = String(txtNumber);


    if (isNaN(filterNum(txtNumber))) {

        if (obj == '[object]')
            obj.value = "";



        return;

    }



    var rxSplit = new RegExp('([0-9])([0-9][0-9][0-9][,.])');

    var arrNumber = txtNumber.split('.');

    var result;

    arrNumber[0] += '.';




    do

    {

        arrNumber[0] = arrNumber[0].replace(rxSplit, '$1,$2');

    } while (rxSplit.test(arrNumber[0]));



    if (arrNumber.length > 1)

        result = arrNumber.join('');
    else

        result = arrNumber[0].split('.')[0];


    if (obj == '[object]')
        obj.value = result;


    return result;


}



//,없애기
function filterNum(str) {
    var re = /^\$|,/g;
    var str = String(str);
    return str.replace(re, "");
}

// 데이터 메모리 저장
function putData(name, putData, callback) {
    location.href = "manager://putData?" + name + "&" + putData + "&" + callback;
}

// 여러 데이터 메모리 저장
function putNData(json, callback) {
    location.href = "manager://putNData?" + json + "&" + callback;
}

//데이터 메모리에서 읽어오기
function getData(name, callback) {
    location.href = "manager://getData?" + name + "&" + callback;
}

//데이터 파일 저장
function saveData(name, putData, callback) {
    var encoded_data = encodeURIComponent(putData);
    location.href = "manager://saveData?" + name + "&" + encoded_data + "&" + callback;
}

//데이터 파일 저장
function saveStampData(name, putData, callback) {
    var encoded_data = encodeURIComponent(putData);
    location.href = "manager://saveStampData?" + name + "&" + encoded_data + "&" + callback;
}

//여러 데이터 파일 저장
function saveNData(json, callback) {
    var encoded_json = encodeURIComponent(json);
    location.href = "manager://saveNData?" + encoded_json + "&" + callback;
}

//데이터 파일에서 읽어오기
function loadData(name, callback) {
    location.href = "manager://loadData?" + name + "&" + callback;
}

//데이터 메모리에서 읽어오기
function getPhoneKey(callback) {
    location.href = "manager://getPhoneKey?" + callback;
}

function getLocation(callback) {
    location.href = "manager://getLocation?" + callback;
}

function getMyPhoneNum(callback) {
    location.href = "manager://getMyPhoneNum?" + callback;
}

function showNext(url, direction) {
    location.href = "manager://shownext?" + url + "&" + direction;
}

function showRoot(url) {
    location.href = "manager://showroot?" + url;
}

function showRemote(url, frmStr) {
    var frmObj = document.getElementById(frmStr);

    frmObj.action = "manager://showremote";

    var text = '';
    for (var i = 0; i < frmObj.elements.length; i++) {
        if (frmObj.elements[i].type == 'text' || frmObj.elements[i].type == 'textarea' || frmObj.elements[i].type == 'password' || frmObj.elements[i].type == 'email' || frmObj.elements[i].type == 'hidden' || frmObj.elements[i].type == 'select-one' || frmObj.elements[i].type == 'tel') {
            if (i != 0)
                text = text + "&";

            text = text + frmObj.elements[i].name + "=" + encodeURIComponent(frmObj.elements[i].value);
        }
    }
    location.href = frmObj.action + '?' + url + '?' + text;
}

var next_url = "";
var next_direction = "";

function showNextWithParam(url, param_name, param_value, direction) {
    next_url = url;
    next_direction = direction;
    putData(param_name, param_value, 'callbackShowNextWithParam');
}

function callbackShowNextWithParam(res) {
    var url = next_url;
    var direction = next_direction;
    next_url = "";
    next_direction = "";
    showNext(url, direction);
}

function showPrev(callback) {
    location.href = "manager://showprev?" + callback;
}

function showRight(page) {
    location.href = "manager://showright?" + page;
}

var is_direct_back = false;

function onPrev() {
    showPrev();
}

function showNextForBanner(url, direction) {
    location.href = "manager://showNextForBanner?" + url + "&" + direction;
}

var next_bnr_url = "";
var next_bnr_direction = "";

function showNextForBannerWithParam(url, param_name, param_value, direction) {
    next_bnr_url = url;
    next_bnr_direction = direction;
    putData(param_name, param_value, 'callbackShowNextForBannerWithParam');
}

function callbackShowNextForBannerWithParam(res) {
    var url = next_bnr_url;
    var direction = next_bnr_direction;
    showNextForBanner(url, direction);
}

function takePicture(callback) {
    location.href = "manager://takePicture?" + callback;
}

function getPicture(callback) {
    location.href = "manager://getPicture?" + callback;
}

function getCurrentLocation(callback) {
    location.href = "manager://getCurrentLocation?" + callback;
}

function getCurrentLocationWithException(callback) {
    location.href = "manager://getCurrentLocationWithException?" + callback;
}


function showMap(shopDetailResult) {
    //location.href="manager://showMap?"+ name + "&" + lati + "&" + longi + "&" + callback;
    //showNext("D01_03.html?"+brNm + "," +addr + "," +tel + "," +tel0507 + "," + lati + "," + longi+ "," + brCd, "right");
    showNextWithParam('map_view.html', 'param_map_view', shopDetailResult, 'right');
}

function getLocationByMap(callback) {
    location.href = "manager://getLocationByMap?" + callback;
}

function isFacebookLoggedin(callback) {
    location.href = "manager://isFacebookLoggedin?" + callback;
}

function getFacebookToken(callback) {
    location.href = "manager://getFacebookToken?" + callback;
}

function getFacebookID(callback) {
    location.href = "manager://getFacebookID?" + callback;
}

function getTwitterToken(callback) {
    location.href = "manager://getTwitterToken?" + callback;
}

function isTwitterLoggedin(callback) {
    location.href = "manager://isTwitterLoggedin?" + callback;
}

function facebookLogin(callback) {
    location.href = "manager://facebookLogin?" + callback;
}

function facebookLogout(callback) {
    location.href = "manager://facebookLogout?" + callback;
}

function facebookPost(name, caption, message, desc, imgUrl, link, callback) {
    location.href = "manager://facebookPost?" + name + "&" + caption + "&" + message + "&" + desc + "&" + imgUrl + "&" + link + "&" + callback;
}

function twitterLogin(callback) {
    location.href = "manager://twitterLogin?" + callback;
}

function twitterLogout(callback) {
    location.href = "manager://twitterLogout?" + callback;
}

function twitterPost(message, callback) {
    location.href = "manager://twitterPost?" + message + "&" + callback;
}

function facebookRequest(graph, callback) {
    location.href = "manager://facebookRequest?" + graph + "&" + callback;
}

function twitterRequest(callback) {
    location.href = "manager://twitterRequest?" + callback;
}

function me2dayLogin(callback) {
    location.href = "manager://me2dayLogin?" + callback;
}

function me2dayLogout(callback) {
    location.href = "manager://me2dayLogout?" + callback;
}

function me2dayPost(message, callback) {
    location.href = "manager://me2dayPost?" + message + "&" + callback;
}

function getLocationByMapWithName(callback) {
    location.href = "manager://getLocationByMapWithName?" + callback;
}

function searchLocation(keyword, callback) {
    location.href = "manager://searchLocation?" + keyword + "&" + callback;
}

function showWebView(pageUrl) {
    location.href = "manager://showWebView?" + pageUrl;
}

function closeApp() {
    location.href = "manager://closeApp";
}

$(document).ready(function() {
    // history back
    $("header .btn_prev").bind("click", function() {
        onPrev();
        //		showPrev('');
    });
    $(".info_top .btn_back").bind("click", function() {
        onPrev();
        //		showPrev('');
    });
    // refresh
    $("header .btn_refresh").bind("click", function() {
        startLoading('callback_RefreshStart');
    });
    // search
    $("header .btn_search").bind("click", function() {
        goNewsSearch();
    });
    //---
    // popup
    $.extend({
        popView: function(idObj) {
            var bw = $(window).width();
            if ($(window).height() <= 499) {
                var bh = 500;
            } else {
                var bh = $(window).height();
            }
            $("body").prepend("<div id='dimmed'></div>");
            $("#dimmed").css({
                "width": bw + "px",
                "height": bh + "px"
            });
            window.scrollTo(0, 0);
            $(idObj).show();
            $('.wrap').hide();
        },
        popClose: function() {
            $("#dimmed").remove();
            $(".popup").hide();
            $('.wrap').show();
        }
    });
    $(".popup .btn_close").click(function() {
        $.popClose();
    });
    //---
    $("input").keypress(function(e) {
        if (e.keyCode == 13)
            return false;
    });
    // header fix
    $("input").bind("click", function() {
        //        $(".header").scrollTo(0, 0);
    });
    /*
    var top = $('#comment').offset().top - parseFloat($('#comment').css('marginTop').replace(/auto/, 0));
    $(window).scroll(function (event) {
        // what the y position of the scroll is
        var y = $(this).scrollTop();

        // whether that's below the form
        if (y >= top) {
            // if so, ad the fixed class
            $('#comment').addClass('fixed');
        } else {
            // otherwise remove it
            $('#comment').removeClass('fixed');
        }
    });
    */
});

String.prototype.URLEncode = function URLEncode() {
    var SAFECHARS = "0123456789" + // Numeric
        "ABCDEFGHIJKLMNOPQRSTUVWXYZ" + // Alphabetic
        "abcdefghijklmnopqrstuvwxyz" +
        "-_.!~*'()"; // RFC2396 Mark characters
    var HEX = "0123456789ABCDEF";
    var plaintext = this;
    var encoded = "";
    for (var i = 0; i < plaintext.length; i++) {
        var ch = plaintext.charAt(i);
        if (ch == " ") {
            encoded += "+"; // x-www-urlencoded, rather than %20
        } else if (SAFECHARS.indexOf(ch) != -1) {
            encoded += ch;
        } else {
            var charCode = ch.charCodeAt(0);
            if (charCode > 255) {
                alert("Unicode Character '" + ch + "' cannot be encoded using standard URL encoding.\n" +
                    "(URL encoding only supports 8-bit characters.)\n" +
                    "A space (+) will be substituted.");
                encoded += "+";
            } else {
                encoded += "%";
                encoded += HEX.charAt((charCode >> 4) & 0xF);
                encoded += HEX.charAt(charCode & 0xF);
            }
        }
    } // for
    return encoded;
};




String.prototype.URLDecode = function URLDecode() {
    var HEXCHARS = "0123456789ABCDEFabcdef";
    var encoded = this;
    var plaintext = "";
    var i = 0;
    while (i < encoded.length) {
        var ch = encoded.charAt(i);
        if (ch == "+") {
            plaintext += " ";
            i++;
        } else if (ch == "%") {
            if (i < (encoded.length - 2) && HEXCHARS.indexOf(encoded.charAt(i + 1)) != -1 && HEXCHARS.indexOf(encoded.charAt(i + 2)) != -1) {
                plaintext += unescape(encoded.substr(i, 3));
                i += 3;
            } else {
                alert('Bad escape combination near ...' + encoded.substr(i));
                plaintext += "%[ERROR]";
                i++;
            }
        } else {
            plaintext += ch;
            i++;
        }
    } // while
    return plaintext;
};

function parseJSON(json) {
    //	var res = replaceAll(json, "+", " ");
    var res = Base64.decode(json);

    var ua = "" + navigator.userAgent;

    if (ua.toUpperCase().indexOf('IPHONE') != -1 || ua.toUpperCase().indexOf('IPAD') != -1) {
        res = decodeURIComponent(res);
        res = replaceAll(res, '+', ' ');
    } else
        res = decodeURL(res);

    res = replaceAll(res, '\n', '\\n');
    res = replaceAll(res, '\r', '\\r');
    res = replaceAll(res, '\t', '\\t');

    return jsonObject = JSON.parse(res);
}

function parseJSON2(json) {
    alert(json);

    var res = Base64.decode(json);
    alert(res);
    res = decodeURIComponent(res);
    alert(res);
    res = replaceAll(res, '\n', '\\n');
    alert(res);
    res = replaceAll(res, '\r', '\\r');
    alert(res);
    res = replaceAll(res, '\t', '\\t');
    alert(res);

    return jsonObject = JSON.parse(res);
}

function encodeJSON(json_obj) {
    return Base64.encode(encodeURIComponent(jQuery.JSON.encode(json_obj)));
}

function decodeJSON(json_str) {
    if (json_str == null || json_str == "")
        return null;

    var base64_decoded = Base64.decode(json_str);

    var url_decoded = "";
    var ua = "" + navigator.userAgent;
    if (ua.toUpperCase().indexOf('IPHONE') != -1 || ua.toUpperCase().indexOf('IPAD') != -1) {
        url_decoded = decodeURIComponent(base64_decoded);
        url_decoded = replaceAll(url_decoded, '+', ' ');
    } else
        url_decoded = decodeURL(base64_decoded);

    url_decoded = replaceAll(url_decoded, '\n', '\\n');
    url_decoded = replaceAll(url_decoded, '\r', '\\r');
    url_decoded = replaceAll(url_decoded, '\t', '\\t');
    return json_obj = jQuery.JSON.decode(url_decoded);
}

//날짜 혹은 시간 변환 하기
function dateTimeConvert(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(0, 4);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
        return str1 + "년" + str2 + "월" + str3 + "일";
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);

        if (str1 >= 12) {
            if (str1 == '12')
                str1 = "오후 " + str1;
            else
                str1 = "오후 " + (str1 - 12);
        } else {
            str1 = "오전 " + str1;
        }

        return str1 + "시" + str2 + "분" + str3 + "초";
    }
}

function dateTimeConvertForCoupon(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(0, 4);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
        return str1 + "<br />" + str2 + "월" + str3 + "일";
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);

        if (str1 >= 12) {
            if (str1 == '12')
                str1 = "오후 " + str1;
            else
                str1 = "오후 " + (str1 - 12);
        } else {
            str1 = "오전 " + str1;
        }

        return str1 + "시" + str2 + "분" + str3 + "초";
    }
}

function dateTimeConvertForCoupon2(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(0, 4);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
        return str1 + "년 " + str2 + "월 " + str3 + "일";
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);

        if (str1 >= 12) {
            if (str1 == '12')
                str1 = "오후 " + str1;
            else
                str1 = "오후 " + (str1 - 12);
        } else {
            str1 = "오전 " + str1;
        }

        return str1 + "시 " + str2 + "분";
    }
}

function dateTimeConvertNoSecond(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(2, 2);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
        return str1 + "년" + str2 + "월" + str3 + "일";
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);

        if (str1 >= 12) {
            if (str1 == '12')
                str1 = "오후 " + str1;
            else
                str1 = "오후 " + (str1 - 12);
        } else {
            str1 = "오전 " + str1;
        }

        return str1 + "시" + str2 + "분";
    }
}

function dateTimeConvert2(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(0, 4);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);
    }

    return str1 + delim + str2 + delim + str3;
}

function dateTimeConvert3(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(2, 2);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
        return str1 + delim + str2 + delim + str3;
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);
        return str1 + delim + str2;
    }
}

function dateTimeConvert4(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(0, 4);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
        return str2 + "월" + str3 + "일";
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);

        if (str1 >= 12) {
            if (str1 == '12')
                str1 = "PM " + str1;
            else
                str1 = "PM " + (str1 - 12);
        } else {
            str1 = "AM " + str1;
        }

        return str1 + ":" + str2;
    }
}

function dateTimeConvert5(dateStr, timeStr) {
    var dateString = dateStr.substr(0, 4) + "-" + dateStr.substr(4, 2) + "-" + dateStr.substr(6, 2) + " " + timeStr.substr(0, 2) + ":" + timeStr.substr(2, 2) + ":" + timeStr.substr(4, 2);
    var reggie = /(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})/;
    var dateArray = reggie.exec(dateString);
    var dateObject = new Date(
        (+dateArray[1]), (+dateArray[2]) - 1, // Careful, month starts at 0!
        (+dateArray[3]), (+dateArray[4]), (+dateArray[5]), (+dateArray[6])
    );
    var curDateT = new Date();
    var diffSeconds = parseInt((curDateT - dateObject) / 1000);
    if (diffSeconds < 60)
        return diffSeconds + "초전";
    var diffMinutes = parseInt(diffSeconds / 60);
    if (diffMinutes < 60)
        return diffMinutes + "분전";
    var diffHours = parseInt(diffMinutes / 60);
    if (diffHours < 24)
        return diffHours + "시간전";
    var diffDays = parseInt(diffHours / 24);
    if (diffDays < 30)
        return diffDays + "일전";
    var diffMonths = (curDateT.getFullYear() - dateObject.getFullYear()) * 12 + curDateT.getMonth() - dateObject.getMonth();
    return diffMonths + "달전";
}

function dateTimeConvert5ToHtml(dateStr, timeStr) {
    var dateString = dateStr.substr(0, 4) + "-" + dateStr.substr(4, 2) + "-" + dateStr.substr(6, 2) + " " + timeStr.substr(0, 2) + ":" + timeStr.substr(2, 2) + ":" + timeStr.substr(4, 2);
    var reggie = /(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})/;
    var dateArray = reggie.exec(dateString);
    var dateObject = new Date(
        (+dateArray[1]), (+dateArray[2]) - 1, // Careful, month starts at 0!
        (+dateArray[3]), (+dateArray[4]), (+dateArray[5]), (+dateArray[6])
    );
    var curDateT = new Date();
    var diffSeconds = parseInt((curDateT - dateObject) / 1000);
    if (diffSeconds < 60)
        return "<p class='ago second'>" + diffSeconds + "초전</p>";
    var diffMinutes = parseInt(diffSeconds / 60);
    if (diffMinutes < 60)
        return "<p class='ago minute'>" + diffMinutes + "분전</p>";
    var diffHours = parseInt(diffMinutes / 60);
    if (diffHours < 24)
        return "<p class='ago time'>" + diffHours + "시간전</p>";
    var diffDays = parseInt(diffHours / 24);
    if (diffDays < 30)
        return "<p class='ago day'>" + diffDays + "일전</p>";
    var diffMonths = (curDateT.getFullYear() - dateObject.getFullYear()) * 12 + curDateT.getMonth() - dateObject.getMonth();
    return "<p class='ago month'>" + diffMonths + "달전</p>";
}

function getCurrentDate() {
    var d = new Date();

    var s =
        leadingZeros(d.getFullYear(), 4) + '-' +
        leadingZeros(d.getMonth() + 1, 2) + '-' +
        leadingZeros(d.getDate(), 2);

    return s;
}

function getMonthMM(index) {
    var d = new Date();
    d.setMonth(d.getMonth() + index);
    return leadingZeros(d.getMonth() + 1, 2);
}

function getCurrentDateNoFormat() {
    var d = new Date();

    var s =
        leadingZeros(d.getFullYear(), 4) +
        leadingZeros(d.getMonth() + 1, 2) +
        leadingZeros(d.getDate(), 2);

    return s;
}

function getTimeStamp() {
    var d = new Date();

    var s =
        leadingZeros(d.getFullYear(), 4) + '-' +
        leadingZeros(d.getMonth() + 1, 2) + '-' +
        leadingZeros(d.getDate(), 2) + ' ' +

        leadingZeros(d.getHours(), 2) + ':' +
        leadingZeros(d.getMinutes(), 2) + ':' +
        leadingZeros(d.getSeconds(), 2);

    return s;
}

function leadingZeros(n, digits) {
    var zero = '';
    n = n.toString();

    if (n.length < digits) {
        for (i = 0; i < digits - n.length; i++)
            zero += '0';
    }
    return zero + n;
}

function goBannerLink(row) {
    if (row.lnGbn == '0') {

    } else if (row.lnGbn == '1') {
        // 매장상세
        //showNextWithParam('D02_.html', 'd02_param', row.brCd, 'right');
        showNextWithParam('shop_detail.html', 'param_shop_detail', row.brCd, 'right');

    } else if (row.lnGbn == '2') {
        // 웹뷰
        showWebView(row.webUrl, 'right');

    } else if (row.lnGbn == '3') {
        // 사파리
        window.open(row.webUrl, '_blank', '');


    } else if (row.lnGbn == '4') {
        // 게시물 링크
        //showNextWithParam('P05_04_02_01.html', 'p05_04_02_01_param', row.bbsSeqNo, 'right');
        showNextWithParam('notice_detail.html', 'param_notice_detail', row.bbsSeqNo, 'right');
    } else if (row.lnGbn == '5') {
        // 브랜드별리스트
        //showNextWithParam('List02.html', 'list02_param', row.brndCd, 'right');
        showNextWithParam('brand_menu.html', 'param_brand_menu', row.brndCd, 'right');

    } else if (row.lnGbn == '6') {
        // 지역별매장리스트
        var param = "";
        param = row.lati + "|" + row.longti;

        // 배너구분 - 1:포장메인,2:브랜드메인,3:포장카테고리별,4:배달카테고리별,5:브랜드카테고리별,6:포장지역별,7:배달지역별
        goMainBanner(jsonToString(row));

    } else if (row.lnGbn == '7') {
        // 테마상세
        var param = "";
        param = row.thmCd + "|" + row.thmNm;
        //showNextForBanner('List03.html?'+param, 'right');
        showNextForBanner('eat_today_detail.html?' + param, 'right');

    }
}

function goBannerLinkWithParam(row, lati, longi) {
    if (row.lnGbn == '0') {

    } else if (row.lnGbn == '1') {
        // 매장상세
        var param = "";
        param = param + row.brCd + "|" + lati + "|" + longi + "|banner";
        //showNextForBanner('D02_.html?'+param, 'right');
        showNextForBannerWithParam('shop_detail.html', 'param_shop_detail', param, 'right');

    } else if (row.lnGbn == '2') {
        // 웹뷰
        showWebView(row.webUrl, 'right');

    } else if (row.lnGbn == '3') {
        // 사파리
        callSafari(row.webUrl);


    } else if (row.lnGbn == '4') {
        // 게시물 링크
        var param = row.bbsSeqNo + "|banner";
        //showNextForBannerWithParam('P05_04_02_01.html', 'p05_04_02_01_param', row.bbsSeqNo, 'right');
        showNextForBannerWithParam('notice_detail.html', 'param_notice_detail', row.bbsSeqNo, 'right');
    } else if (row.lnGbn == '5') {
        // 브랜드별리스트
        var param = "";
        param = param + row.brndCd + "|" + row.brndNm + "|banner";
        //showNextForBannerWithParam('List02.html', 'list02_param', param, 'right');
        showNextForBannerWithParam('brand_menu.html', 'param_brand_menu', param, 'right');

    } else if (row.lnGbn == '6') {
        // 지역별매장리스트
        var param = "";
        param = row.lati + "|" + row.longti;

        // 배너구분 - 1:포장메인,2:브랜드메인,3:포장카테고리별,4:배달카테고리별,5:브랜드카테고리별,6:포장지역별,7:배달지역별
        goMainBanner(jsonToString(row));


    } else if (row.lnGbn == '7') {
        // 테마상세
        var param = "";
        param = row.thmCd + "|" + row.thmNm + "|banner";
        //showNextForBannerWithParam('List03.html', 'list03_param', param, 'right');
        showNextForBannerWithParam('eat_today_detail.html', 'param_eat_today_detail', param, 'right');

    } else if (row.lnGbn == '8') {
        // 카카오톡
        var kakao_link = "";
        var kakao_msg = encodeURIComponent("배달도 맛집으로 즐기자! 배달맛집 App 다운로드 ");
        kakao_link = "kakaolink://sendurl?msg=" + kakao_msg + "&url=http://goo.gl/AuyFT&appid=com.kakao.android.image&appver=2.0&appname=카카오톡";
        location.href = kakao_link;
    } else if (row.lnGbn == '9') {
        // D스탬프
        var param = "banner";
        showNextForBannerWithParam("stamp_zone.html", "param_stamp_zone", param, "right");
    }
}

function goMainBanner(jsonString) {
    location.href = "manager://goMainBanner?" + jsonString;
}

function callSafari(url) {
    location.href = "manager://callSafari?" + url;
}

function callSafariWithCallback(url, callback) {
    location.href = "manager://callSafariWithCallback?" + callback + "&" + url;
}

function goNavigate(param) {
    location.href = "manager://goNavigate?" + param;
}

function setLoginComplete(callback) {
    location.href = "manager://setLoginComplete?" + callback;
}

function setLogoutComplete(callback) {
    location.href = "manager://setLogoutComplete?" + callback;
}

function requestBilling(code, callback) {
    location.href = "manager://requestBilling?" + code + "&" + callback;
}


function callback_RefreshStart(res) {
    initLoad();
    closeLoading();
}


//이메일 체크
function checkMail(strMail) {
    /** 체크사항
      - @가 2개이상일 경우
      - .이 붙어서 나오는 경우
      -  @.나  .@이 존재하는 경우
      - 맨처음이.인 경우
      - @이전에 하나이상의 문자가 있어야 함
      - @가 하나있어야 함
      - Domain명에 .이 하나 이상 있어야 함
      - Domain명의 마지막 문자는 영문자 2~4개이어야 함 **/

    var check1 = /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/;

    var check2 = /^[a-zA-Z0-9\-\.\_]+\@[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,4})$/;

    if (!check1.test(strMail) && check2.test(strMail)) {
        return true;
    } else {
        return false;
    }
}

function check_newscontents(contents) {
    var temp = "";
    var temp_left = "";
    var temp_right = contents;
    var check = /[ㄱ-ㅎ|ㅏ-ㅣ|가-힣]/;
    while (temp_right.length > 0) {
        var begin = temp_right.indexOf('(');
        if (begin != -1) {
            temp_left += temp_right.substr(0, begin);
            temp_right = temp_right.substr(begin);

            var end = temp_right.indexOf(')', 0);
            if (end != -1) {
                var chk_str = temp_right.substr(0, end + 1);
                temp_right = temp_right.substr(end + 1);
                if (check.test(chk_str) == false)
                    temp_left += chk_str;
            } else {
                temp_left += temp_right;
                temp_right = "";
                break;
            }
        } else {
            temp_left += temp_right;
            temp_right = "";
        }
    }
    var idx = temp_left.indexOf("Read the article:");
    if (idx != -1) {
        temp = temp_left.substr(0, idx);
    } else {
        temp = temp_left;
    }
    temp = replaceAll(temp, '*', '');
    temp = replaceAll(temp, '\r\n', '<br />');
    temp = replaceAll(temp, '\n', '<br />');
    return temp;
}

if (typeof String.prototype.startsWith != 'function') {
    String.prototype.startsWith = function(str) {
        return this.indexOf(str) == 0;
    }
}

function getPhoneNum(phNo) {
    if (phNo.length < 9)
        return phNo;

    var arrFirst = ["02", "051", "053", "032", "062", "042", "052", "031", "033", "043", "041", "063", "061", "054", "055", "064", "0507", "010", "011", "016", "017", "018", "019", "070"];

    var strReturn = phNo;
    for (var i = 0; i < arrFirst.length; i++) {
        var firstLength = arrFirst[i].length;
        if (phNo.startsWith(arrFirst[i])) {
            // 국번 뒷부분을 자른다.
            var phNumber = phNo.substring(firstLength);
            var len = phNumber.length;

            // 국번 뒷부분 자릿수가 7인 경우와 8인경우에 대해 3자리-4자리, 4자리-4자리로 나눈다.
            if (len == 7) {
                strReturn = arrFirst[i] + "-" + phNumber.substring(0, 3) + "-" + phNumber.substring(3);
                break;
            } else if (len == 8) {
                strReturn = arrFirst[i] + "-" + phNumber.substring(0, 4) + "-" + phNumber.substring(4);
                break;
            } else {
                strReturn = arrFirst[i] + "-" + phNumber.substring(0);
            }
        }
    }

    return strReturn;

}

function URLEncode(org) {
    // The Javascript escape and unescape functions do not correspond
    // with what browsers actually do...
    var SAFECHARS = "0123456789" + // Numeric
        "ABCDEFGHIJKLMNOPQRSTUVWXYZ" + // Alphabetic
        "abcdefghijklmnopqrstuvwxyz" +
        "-_.!~*'()"; // RFC2396 Mark characters
    var HEX = "0123456789ABCDEF";

    var plaintext = org;
    var encoded = "";
    for (var i = 0; i < plaintext.length; i++) {
        var ch = plaintext.charAt(i);
        if (ch == " ") {
            encoded += "+"; // x-www-urlencoded, rather than %20
        } else if (SAFECHARS.indexOf(ch) != -1) {
            encoded += ch;
        } else {
            var charCode = ch.charCodeAt(0);
            if (charCode > 255) {
                alert("Unicode Character '" + ch + "' cannot be encoded using standard URL encoding.\n" +
                    "(URL encoding only supports 8-bit characters.)\n" +
                    "A space (+) will be substituted.");
                encoded += "+";
            } else {
                encoded += "%";
                encoded += HEX.charAt((charCode >> 4) & 0xF);
                encoded += HEX.charAt(charCode & 0xF);
            }
        }
    } // for

    return encoded;
}

function URLDecode(encoded) {
    // Replace + with ' '
    // Replace %xx with equivalent character
    // Put [ERROR] in output if %xx is invalid.
    var HEXCHARS = "0123456789ABCDEFabcdef";
    var plaintext = "";
    var i = 0;
    while (i < encoded.length) {
        var ch = encoded.charAt(i);
        if (ch == "+") {
            plaintext += " ";
            i++;
        } else if (ch == "%") {
            if (i < (encoded.length - 2) && HEXCHARS.indexOf(encoded.charAt(i + 1)) != -1 && HEXCHARS.indexOf(encoded.charAt(i + 2)) != -1) {
                plaintext += unescape(encoded.substr(i, 3));
                i += 3;
            } else {
                alert('Bad escape combination near ...' + encoded.substr(i));
                plaintext += "%[ERROR]";
                i++;
            }
        } else {
            plaintext += ch;
            i++;
        }
    } // while
    return plaintext;

}

function decodeURL(str) {
    var s0, i, j, s, ss, u, n, f;
    s0 = ""; // decoded str
    for (i = 0; i < str.length; i++) { // scan the source str
        s = str.charAt(i);
        if (s == "+") {
            s0 += " ";
        } // "+" should be changed to SP
        else {
            if (s != "%") {
                s0 += s;
            } // add an unescaped char
            else { // escape sequence decoding
                u = 0; // unicode of the character
                f = 1; // escape flag, zero means end of this sequence
                while (true) {
                    ss = ""; // local str to parse as int
                    for (j = 0; j < 2; j++) { // get two maximum hex characters for parse
                        sss = str.charAt(++i);
                        if (((sss >= "0") && (sss <= "9")) || ((sss >= "a") && (sss <= "f")) || ((sss >= "A") && (sss <= "F"))) {
                            ss += sss; // if hex, add the hex character
                        } else {
                            --i;
                            break;
                        } // not a hex char., exit the loop
                    }
                    n = parseInt(ss, 16); // parse the hex str as byte
                    if (n <= 0x7f) {
                        u = n;
                        f = 1;
                    } // single byte format
                    if ((n >= 0xc0) && (n <= 0xdf)) {
                        u = n & 0x1f;
                        f = 2;
                    } // double byte format
                    if ((n >= 0xe0) && (n <= 0xef)) {
                        u = n & 0x0f;
                        f = 3;
                    } // triple byte format
                    if ((n >= 0xf0) && (n <= 0xf7)) {
                        u = n & 0x07;
                        f = 4;
                    } // quaternary byte format (extended)
                    if ((n >= 0x80) && (n <= 0xbf)) {
                        u = (u << 6) + (n & 0x3f);
                        --f;
                    } // not a first, shift and add 6 lower bits
                    if (f <= 1) {
                        break;
                    } // end of the utf byte sequence
                    if (str.charAt(i + 1) == "%") {
                        i++;
                    } // test for the next shift byte
                    else {
                        break;
                    } // abnormal, format error
                }
                s0 += String.fromCharCode(u); // add the escaped character
            }
        }
    }
    return s0;

}

function toInt(data) {
    if (data == null || data == "" || data == "null")
        return 0;

    return parseInt(data, 10);
}

function toStr(data) {
    //return data.toString();
    return String(data);
}

function isAbnormalResolution(apVer) {
    //var apVer = navigator.appVersion;
    if (apVer.search("SHV-E210") > -1 ||
        apVer.search("SHV-E160") > -1)
    /*
	if(apVer.search("SHV-E210") > -1 ||
		apVer.search("XT910") > -1)
	*/
        return true;
    return false;
}

function getDateString(date) {
    if (date == null) {
        date = new Date();
    }
    var year = date.getFullYear(); //2013
    var month = date.getMonth();
    var day = date.getDate(); //4

    var yoil = date.getDay();

    var yoilStr = "";
    switch (yoil) {
        case 0:
            yoilStr = "일";
            break;
        case 1:
            yoilStr = "월";
            break;
        case 2:
            yoilStr = "화";
            break;
        case 3:
            yoilStr = "수";
            break;
        case 4:
            yoilStr = "목";
            break;
        case 5:
            yoilStr = "금";
            break;
        case 6:
            yoilStr = "토";
            break;
    }

    return year + "." + (month + 1) + "." + day + "(" + yoilStr + ")";

}

function toDate(dateStr) {
    var dateY = dateStr.substr(0, 4);
    var dateM = dateStr.substr(4, 2);
    var dateD = dateStr.substr(6, 2);
    var date = new Date(toInt(dateY), toInt(dateM) - 1, toInt(dateD));
    return date;
}


function getDateWithDayOfWeek(dateStr) {
    var dateY = dateStr.substr(0, 4);
    var dateM = dateStr.substr(4, 2);
    var dateD = dateStr.substr(6, 2);

    var date = new Date(toInt(dateY), toInt(dateM) - 1, toInt(dateD));
    return getDateString(date);
}

function getDateWithDayOfWeek2(year, month, day) {
    var date = new Date(year, month - 1, day);
    return getDateString(date);
}

function getDate(dateStr) {
    var dateY = dateStr.substr(0, 4);
    var dateM = dateStr.substr(4, 2);
    var dateD = dateStr.substr(6, 2);

    return dateY + "." + dateM + "." + dateD;
}

function getDaysOfDiffDate(startDateStr, endDateStr) {
    var startY = toInt(startDateStr.substr(0, 4));
    var startM = toInt(startDateStr.substr(4, 2));
    var startD = toInt(startDateStr.substr(6, 2));
    var endY = toInt(endDateStr.substr(0, 4));
    var endM = toInt(endDateStr.substr(4, 2));
    var endD = toInt(endDateStr.substr(6, 2));

    var startDate = new Date(startY, startM - 1, startD);
    var endDate = new Date(endY, endM - 1, endD);
    var diffTime = endDate.getTime() - startDate.getTime();
    return Math.floor(diffTime / (1000 * 60 * 60 * 24));
}

function getLeftDays(dateStr) {
    var endY = toInt(dateStr.substr(0, 4));
    var endM = toInt(dateStr.substr(4, 2));
    var endD = toInt(dateStr.substr(6, 2));
    var endDate = new Date(endY, endM - 1, endD, 23, 59, 59);
    var curDate = new Date();

    var diffTime = endDate.getTime() - curDate.getTime();
    return Math.floor(diffTime / (1000 * 60 * 60 * 24));
}

function dateToString(year, month, day) {
    var dateStr = "";
    dateStr += toStr(year);
    if (month < 10)
        dateStr += "0";
    dateStr += toStr(month);
    if (day < 10)
        dateStr += "0";
    dateStr += toStr(day);
    return dateStr;
}

function getTodayDateString() {
    var today = new Date();
    return dateToString(today.getFullYear(), today.getMonth() + 1, today.getDate());
}

function getYesterdayDateString() {
    var today = new Date();
    var yesterday = new Date(today.valueOf() - (24 * 60 * 60 * 1000));
    return dateToString(yesterday.getFullYear(), yesterday.getMonth() + 1, yesterday.getDate());
}

function getHiddenEmail(email) {
    var length = email.length;
    var hidden_email = "";
    if (length > 3) {
        hidden_email = email.substr(0, 3);
        var temp = email.substr(3);
        temp = temp.replace(/[A-Za-z0-9\@\.\_\-+]/g, "*");
        hidden_email += temp;
    } else
        hidden_email = email;
    return hidden_email;
}

function findString(target, keyword) {
    if (target.length < keyword.length)
        return false;

    if (new RegExp(keyword, "gi").test(target))
        return true;
    else
        return false;
}

function adjustFontSize(fontSize) {
    if (fontSize == "SMALLER") {
        $("body,th,td,p").css("font-size", "11px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "12px");
    } else if (fontSize == "SMALL") {
        $("body,th,td,p").css("font-size", "14px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "15px");
    } else if (fontSize == "NORMAL") {
        $("body,th,td,p").css("font-size", "17px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "18px");
    } else if (fontSize == "BIG") {
        $("body,th,td,p").css("font-size", "20px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "22px");
    } else if (fontSize == "BIGGER") {
        $("body,th,td,p").css("font-size", "23px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "25px");
    }
}

function adjustFontSize_NewsDetail(fontSize) {
    if (fontSize == "SMALLER") {
        $("body,th,td,p").css("font-size", "11px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "12px");
    } else if (fontSize == "SMALL") {
        $("body,th,td,p").css("font-size", "14px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "15px");
    } else if (fontSize == "NORMAL") {
        $("body,th,td,p").css("font-size", "17px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "18px");
    } else if (fontSize == "BIG") {
        $("body,th,td,p").css("font-size", "20px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "22px");
    } else if (fontSize == "BIGGER") {
        $("body,th,td,p").css("font-size", "23px");
        //		$(".wrap_view").css("font-size", "14px");
        $(".wrap_view").css("font-size", "25px");
    }
}

function new_TodayNews(set) {
    if (set) {
        if ($('#new_today').is(':visible') == false)
            $('#new_today').show();
    } else {
        if ($('#new_today').is(':visible'))
            $('#new_today').hide();
    }
}

function num_MyNews(count) {
    if (count != "" && count != "0") {
        $('#count_mynews').html(count);
        if ($('#count_mynews').is(':visible') == false)
            $('#count_mynews').show();
    } else {
        if ($('#count_mynews').is(':visible'))
            $('#count_mynews').hide();
    }
}

function new_More(set) {
    if (set) {
        if ($('#new_notice').is(':visible') == false)
            $('#new_notice').show();
    } else {
        if ($('#new_notice').is(':visible'))
            $('#new_notice').hide();
    }
}

function isReadTodayNews(read_date, today_empty) {
    if (today_empty == "Y")
        return true;

    if (read_date == '')
        return false;

    var today_date = getTodayDateString();
    if (read_date == today_date)
        return true;
    else
        return false;
}

function putReqParams(url, params, callback) {
    location.href = "manager://putReqParams?" + url + "," + params + "," + callback;

}

function showDetail(page, params) {
    location.href = "manager://showdetail?" + page + "&" + params;
}

function showBrandList(page, params) {
    location.href = "manager://showbrandlist?" + page + "&" + params;
}

function showStampHere() {
    location.href = "manager://showstamphere";
}

function showBranchList(page, params) {
    location.href = "manager://showbranchlist?" + page + "&" + params;
}

function showAgreement(page, params) {
    location.href = "manager://showagreement?" + page + "&" + params;
}

function agreementResult(agreementYn, params) {
    location.href = "manager://agreementResult?" + agreementYn + "&" + params;
}

function setStampType(useYn, params, callback) {
    location.href = "manager://setstamptype?" + useYn + "&" + params + "&" + callback;
}

function showSWS() {
    location.href = "manager://showsws";
}

function phoneCall(number) {
    location.href = "manager://phoneCall?" + number;
}

function showToast(msg, callback) {
    location.href = "manager://showtoast?" + msg + "&" + callback;
}

function startActivity(urlData, params) {
    location.href = "manager://startactivity?" + urlData + "&" + params;
}

function getParams(callback) {
    location.href = "manager://getparams?" + callback;
}

function showMsgPopup(msg) {
    $('html,body').scrollTop(0);
    $("#msg").html(msg);
    //	$("#msgPopup").show();

    $("#msgPopup").show();

}

function callBackNone(data) {}


function enableStamp(yn, callback) {
    location.href = "manager://enableStamp?" + yn + "&" + callback;
}

function getNetworkStatus(callback) {
    location.href = "manager://getNetworkStatus?" + callback;
}

function selectSort(initial, callback) {
    location.href = "manager://selectSort?" + initial + "&" + callback;
}

function isInstalled(appPackage, callback) {
    location.href = "manager://isInstalled?" + appPackage + "&" + callback;
}

function goApp(appPackage, appsType) {
    location.href = "manager://goApp?" + appPackage + "&" + appsType;
}

function goLink(linkTyp, linkUrl) {
    if (linkTyp == "0") {

    } else if (linkTyp == "1" || linkTyp == "2" || linkTyp == "3") {
        goApp(linkUrl, linkTyp);
    } else if (linkTyp == "4") {
        //		alert(linkUrl.substring(0,7));
        if (linkUrl.substring(0, 4) == 'http') {
            callSafari(linkUrl);
        }
    }
}

function validateEmail(email) {
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
}

function validatePhone(num) {
    if (num.length < 10) {
        return false;
    }

    if (num.substr(0, 3) != "010") {
        return false;
    }
    return true;
}


/* 폼 입력값 Check*/
function frmchk_char(str, condition)
    /*
    설명  : 폼 입력값을 정규식패턴을 이용해서 체크함
    사용법 : frmchk_char(문자열, 조건)
    결과값 : true/false
    조건  :
     0 = 첫글자 영문, 영문, 숫자, _ 사용가능
     1 = 영문만 사용가능
     2 = 숫자만 사용가능
     3 = 한글만 사용가능
     4 = 영문, 숫자 사용가능
     5 = 영문, 숫자, 한글 사용가능
     6 = 한글, 숫자 사용가능
     7 = 한글, 영문 사용가능
     8 = 한글을 포함하는지 여부
    */
    {
        var objPattern;
        switch (condition) {
            case (0):
                objPattern = /^[a-zA-Z]{1}[a-zA-Z0-9_]+$/;
                break;
            case (1):
                objPattern = /^[a-zA-Z]+$/;
                break;
            case (2):
                objPattern = /^[0-9]+$/;
                break;
            case (3):
                objPattern = /^[가-힣]+$/;
                break;
            case (4):
                objPattern = /^[a-zA-Z0-9]+$/;
                break;
            case (5):
                objPattern = /^[가-힣a-zA-Z0-9]+$/;
                break;
            case (6):
                objPattern = /^[가-힣0-9]+$/;
                break;
            case (7):
                objPattern = /^[가-힣a-zA-Z]+$/;
                break;
            case (8):
                objPattern = /[가-힣]/;
        }
        return objPattern.test(str);
    }


function validateDateFormat(str) {
    if (str.length != 8)
        return false;

    var y = str.substr(0, 4),
        m = str.substr(4, 2) - 1,
        d = str.substr(6, 2);
    var D = new Date(y, m, d);

    var date = new Date();
    if (y < 1900)
        return false;
    if (y > date.getFullYear())
        return false;

    return (D.getFullYear() == y && D.getMonth() == m && D.getDate() == d) ? true : false;
}

function onAlertClose() {
    location.href = "manager://onAlertClose";
}

var pushData = null;
var pushStr = "";

function onPush(data) {
    pushStr = data;
    var result = parseJSON(data);
    pushData = result;
    showAlert('commonPopup', '메시지 알림', result.alertMsg, 'onClosePush');
}

function onClosePush(data) {
    location.href = "manager://onPush?" + pushStr;
}

// 사업자등록번호 체크
function check_busino(obj) {
    var sum = 0;
    var getlist = new Array(10);
    var chkvalue = new Array("1", "3", "7", "1", "3", "7", "1", "3", "5");

    for (var i = 0; i < 10; i++) {
        getlist[i] = obj.val().substring(i, i + 1);
    }
    for (var i = 0; i < 9; i++) {
        sum += getlist[i] * chkvalue[i];
    }
    sum = sum + parseInt((getlist[8] * 5) / 10);
    sidliy = sum % 10;
    sidchk = 0;

    if (sidliy != 0) {
        sidchk = 10 - sidliy;
    } else {
        sidchk = 0;
    }

    if (sidchk != getlist[9]) {
        return false;
    }

    return true;
}

// 숫자만 입력되었는지 체크한다.
function do_checkNumber(obj) {
    if (/[^0123456789]/g.test(obj.val())) {
        alert("숫자만 입력해 주세요.");
        obj.val('');
        obj.focus();
    }
};

// 입력된 숫자가 휴대폰번호인지 체크한다.
function do_checkMobileNumer(obj) {
    if (/^(?:(010\d{4})|(01[1|6|7|8|9]\d{3,4}))(\d{4})$/g.test(obj.val())) {
        return true;
    }
    return false;
};

// maxlength 체크
function maxLengthCheck(object){
	if (object.value.length > object.maxLength){
		object.value = object.value.slice(0, object.maxLength);
	}
}

//숫자만
$(document).on("keyup", "input:text[numberOnly]", function() {$(this).val( $(this).val().replace(/[^0-9]/gi,"") );});
// 숫자(실수포함)만
$(document).on("keyup", "input:text[number2Only]", function() {$(this).val( $(this).val().replace(/[^.0-9]/gi,"") );});
// 영문만
$(document).on("keyup", "input:text[engOnly]", function() {$(this).val( $(this).val().replace(/[0-9]|[^\!-z]/gi,"") );});
// 영문+띄어쓰기만
$(document).on("keyup", "input:text[eng2Only]", function() {$(this).val( $(this).val().replace(/[0-9]|[^\!-z\s]/gi,"") );});
