function hasStorage() {
    try {
        localStorage.setItem('test', 'test');
        localStorage.removeItem('test');
        return true;
    } catch (exception) {
        return false;
    }
}

function getEquipNo() {
    if (hasStorage()) {
        equipNo = localStorage.getItem('equipNo');
        
        if (equipNo === undefined || equipNo === null || equipNo === "") {
            equipNo = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
                var r = Math.random()*16|0, v = c === 'x' ? r : (r&0x3|0x8);
                return v.toString(16);
            });
        }
        
        localStorage.setItem('equipNo', equipNo);
        return equipNo;
    }
    else
        return "f6db9d72-bec3-4637-8c72-f1ea8914d5f6";
}

/**--------------------------------------------------*/
/** 					PARAMETER
/**--------------------------------------------------*/
var API_KEY     = 'p9d3aa94deb714a5fb90030d2a486a6dc';	// 설정 KEY
var FUNC_KEY    = 'V00A001S0001FSR004';                 // 기능 KEY
var CUST_ID     = getEquipNo();							// 고객 ID
var SVC_NM      = 'echoss.marketing.rally';				// 서비스 명
var ISU_NO      = '';									// 쿠폰 발급 번호

var OTP_DIV_CD_SAVE_UP = "1";							// 구분 코드(1:적립)
var OTP_DIV_CD_CANCEL_SAVING_UP = "2"; 					// 구분 코드(2:적립취소)
var OTP_DIV_CD_USE_COUPON = "3"; 						// 구분 코드(3:쿠폰사용)

var canStamp = false; 									// 스탬프 여부
var canCoupon = false; 									// 쿠폰 여부
var useCoupon = false; 									// 쿠폰 사용 여부
var isCoupon = false; 									// 쿠폰 존재 여부

/**--------------------------------------------------*/
/** 					VIEW
/**--------------------------------------------------*/
// 중단 상점 슬라이드
$('#banner_wrap').slick({
	touchMove : false,
	swipe : false,
	infinite : true,
	dots : true,
	speed : 300,
	prevArrow : $('#slick-prev'),
	nextArrow : $('#slick-next')
});

// 하단 쿠폰바 열고닫힘
function open_coupon(target) {
	document.getElementById("div_rally_coupon").classList.toggle('on');
	document.getElementById("icon_slide").classList.toggle('on');
};

/**--------------------------------------------------*/
/** 					SETTING
/**--------------------------------------------------*/
$(window).on('load', function() {
	// 높이 구하기
	var div_container_height = document.getElementsByClassName('div_container')[0].offsetHeight;
	var div_voucherH_height = document.getElementsByClassName('div_voucherH')[0].offsetHeight;
	var div_rally_top_content_height = document.getElementsByClassName('div_rally_top_content')[0].offsetHeight;
	var div_banner_content_height = div_container_height - (div_voucherH_height + div_rally_top_content_height);
	for( var i = 0; i < document.getElementsByClassName('div_banner_content').length; i++ ) {
		document.getElementsByClassName('div_banner_content')[i].style.height = div_banner_content_height + 'px';
	}
	
	// [S-1]SDK 초기화
	echoss.initialize(API_KEY, echoss.REGION_CODE_TYPE.KOREA);
});

// [S-2]스탬프 초기화
echoss.initializeSuccess = function() {
	echoss.setLanguageCode(echoss.Common.LANGUAGE_CODE_TYPE.ENGLISH);
	
	echoss.Icon.init();
	
	echoss.Stamp.init(function(locUseTyp) {
		get_stamprallyInfo('reset');
	},
	function(errorCode, errorMessage) {
		alert(errorMessage + ' (' + errorCode + ')');
	});
}

// 스탬프 랠리 추가 및 상세 조회
function get_stamprallyInfo(type) {
	echoss.Stamprally.addAndGetDetailinfo({
		id 		: CUST_ID,
		funckey : FUNC_KEY
	},
	function(result) {
		var accuCount = result.accuCount; 				// 적립 건수
		var custCpnSize = result.custCpnList.length; 	// 쿠폰 갯수
		
		set_otpData();
		
		// 스탬프 적립 건수
		$('.span_number_area').html(accuCount);
		
		// 스탬프 적립 노출 아이콘
		if( accuCount === 1 ) {
			$('.coupon_icon').eq(0).find('.icon_on').addClass("on");
			$('.coupon_icon').eq(1).find('.icon_on').removeClass("on");
			$('.coupon_icon').eq(2).find('.icon_on').removeClass("on");
			
			echoss.Icon.showIcon();
		} 
		else if( accuCount === 2 ) {
			$('.coupon_icon').eq(0).find('.icon_on').addClass("on");
			$('.coupon_icon').eq(1).find('.icon_on').addClass("on");
			$('.coupon_icon').eq(2).find('.icon_on').removeClass("on");
			
			echoss.Icon.showIcon();
		} 
		else if( accuCount === 3 ) {
			$('.coupon_icon').eq(0).find('.icon_on').addClass("on");
			$('.coupon_icon').eq(1).find('.icon_on').addClass("on");
			$('.coupon_icon').eq(2).find('.icon_on').addClass("on");
			
			echoss.Icon.hideIcon();
		}
		
		if( (type == 'reset' && custCpnSize === 0) || (accuCount === 3 && custCpnSize === 0) ) {
			$('.span_number_area').html("0");
		    $('.coupon_icon').eq(0).find('.icon_on').removeClass("on");
		    $('.coupon_icon').eq(1).find('.icon_on').removeClass("on");
		    $('.coupon_icon').eq(2).find('.icon_on').removeClass("on");
		    
			echoss.Icon.showIcon();
		}
		
		canStamp = true;
		
		// 스탬프 적립시 쿠폰 발급
    	var html = "";
		if( custCpnSize > 0 ) {
			var obj = '';
	    	var imgUrl = '';
	    	
	    	for( var i = 0; i < result.custCpnList.length; i++ ) {
	            obj = result.custCpnList[i];
	            ISU_NO = obj.issueNo;
	            
	            var isImg = false;
	            for( var j=0; j<result.rallyOdrCpnList.length; j++ ) {
	                if( result.rallyOdrCpnList[j].code == obj.code ) {
	                	imgUrl = result.rallyOdrCpnList[j].imgUrl;
	                    isImg = true;
	                    break;
	                }
	            }
	            
	            if( !isImg ) {
	                for( var j=0; j<result.rallyCpnList.length; j++ ) {
	                    if( result.rallyCpnList[j].code == obj.code ) {
	                    	imgUrl = result.rallyCpnList[j].imgUrl;
	                        isImg = true;
	                        break;
	                    }
	                }
	            }
	        }
	    	
	    	// [C-0]쿠폰 목록
	    	html += '<span class="coupon_btn" onclick="open_coupon(this);">COUPON<span id="icon_slide" class="icon_slide"></span></span>';
	    	html += '<div class="div_coupon_inner_bg">';
	    	html += '	<div class="div_coupon_content">';
	    	html += '		<span class="img_area">';
	    	html += '			<img src="'+ imgUrl +'" alt="img_coupon" />';
	    	html += '		</span>';
	    	html += '		<div class="div_content_desc">';
	    	html += '			<p class="p_coupon_name">'+ obj.name +'</p>';
	    	html += '			<div class="div_coupon_term">';
	    	html += '				<p class="p_issued">Issued</p>';
	    	html += '				<p class="p_issued">Expiry</p>';
	    	html += '			</div>';
	    	html += '			<div class="p_date">';
	    	html += '				<p class="Issued_inner">'+ format_dateString(obj.issueDate, '-') +'</p>';
	    	html += '				<p class="Expiry_inner">'+ format_dateString(obj.expDate, '-', 'No expiry date') +'</p>';
	    	html += '			</div>';
	    	html += '		</div>';
	    	html += '	</div>';
	    	html += '</div>';
    	
			$('#div_rally_coupon').html(html);
			$('#div_rally_coupon').show();
			
			// [C-1]쿠폰 팝업 이동
			$('.div_coupon_inner_bg').on('click', function() {
				var popParams = {
					title 		: obj.name,
					subtit 		: obj.name,
					imgUrl 		: obj.imgUrl,
					expiryDt 	: format_dateString(obj.expDate, '-')
				};
				
				open_popup(popParams);
			});
			
			isCoupon = true;
		}
		else {
			$('#div_rally_coupon').html(html);
			$('#div_rally_coupon').hide();
			
			isCoupon = false;
		}
		
		// 에코스 아이콘 클릭시 스탬프 이용 불가
		$('#echossIcon').on('click', function() {
			canStamp = false;
		});
		$('#echoss_icon_wrap .btn_icon_close').on('click', function() {
			canStamp = true;
		});
	},
	function(errorCode, errorMessage) {
		alert(errorMessage + ' (' + errorCode + ')');
	});
}

/**--------------------------------------------------*/
/** 					STAMPING
/**--------------------------------------------------*/
// [S-3]스탬프 에러 처리
echoss.Stamp.onError = function(errorCode, errorMessage) {
	alert(errorMessage + ' (' + errorCode + ')');
}

// [S-4]스탬프 정상 처리
echoss.Stamp.onStamp = function(stampParams) {
	if(!canStamp) {
		return;
	}
	
	canStamp = false;
	echoss.Icon.hideIcon();
	
	// 쿠폰 사용
	startStampAnimation();
	if( canCoupon ) {
		echoss.Stamprally.useCoupon({
			id 			: CUST_ID,
			issueNo 	: ISU_NO,
			type 		: "1",
			stampParams : stampParams
		},
		function(result) {
			stopStampAnimation();
			$('.img_used').show();
			useCoupon = true;
		},
		function(errorCode, errorMessage) {
			stopStampAnimation();
			canStamp = true;
			echoss.Icon.showIcon();
			alert(errorMessage + ' (' + errorCode + ')');
		});
	}
	// 스탬프 적립
	else {
		if( isCoupon ) {
			stopStampAnimation();
			canStamp = true;
			alert("Please use coupon to re-participate rally service");
			return;
		}
		
		echoss.Stamprally.collect({
			id 			: CUST_ID,
			funckey 	: FUNC_KEY,
			stampParams : stampParams
		},
		function(result) {
			stopStampAnimation();
			get_stamprallyInfo('accu');
		},
		function(errorCode, errorMessage) {
			stopStampAnimation();
			canStamp = true;
			echoss.Icon.showIcon();
			alert(errorMessage + ' (' + errorCode + ')');
		});
	}
}

/**--------------------------------------------------*/
/** 					OTP
/**--------------------------------------------------*/
// [O-2]데이터 설정
function set_otpData() {
	var aprvData = '';
	var isuDivCd = '';
	
	// 쿠폰 사용
	if( canCoupon ) {
		aprvData = set_aprvData(OTP_DIV_CD_USE_COUPON, CUST_ID, FUNC_KEY, ISU_NO);
		isuDivCd = echoss.Icon.OTP_ISSUE_TYPE.USE_COUPON;
	}
	// 스탬프 적립
	else {
		aprvData = set_aprvData(OTP_DIV_CD_SAVE_UP, CUST_ID, FUNC_KEY);
		isuDivCd = echoss.Icon.OTP_ISSUE_TYPE.COLLECT;
	}
	
	// otp 처리
	echoss.Icon.setOtpData({
		aprvData 	: aprvData,
		funcCd 		: echoss.Icon.OTP_FUNC_CODE.STAMP_RALLY,
		isuDivCd 	: isuDivCd,
		cntYn 		: "N",
	},
	function() {
		echoss.Icon.closeGuideView();
		echoss.Icon.hideIcon();

		// 쿠폰 사용
		if( canCoupon ) {
			$('.img_used').show();
			useCoupon = true;
		}
		else {
			get_stamprallyInfo('accu');
		}
	},
	function(errorCode, errorMessage) {
		alert(errorMessage + ' (' + errorCode + ')');
	});
}

// [O-2]데이터 설정 -> 데이터 구성(구분코드, 고객번호, 매장키, 쿠폰발행번호)
function set_aprvData(otpDivCd, custId, funcKey, isuNo) {
	var aprvData = otpDivCd + "," + custId + "," + funcKey;
	if( isuNo != undefined ) {
		aprvData += ("," + isuNo);
	} 
	else {
		aprvData += ("," + "0");
	}
	
	return aprvData;
}

/**--------------------------------------------------*/
/** 					POPUP
/**--------------------------------------------------*/
// [C-2]쿠폰 팝업 열기
function open_popup(popParams) {
	canCoupon = true;
	canStamp = true;
	
	set_otpData();
	echoss.Icon.showIcon();
	
	var html = '';
		html += '<div class="popup_wrap on" data-popupwrap="popupwrap">';
		html += '	<div class="popup_content popup_content_02">';
		html += '		<img class="icon_close_coupon" src="images/btn_close_header.png" alt="btn_close_header" onclick="close_popup(this);" />';
		html += '		<div class="div_coupon_popup">';
		html += '			<p class="p_title">'+ popParams.title +'</p>';
		html += '			<p class="p_subtit">'+ popParams.subtit +'</p>';
		html += '			<img class="img_content" src="'+ popParams.imgUrl +'" alt="img_coupon_01" />';
		html += '			<div class="div_expiry_desc">';
		html += '				<p class="pop_expiry">Expiry</p>';
		html += '				<p class="pop_expiry_date">'+ popParams.expiryDt +'</p>';
		html += '			</div>';
		html += '			<div class="stamp_handCancel">';
		html += '				<p class="stamp_desc">Anywhere you want,<br/>just stamp on the smart phone</p>';
		html += '				<img class="img_stamping" src="images/img_stamp_here.png" alt="img_stamp_here" />';
		html += '			</div>';
		html += '		</div>';
		html += '	</div>';
		html += '	<img class="img_used on" src="images/img_used.png" alt="img_used" style="display:none;" />';
		html += '</div>';
	$('body').append(html);
}

// [C-3]쿠폰 팝업 닫기(css display:none)
function close_popup(target) {
	canCoupon = false;
	canStamp = false;
	
	set_otpData();
	echoss.Icon.hideIcon();
	
	var target_this = target.parentNode;
	while( target_this.getAttribute("data-popupwrap") != "popupwrap" && target_this.getAttribute("data-popupwrap") != "" ) {
		target_this = target_this.parentNode;
	}
	target_this.style.display = "none";
	
	// 쿠폰 사용을 했을 경우 새로 고침
	if( useCoupon ) {
		get_stamprallyInfo('reset');
	}
	
	return;
};

/**--------------------------------------------------*/
/** 					REFERENCE
/**--------------------------------------------------*/

// 날짜 포맷 - format_dateString(obj.expDate, '-', 'No expiry date')
function format_dateString(dateStr, delim, defaultStr) {
	if( defaultStr != undefined && dateStr.length <= 0 )
		return defaultStr;
	
	var dateString = "";
	var year = dateStr.substr(0, 4);
	var month = dateStr.substr(4, 2);
	var day = dateStr.substr(6, 2);
	
	dateString = year + delim + month + delim + day;
	
	return dateString;
}

/**--------------------------------------------------*/
/** 					ANIMATION
/**--------------------------------------------------*/
// Show Stamping Effect on screen
function startStampAnimation() {	
	if( document.getElementById('modal-stamp') === null ) {
        var elemDiv = document.createElement('div');
        elemDiv.id = 'modal-stamp';
        elemDiv.className = 'stamp-modal';
        var htmlStr = '';
        htmlStr += '<div id="stampMotion_fr_box">'
        htmlStr += '	<div id="stamp_box_frame" style="position:relative;">'
        htmlStr += '		<img src="images/stamping/stamp_motion_fr.png" id="stampMotion_fr" />';
        htmlStr += '		<img src="images/stamping/stamping_ico.gif" id="stampMotion00" />';
        htmlStr += '	</div>'
        htmlStr += '</div>'
        htmlStr += '<img src="images/stamping/stamp_motion05.png" id="stampMotion05" />';
        htmlStr += '<img src="images/stamping/stamp_motion06.png" id="stampMotion06" />';
        htmlStr += '<img src="images/stamping/stamp_motion07.png" id="stampMotion07" />';
        elemDiv.innerHTML = htmlStr;
        $('body').append(elemDiv);
    }
	
	$('#modal-stamp').addClass('effect-show');
	$('#stampMotion00').addClass("changeImgShow0");
	$('#stampMotion05').addClass("scaleUpImg");
	$('#stampMotion06').addClass("scaleUpImg2");
	$('#stampMotion07').addClass("scaleUpImg3");
}

// Dismiss Stamping Effect on screen
function stopStampAnimation() {
	$('#modal-stamp').removeClass('effect-show');
	$('#stampMotion00').removeClass("changeImgShow0");
	$('#stampMotion05').removeClass("scaleUpImg");
	$('#stampMotion06').removeClass("scaleUpImg2");
	$('#stampMotion07').removeClass("scaleUpImg3");
}
