function hasStorage() {
    try {
        localStorage.setItem('test', 'test');
        localStorage.removeItem('test');
        return true;
    } catch (exception) {
        return false;
    }
}

function getEquipNo() {
    if (hasStorage()) {
        equipNo = localStorage.getItem('equipNo');
        
        if (equipNo === undefined || equipNo === null || equipNo === "") {
            equipNo = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
                var r = Math.random()*16|0, v = c === 'x' ? r : (r&0x3|0x8);
                return v.toString(16);
            });
        }
        
        localStorage.setItem('equipNo', equipNo);
        return equipNo;
    }
    else
        return "f6db9d72-bec3-4637-8c72-f1ea8914d5f6";
}

/**--------------------------------------------------*/
/** 					PARAMETER
/**--------------------------------------------------*/
var API_KEY     = 'p9d3aa94deb714a5fb90030d2a486a6dc';	// 설정 KEY
var FUNC_KEY    = 'V00A001B002M00001S0001FRT001';		// 기능 KEY
var CUST_ID     = getEquipNo();                         // 고객 ID
var SVC_NM      = 'echoss.marketing.roulette';			// 서비스 명
var ISU_NO      = '';									// 쿠폰 발급 번호

var OTP_DIV_CD_SAVE_UP = "1";							// 구분 코드(1:적립)
var OTP_DIV_CD_RES_SAVE_UP = "2"; 						// 구분 코드(2:적립후)
var OTP_DIV_CD_USE_COUPON = "3"; 						// 구분 코드(3:쿠폰사용)

var canStamp = false; 									// 스탬프 여부
var canCoupon = false; 									// 쿠폰 여부
var useCoupon = false; 									// 쿠폰 사용 여부
var canPrize = false; 									// 당첨 여부
var canReset = false; 									// 초기화 여부

var speakInterval = null;

/**--------------------------------------------------*/
/** 					SETTING
/**--------------------------------------------------*/
$(window).on('load', function() {
	// [S-1]SDK 초기화
	echoss.initialize(API_KEY, echoss.REGION_CODE_TYPE.KOREA);
});

// [S-2]스탬프 초기화
echoss.initializeSuccess = function() {
	echoss.setLanguageCode(echoss.Common.LANGUAGE_CODE_TYPE.ENGLISH);
	
	echoss.Icon.init();
	
	echoss.Stamp.init(function(locUseTyp) {
		get_stamprouletteInfo('reset');
	},
	function(errorCode, errorMessage) {
		alert(errorMessage + ' (' + errorCode + ')');
	});
}

// [S-2-2]스탬프 초기화 설정/[S-4]스탬프 정상 처리 -> 스탬프 룰렛 추가 및 상세 조회
var cpnArray = new Array();
function get_stamprouletteInfo(type) {
	// 쿠폰 목록 비우기
	$('.div_coupon_content').remove();
	
	set_otpData();
	
	if( type == 'reset' ) {
		echoss.Icon.showIcon();
	}
	
	echoss.Stamproulette.addAndGetDetailinfo({
		id 		: CUST_ID,
		funckey : FUNC_KEY,
		type    : OTP_DIV_CD_SAVE_UP
	},
	function(result) {
		// 스탬프 적립시 쿠폰 발급
		var html = "";
	    if( result.custCpnList.length > 0 ) {
	    	var obj = '';
	    	var imgUrl = '';

	    	for( var i = 0; i < result.custCpnList.length; i++ ) {
	            obj = result.custCpnList[i];
	            cpnArray.push(result.custCpnList[i]);
	        
	            for( var j=0; j<result.roulCpnList.length; j++ ) {
	                if( result.roulCpnList[j].code == obj.code ) {
	                	imgUrl = result.roulCpnList[j].imgUrl;
	                    break;
	                }
	            }
	            
	            html += '<div class="div_coupon_content" onclick="go_couponPopup('+ i +', \''+ imgUrl +'\', \''+ obj.issueNo +'\');">';
	            html += '	<span class="img_area">';
	            html += '		<img src="'+ imgUrl +'" alt="img_coupon" />';
	            html += '	</span>';
	            html += '	<div class="div_content_desc">';
	            html += '		<p class="p_coupon_name">'+ obj.name +'</p>';
	            html += '		<div class="div_coupon_term">';
	            html += '			<p class="p_issued">Issued</p>';
	            html += '			<p class="p_issued">Expiry</p>';
	            html += '		</div>';
	            html += '		<div class="p_date">';
	            html += '			<p class="Issued_inner">'+ format_dateString(obj.issueDate, '-') +'</p>';
	            html += '			<p class="Expiry_inner">'+ format_dateString(obj.expDate, '-', 'No expiry date') +'</p>';
	            html += '		</div>';
	            html += '	</div>';
	            html += '</div>';
	        }
	    	$('#div_coupon_inner_bg').html(html);
	    	$('#div_roulette_coupon').show();
		}
	    else {
	    	$('#div_coupon_inner_bg').html(html);
	    	$('#div_roulette_coupon').hide();
	    }
    	
    	// 에코스 아이콘 클릭시 스탬프 이용 불가
    	$('#echossIcon').on('click', function() {
    		canStamp = false;
    	});
    	$('#echoss_icon_wrap .btn_icon_close').on('click', function() {
    		canStamp = true;
    	});
    	
    	if( !canPrize ) {
    		canStamp = true;
    		
	    	// 말풍선
	    	var img_num2 = 1;
	    	if(speakInterval != null) {
	    		clearInterval(speakInterval);
	    		speakInterval = null;
	    	}
	    	
	    	speakInterval = setInterval(function() {
	    		img_num2 += 1;
	    		if(img_num2 > 2) {
	    			img_num2 = 1;
	    		}
	    		$('img.stamp_balloon').attr("src", "images/img_balloon_0" + img_num2 + ".png");
	    	}, 200);
	    }
	},
	function(errorCode, errorMessage) {
		alert(errorMessage + ' (' + errorCode + ')');
	});
}

/**--------------------------------------------------*/
/** 					STAMPING
/**--------------------------------------------------*/
// [S-3]스탬프 에러 처리
echoss.Stamp.onError = function(errorCode, errorMessage) {
	alert(errorMessage + ' (' + errorCode + ')');
}

// [S-4]스탬프 정상 처리
echoss.Stamp.onStamp = function(stampParams) {
	// 스탬프 허용 체크
	if(!canStamp) {
		return;
	}
	
	canStamp = false;
	
	// 쿠폰 사용
	if( canCoupon ) {
		startStampAnimation();
		echoss.Stamproulette.useCoupon({
			id 			: CUST_ID,
			issueNo 	: ISU_NO,
			funckey 	: FUNC_KEY,
			type 		: "1",
			stampParams : stampParams
		},
		function(result) {
			stopStampAnimation();
			$('.img_used').show();
			useCoupon = true;
			echoss.Icon.hideIcon();
		},
		function(errorCode, errorMessage) {
			stopStampAnimation();
			canStamp = true;
			alert(errorMessage + ' (' + errorCode + ')');
		});
	}
	// 스탬프 적립
	else {
		echoss.Stamproulette.getDetailinfo({
			id 			: CUST_ID,
			funckey 	: FUNC_KEY,
			type    	: OTP_DIV_CD_RES_SAVE_UP,
			stampParams : stampParams
		},
		function(result) {
			do_stamproulette();
		},
		function(errorCode, errorMessage) {
			canStamp = true;
			alert(errorMessage + ' (' + errorCode + ')');
		});
	}
}

/**--------------------------------------------------*/
/** 					OTP
/**--------------------------------------------------*/
// [O-2]데이터 설정
function set_otpData() {
	var aprvData = '';
	var isuDivCd = '';
	
	// 쿠폰 사용
	if( canCoupon ) {
		aprvData = set_aprvData(OTP_DIV_CD_USE_COUPON, CUST_ID, FUNC_KEY, ISU_NO);
		isuDivCd = echoss.Icon.OTP_ISSUE_TYPE.USE_COUPON;
	}
	// 스탬프 적립
	else {
		aprvData = set_aprvData(OTP_DIV_CD_SAVE_UP, CUST_ID, FUNC_KEY);
		isuDivCd = echoss.Icon.OTP_ISSUE_TYPE.COLLECT;
	}
	
	echoss.Icon.setOtpData({
		aprvData 	: aprvData,
		funcCd 		: echoss.Icon.OTP_FUNC_CODE.STAMP_ROULETTE,
		isuDivCd 	: isuDivCd,
		cntYn 		: "N",
	},
	function() {
		echoss.Icon.closeGuideView();
		echoss.Icon.hideIcon();
		
		// 쿠폰 사용
		if( canCoupon ) {
			$('.img_used').show();
			useCoupon = true;
		}
		else {
			do_stamproulette();
		}
	},
	function(errorCode, errorMessage) {
		alert(errorMessage + ' (' + errorCode + ')');
	});
}

// [O-2]데이터 설정 -> 데이터 구성(구분코드, 고객번호, 매장키, 쿠폰발행번호)
function set_aprvData(otpDivCd, custId, funcKey, isuNo) {
	var aprvData = otpDivCd + "," + custId + "," + funcKey;
	if( isuNo != undefined ) {
		aprvData += ("," + isuNo);
	} 
	else {
		aprvData += ("," + "0");
	}
	
	return aprvData;
}

/**--------------------------------------------------*/
/** 					ROULETTE
/**--------------------------------------------------*/
// [R-1]스탬프 룰렛 돌리기
function do_stamproulette() {
	echoss.Icon.hideIcon();
	
	// 룰렛 시작
	$('img.stamp_balloon').addClass("roulette_start");
	var img_num1 = 1;
	move_elp = setInterval(function() {
		img_num1 += 1;
		// 코끼리
		$('img#elp_img').attr("src", "images/img_elephant_0" + img_num1 + ".png");
		if(img_num1 == 4) {
			img_num1 = 1;
		}
	}, 120);
	
	$('img.spin_elp_roulette').addClass('on');
	
	// 룰렛판 정지
	setTimeout(function() {
		$('img.spin_elp_roulette').removeClass("on");
		$('img.spin_elp_roulette').addClass("spin_stop");
		
		// 코끼리 정지
		setTimeout(function() {
			$('body').addClass("roulette_stop");
			clearInterval(move_elp);
			req_stamproulette();
		}, 900);
	}, 700);
}

// [R-2]스탬프 룰렛 결과
function req_stamproulette() {
	echoss.Stamproulette.issueCoupon({
		id 		: CUST_ID,
		funckey : FUNC_KEY
	},
	function(result) {
		// 당첨
		if( result.cpnIsuYn === "Y" ) {
			alert("Congratulations! You've earned a coupon!");
			
			$('img.complete_paper').show();
			
			var img_num3 = 1;
			rouletteStopTimer = setInterval(function() {
				img_num3 += 1;
				$('img.complete_paper').attr("src",	"images/img_paper_0" + img_num3 + ".png");
				if(img_num3 == 3) {
					img_num3 = 1;
				}
			}, 120);
			
			canPrize = true;
			
			get_stamprouletteInfo();
		}
		// 꽝
		else {
			canPrize = false;
			
			alert("You did not win the coupon. Please try one more time.");
		}
		
		canReset = true;
		
		// 초기화
		$('img.spin_elp_roulette.spin_stop').click(function() {
			clearInterval(rouletteStopTimer);
			
			$('img.complete_paper').hide();
			$('body').removeClass("roulette_stop");
			$('img.spin_elp_roulette').removeClass("spin_stop");
			$('img.stamp_balloon').removeClass("roulette_start");
			
			canPrize = false;
			canReset = false;
			
			get_stamprouletteInfo('reset');
		});
	},
	function(errorCode, errorMessage) {
		alert(errorMessage + ' (' + errorCode + ')');
	});
}

/**--------------------------------------------------*/
/** 					POPUP
/**--------------------------------------------------*/
// [C-1]쿠폰 팝업 이동
function go_couponPopup(idx, imgUrl, issueNo) {
	var obj = cpnArray[idx];
	var popParams = {
			title 		: obj.name,
			subtit 		: obj.name,
			imgUrl 		: imgUrl,
			expiryDt 	: format_dateString(obj.expDate, '-'),
			issueNo		: issueNo
	};
	open_popup(popParams);
}

// [C-2]쿠폰 팝업 열기
function open_popup(popParams) {
	canCoupon = true;
	canStamp = true;
	
	ISU_NO = popParams.issueNo;
	
	set_otpData();
	echoss.Icon.showIcon();
	
	var html = '';
		html += '<div class="popup_wrap on" data-popupwrap="popupwrap" id="'+ popParams.issueNo +'">';
		html += '	<div class="popup_content popup_content_02">';
		html += '		<img class="icon_close_coupon" src="images/btn_close_header.png" alt="btn_close_header" onclick="close_popup(this);" />';
		html += '		<div class="div_coupon_popup">';
		html += '			<p class="p_title">'+ popParams.title +'</p>';
		html += '			<p class="p_subtit">'+ popParams.subtit +'</p>';
		html += '			<img class="img_content" src="'+ popParams.imgUrl +'" alt="img_coupon_01" />';
		html += '			<div class="div_expiry_desc">';
		html += '				<p class="pop_expiry">Expiry</p>';
		html += '				<p class="pop_expiry_date">'+ popParams.expiryDt +'</p>';
		html += '			</div>';
		html += '			<div class="stamp_handCancel">';
		html += '				<p class="stamp_desc">Anywhere you want,<br/>just stamp on the smart phone</p>';
		html += '				<img class="img_stamping" src="images/img_stamp_here.png" alt="img_stamp_here" />';
		html += '			</div>';
		html += '		</div>';
		html += '	</div>';
		html += '	<img class="img_used on" src="images/img_used.png" alt="img_used" style="display:none;" />';
		html += '</div>';
	$('body').append(html);
}

// [C-3]쿠폰 팝업 닫기(css display:none)
function close_popup(target) {
	canCoupon = false;
	
	if( canPrize ) {
		canStamp = false;
	}
	
	$('body #'+ISU_NO).remove();
	
	ISU_NO = '';
	
	set_otpData();
	if( canReset ) {
		echoss.Icon.hideIcon();
	}
	
	var target_this = target.parentNode;
	while( target_this.getAttribute("data-popupwrap") != "popupwrap" && target_this.getAttribute("data-popupwrap") != "" ) {
		target_this = target_this.parentNode;
	}
	target_this.style.display = "none";
	
	// 쿠폰 사용을 했을 경우 새로 고침
	if( useCoupon ) {
		$('.img_used').hide();
		if( canReset ) {
			get_stamprouletteInfo();
		}
		else {
			get_stamprouletteInfo('reset');
		}
	}
	
	return;
}

/**--------------------------------------------------*/
/** 					REFERENCE
/**--------------------------------------------------*/
// 날짜 포맷 - format_dateString(obj.expDate, '-', 'No expiry date')
function format_dateString(dateStr, delim, defaultStr) {
	if( defaultStr != undefined && dateStr.length <= 0 )
		return defaultStr;
	
	var dateString = "";
	var year = dateStr.substr(0, 4);
	var month = dateStr.substr(4, 2);
	var day = dateStr.substr(6, 2);
	
	dateString = year + delim + month + delim + day;
	
	return dateString;
}

/**--------------------------------------------------*/
/** 					ANIMATION
/**--------------------------------------------------*/
// Show Stamping Effect on screen
function startStampAnimation() {	
	if( document.getElementById('modal-stamp') === null ) {
        var elemDiv = document.createElement('div');
        elemDiv.id = 'modal-stamp';
        elemDiv.className = 'stamp-modal';
        var htmlStr = '';
        htmlStr += '<div id="stampMotion_fr_box">'
        htmlStr += '	<div id="stamp_box_frame" style="position:relative;">'
        htmlStr += '		<img src="images/stamping/stamp_motion_fr.png" id="stampMotion_fr" />';
        htmlStr += '		<img src="images/stamping/stamping_ico.gif" id="stampMotion00" />';
        htmlStr += '	</div>'
        htmlStr += '</div>'
        htmlStr += '<img src="images/stamping/stamp_motion05.png" id="stampMotion05" />';
        htmlStr += '<img src="images/stamping/stamp_motion06.png" id="stampMotion06" />';
        htmlStr += '<img src="images/stamping/stamp_motion07.png" id="stampMotion07" />';
        elemDiv.innerHTML = htmlStr;
        $('body').append(elemDiv);
    }
	$('#modal-stamp').addClass("effect-show");
	$('#stampMotion00').addClass("changeImgShow0");
	$('#stampMotion05').addClass("scaleUpImg");
	$('#stampMotion06').addClass("scaleUpImg2");
	$('#stampMotion07').addClass("scaleUpImg3");
}

// Dismiss Stamping Effect on screen
function stopStampAnimation() {
	$('#modal-stamp').removeClass("effect-show");
	$('#stampMotion00').removeClass("changeImgShow0");
	$('#stampMotion05').removeClass("scaleUpImg");
	$('#stampMotion06').removeClass("scaleUpImg2");
	$('#stampMotion07').removeClass("scaleUpImg3");
}
