/**
 * @subject 스탬프카드 이관 처리를 위한 API
 * @date 	2018. 07. 30
 * @author 	CSCHOI
 * @version 1.0
 * */

var extras = {
	EXTRAS_API_KEY 			: "",
	EXTRAS_REGION_CODE 		: "",
	EXTRAS_LANGUAGE_CODE 	: "",
	EXTRAS_SERVER_URL 		: "",
	EXTRAS_CLIENT_ID 		: "22cd9435-c1ef-4a1c-a511-791303a5a20f",
	EXTRAS_CLIENT_SECRET 	: "33663161393164662D303534302D343739332D383562612D356637666264636135643934",

	// 초기화 작업
	initialize : function(apiKey, regionCode, languageCode) {
		if(isEmptyParameter('apiKey', apiKey)
		|| isEmptyParameter('regionCode', regionCode)
		|| isEmptyParameter('languageCode', languageCode)) {
			return;
		}
		
		extras.EXTRAS_API_KEY = apiKey;
		// KR:한국, JP:일본, TW:대만, CN:중국, EU:유럽, APSE1:동남아1, APSE2:동남아2, DEV:개발
		extras.EXTRAS_REGION_CODE = regionCode;
		// ko:한국어, en:영어, ja:일본어, zh_CN:중국어(간체), zh_TW:중국어(번체)
		extras.EXTRAS_LANGUAGE_CODE = languageCode;
		
		var isPROD = false;
		if((apiKey.substring(0,1) === "p" || apiKey.substring(0,5) === "mid:p")) {
			isPROD = true;
		}
		
		if(regionCode === "DEV") {
			extras.EXTRAS_SERVER_URL = "http://mdev.echoss.co.kr";
		}
		else if(regionCode === "KR") {
			if(isPROD)
				extras.EXTRAS_SERVER_URL = "https://platform-function.echoss.co.kr";
			else
				extras.EXTRAS_SERVER_URL = "http://platform-function-dev.echoss.co.kr";
		}
		else if(regionCode === "JP") {
			if(isPROD)
				extras.EXTRAS_SERVER_URL = "https://platform-function.12cm.jp";
			else
				extras.EXTRAS_SERVER_URL = "https://platform-function-dev.12cm.jp";
		}
		else if(regionCode === "CN") {
			if(isPROD)
				extras.EXTRAS_SERVER_URL = "https://platform-function.echoss.cn";
			else
				extras.EXTRAS_SERVER_URL = "https://platform-function-dev.echoss.cn";
		}
		else if(regionCode === "TW") {
			if(isPROD)
				extras.EXTRAS_SERVER_URL = "https://platform-function.12cm.tw";
			else
				extras.EXTRAS_SERVER_URL = "https://platform-function-dev.12cm.tw";
		}
		else if(regionCode === "APSE1") {
			if(isPROD)
				extras.EXTRAS_SERVER_URL = "https://pm.apse1.12cmglobal.com";
			else
				extras.EXTRAS_SERVER_URL = "https://pm.apse1.12cmglobal.com";
		}
		else if(regionCode === "APSE2") {
			if(isPROD)
				extras.EXTRAS_SERVER_URL = "https://pm.apse2.12cmglobal.com";
			else
				extras.EXTRAS_SERVER_URL = "https://pm.apse2.12cmglobal.com";
		}
		else if(regionCode === "EU") {
			if(isPROD)
				extras.EXTRAS_SERVER_URL = "https://pm.europe.12cmglobal.com";
			else
				extras.EXTRAS_SERVER_URL = "https://pm.europe.12cmglobal.com";
		}
	},
	
	stampcard : {
		// FSC-900-10 : 스탬프카드 적립내역 이관
		transferStamps : function(request, callbackSuccess, callbackFail) {
			if(isEmptyParameter('funckey', request.funckey)
			|| isEmptyParameter('fromId', request.fromId)
			|| isEmptyParameter('toId', request.toId)
			|| isEmptyParameter('transferCnt', request.transferCnt)
			|| isEmptyParameter('success callback', callbackSuccess)
			|| isEmptyParameter('fail callback', callbackFail)) {
				return;
			}
			
			var parameters = new Object();
			parameters['key'] = extras.EXTRAS_API_KEY;
			parameters['funckey'] = request.funckey;
			parameters['fromId'] = request.fromId;
			parameters['toId'] = request.toId;
			parameters['transferCnt'] = request.transferCnt;
			
			handleHttp("POST", "/fsc/stampcard/transfer/stamps", parameters, callbackSuccess, callbackFail);
		},
		
		// FSC-900-11 : 스탬프카드 쿠폰 이관(by 하나만)
		transferCoupon : function(request, callbackSuccess, callbackFail) {
			if(isEmptyParameter('funckey', request.funckey)
			|| isEmptyParameter('fromId', request.fromId)
			|| isEmptyParameter('toId', request.toId)
			|| isEmptyParameter('issueNo', request.issueNo)
			|| isEmptyParameter('success callback', callbackSuccess)
			|| isEmptyParameter('fail callback', callbackFail)) {
				return;
			}
			
			var parameters = new Object();
			parameters['key'] = extras.EXTRAS_API_KEY;
			parameters['funckey'] = request.funckey;
			parameters['fromId'] = request.fromId;
			parameters['toId'] = request.toId;
			
			var parameter = new Object();
			parameter['issueNo'] = request.issueNo;
			var coupons = new Array();
			coupons.push(parameter);
			parameters['coupons'] = coupons;
			
			handleHttp("POST", "/fsc/stampcard/transfer/coupons", parameters, callbackSuccess, callbackFail);
		},
		
		// FSC-900-11 : 스탬프카드 쿠폰 이관(by 여러개)
		transferCoupons : function(request, callbackSuccess, callbackFail) {
			if(isEmptyParameter('funckey', request.funckey)
			|| isEmptyParameter('fromId', request.fromId)
			|| isEmptyParameter('toId', request.toId)
			|| isEmptyParameter('coupons', request.coupons)
			|| isEmptyParameter('success callback', callbackSuccess)
			|| isEmptyParameter('fail callback', callbackFail)) {
				return;
			}
			
			var parameters = new Object();
			parameters['key'] = extras.EXTRAS_API_KEY;
			parameters['funckey'] = request.funckey;
			parameters['fromId'] = request.fromId;
			parameters['toId'] = request.toId;
			parameters['coupons'] = request.coupons;
			
			handleHttp("POST", "/fsc/stampcard/transfer/coupons", parameters, callbackSuccess, callbackFail);
		},
		
		// FSC-900-12 : 스탬프카드 적립내역 전체 조회
		history : function(request, callbackSuccess, callbackFail) {
			if(isEmptyParameter('funckey', request.funckey)
			|| isEmptyParameter('id', request.id)
			|| isEmptyParameter('success callback', callbackSuccess)
			|| isEmptyParameter('fail callback', callbackFail)) {
				return;
			}
			
			var parameters = new Object();
			parameters['key'] = extras.EXTRAS_API_KEY;
			parameters['funckey'] = request.funckey;
			parameters['id'] = request.id;
			// 적립일자+시간 기준(1:ASC(default), 2:DESC)
			if(request.sort != undefined && request.sort != null && request.sort != '') {
				parameters['sort'] = request.sort;
			}
			
			handleHttp("POST", "/fsc/stampcard/history", parameters, callbackSuccess, callbackFail);
		},
		
		// FSC-900-13 : 스탬프카드 이관내역 조회
		transferHistory : function(request, callbackSuccess, callbackFail) {
			if(isEmptyParameter('divCd', request.divCd)
			|| isEmptyParameter('success callback', callbackSuccess)
			|| isEmptyParameter('fail callback', callbackFail)) {
				return;
			}
			
			if((request.fromId == undefined || request.fromId == null || request.fromId == '') 
					&& (request.toId == undefined || request.toId == null || request.toId == '')) {
				isEmptyParameter('fromId or toId', null);
			}
			
			var parameters = new Object();
			parameters['key'] = extras.EXTRAS_API_KEY;
			// 1:적립, 2:쿠폰
			parameters['divCd'] = request.divCd;
			
			// 두개 중 하나는 반드시 존재
			if(request.fromId != undefined && request.fromId != null && request.fromId != '') {
				parameters['fromId'] = request.fromId;
			}
			if(request.toId != undefined && request.toId != null && request.toId != '') {
				parameters['toId'] = request.toId;
			}
			if(request.funckey != undefined && request.funckey != null && request.funckey != '') {
				parameters['funckey'] = request.funckey;
			}
			// yyyyMMdd
			if(request.searchStartDt != undefined && request.searchStartDt != null && request.searchStartDt != '') {
				parameters['searchStartDt'] = request.searchStartDt;
			}
			// yyyyMMdd
			if(request.searchEndDt != undefined && request.searchEndDt != null && request.searchEndDt != '') {
				parameters['searchEndDt'] = request.searchEndDt;
			}
			// 이관일자+시간 기준(1:ASC(default), 2:DESC)
			if(request.sort != undefined && request.sort != null && request.sort != '') {
				parameters['sort'] = request.sort;
			}
			
			handleHttp("POST", "/fsc/stampcard/transfer/history", parameters, callbackSuccess, callbackFail);
		},
		
		// FSC-900-14 : 스탬프카드 카드번호로 고객ID 조회
		transferCardno : function(request, callbackSuccess, callbackFail) {
			if(isEmptyParameter('funckey', request.funckey)
			|| isEmptyParameter('cardNo', request.cardNo)
			|| isEmptyParameter('success callback', callbackSuccess)
			|| isEmptyParameter('fail callback', callbackFail)) {
				return;
			}
			
			var parameters = new Object();
			parameters['key'] = extras.EXTRAS_API_KEY;
			parameters['funckey'] = request.funckey;
			parameters['cardNo'] = request.cardNo;
			
			handleHttp("POST", "/fsc/stampcard/transfer/custid", parameters, callbackSuccess, callbackFail);
		},
		
		// FSC-900-15 : 스탬프카드 적립내역 조회(with 이관내역)
		historyTransfer : function(request, callbackSuccess, callbackFail) {
			if(isEmptyParameter('funckey', request.funckey)
			|| isEmptyParameter('id', request.id)
			|| isEmptyParameter('success callback', callbackSuccess)
			|| isEmptyParameter('fail callback', callbackFail)) {
				return;
			}
			
			var parameters = new Object();
			parameters['key'] = extras.EXTRAS_API_KEY;
			parameters['funckey'] = request.funckey;
			parameters['id'] = request.id;
			// 적립일자+시간 기준(1:ASC(default), 2:DESC)
			if(request.sort != undefined && request.sort != null && request.sort != '') {
				parameters['sort'] = request.sort;
			}
			
			handleHttp("POST", "/fsc/stampcard/history/transfer", parameters, callbackSuccess, callbackFail);
		},
		
		// FSC-900-16 : 스탬프카드 이관내역 열람 업데이트
		transferHistoryOpen : function(request, callbackSuccess, callbackFail) {
			if(isEmptyParameter('id', request.id)
			|| isEmptyParameter('seqNo', request.seqNo)
			|| isEmptyParameter('success callback', callbackSuccess)
			|| isEmptyParameter('fail callback', callbackFail)) {
				return;
			}
			
			var parameters = new Object();
			parameters['key'] = extras.EXTRAS_API_KEY;
			parameters['id'] = request.id;
			parameters['seqNo'] = request.seqNo;
			
			handleHttp("PUT", "/fsc/stampcard/transfer/history/open", parameters, callbackSuccess, callbackFail);
		}
		
	}//~stampcard
}//~extras

// 필수 파라미터 체크
function isEmptyParameter(key, value) {
    if(value === undefined || value === null || value === '') {
    	alert(key +' is required');
        return true;
    }
	return false;
}

// 통신
function handleHttp(method, url, params, success, failed) {
	var xmlhttp;
	if(window.XMLHttpRequest) {
		xmlhttp = new XMLHttpRequest();
	}
	else {
		xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	}
	
	if(params === undefined) {
		params = {};
	}
	
	xmlhttp.onreadystatechange = function() {
		if(xmlhttp.readyState === 4) {
			if(xmlhttp.status === 200) {
				var response = JSON.parse(xmlhttp.response);
				if(response.resCd === "0000") {
					success(response.result);
				}
				else {
					failed(response.resCd, response.resMsg);
				}
			}
			else {
				alert(xmlhttp.status);
				
				var errorCode = "";
				var errorMsg = "";
				if(xmlhttp.response !== "" && xmlhttp.response !== undefined && xmlhttp.status !== 404) {
					var request = JSON.parse(xmlhttp.response);
					errorCode = request.resCd;
					errorMsg = request.resMsg;
				}
				
				failed(errorCode, errorMsg);
			}
		}
	}
	
	xmlhttp.open(method, extras.EXTRAS_SERVER_URL + url, true);
	
	xmlhttp.setRequestHeader("Content-type", "application/json");
	xmlhttp.setRequestHeader("Accept", "application/json");
	xmlhttp.setRequestHeader("Accept-Language", extras.EXTRAS_LANGUAGE_CODE);
	xmlhttp.setRequestHeader("Authorization", 'Basic ' + btoa(extras.EXTRAS_CLIENT_ID + ':' + extras.EXTRAS_CLIENT_SECRET));
	
	xmlhttp.send(JSON.stringify(params));
}