function hasStorage() {
    try {
        localStorage.setItem('test', 'test');
        localStorage.removeItem('test');
        return true;
    } catch (exception) {
        return false;
    }
}

function getEquipNo() {
    if (hasStorage()) {
        equipNo = localStorage.getItem('equipNo');
        
        if (equipNo === undefined || equipNo === null || equipNo === "") {
            equipNo = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
                var r = Math.random()*16|0, v = c === 'x' ? r : (r&0x3|0x8);
                return v.toString(16);
            });
        }

        localStorage.setItem('equipNo', equipNo);
        return equipNo;
    }
    else
        return "f6db9d72-bec3-4637-8c72-f1ea8914d5f6";
}

var API_KEY = "d12de3c70eb3f4ed683ebc208e40086b4";
//var CUST_ID = getEquipNo();
var CUST_ID = 'CSCHOI-99';
var FUNCKEY = "V00A001B001S0001FSC001";
//var FUNCKEY = "V00A001B038S0001FSC001";
//var FUNCKEY = "V00A001B039M00001S0001FSC001";
var ISSUE_NO = "";

var canStamp = true;           // Stamping on/off
var isCnclStamp = false;

var QueryString = function () {
    var query_string = {};
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i=0;i<vars.length;i++) {
        var pair = vars[i].split("=");
        // If first entry with this name
        if (typeof query_string[pair[0]] === "undefined") {
            query_string[pair[0]] = decodeURIComponent(pair[1]);
            // If second entry with this name
        } else if (typeof query_string[pair[0]] === "string") {
            var arr = [ query_string[pair[0]],decodeURIComponent(pair[1]) ];
            query_string[pair[0]] = arr;
            // If third or later entry with this name
        } else {
            query_string[pair[0]].push(decodeURIComponent(pair[1]));
        }
    } 
    return query_string;
}();

$(window).load(function() {
    echoss.initialize(API_KEY, echoss.REGION_CODE_TYPE.DEV);
    extras.initialize(API_KEY, echoss.REGION_CODE_TYPE.DEV, echoss.Common.LANGUAGE_CODE_TYPE.ENGLISH);
    
    $('.contents_body').css({
        "min-height": ($(window).height()-173) + "px"
    });
    
    var clipboard = new Clipboard('.clipboard');
	clipboard.on('success', function(e) {
		e.clearSelection();
		showAlert('popup_common', 'Notification', 'Copied to clipboard.');
	});
	clipboard.on('error', function(e) {
		e.clearSelection();
		showAlert('popup_common', 'Notification', 'Not copied to clipboard.');
	});
});

echoss.initializeSuccess = function() {
    
    echoss.setLanguageCode(echoss.Common.LANGUAGE_CODE_TYPE.ENGLISH);
    
    echoss.Icon.init();
    
    echoss.Icon.setOtpData(
        {
            aprvData    : makeEchossServiceApproveKey(OTP_DIV_CODE_SAVE_UP, CUST_ID, FUNCKEY),
            funcCd      : echoss.Icon.OTP_FUNC_CODE.STAMP_CARD,
            isuDivCd    : echoss.Icon.OTP_ISSUE_TYPE.COLLECT,
            cntYn       : "Y",
        }
        , otpSuccess
        , otpFailed
    );
    
    echoss.Icon.showIcon();
    
    echoss.Icon.enableStampingErrorMsg(true);
    
    echoss.Stamp.init(
        // 스탬프를 찍을 수 있는 경우
        function(locUseTyp) {
            requestBranchStampInfo();
        },
        // 스탬프를 찍을 수 없는 경우
        function(errorCode, errorMsg) {
            showAlert('popup_common', 'Notification', errorMsg + " (" + errorCode + ")");
        }
    );
}

/******************************************************
 * 						ECHOSS ICON
 ******************************************************/
var OTP_DIV_CODE_SAVE_UP = "1";
var OTP_DIV_CODE_CANCEL_SAVING_UP = "2";
var OTP_DIV_CODE_USE_COUPON = "3";
function makeEchossServiceApproveKey(otpStampType, custNo, funcKey, issuedCouponNo) {
	// 구분코드,고객번호,매장키,쿠폰발행번호
	// 구분코드 : 1:적립, 2:적립취소, 3:쿠폰사용
	var key = otpStampType + "," + custNo + "," + funcKey;
	if (issuedCouponNo != undefined) {
		key += ("," + issuedCouponNo);
	} else {
		key += ("," + "0"); 
	}
	return key;
}
var otpSuccess = function() {
	echoss.Icon.clseGuideView();
	// 적립
    if (!$('.popup_coupon_wrapper').is(":visible") && !$('.alert_pop_stamp_cancel').is(":visible")) {
		requestBranchStampInfo();
		isCnclStamp = false;
	}
	// 적립취소
	else if ($('.alert_pop_stamp_cancel').is(":visible")) {
		hidePopupView('alert_pop_stamp_cancel');		
        showAlert('popup_common', 'Notification', "Accumulated stamp has been canceled.", 'requestBranchStampInfo');

        echoss.Icon.setOtpData(
                {
                    aprvData    : makeEchossServiceApproveKey(OTP_DIV_CODE_SAVE_UP, CUST_ID, FUNCKEY),
                    funcCd      : echoss.Icon.OTP_FUNC_CODE.STAMP_CARD,
                    isuDivCd    : echoss.Icon.OTP_ISSUE_TYPE.COLLECT,
                    cntYn       : "Y",
                }
                , otpSuccess
                , otpFailed
            );

        requestBranchStampInfo();
        isCnclStamp = true;
	}
	// 쿠폰 사용
	else if ($('.popup_coupon_wrapper').is(":visible") ) {
		$(".popup_coupon_complete").show();
        echoss.Icon.hideIcon();
        requestBranchStampInfo();
        isCnclStamp = false;
	}
}

var otpFailed = function(code, message) {
}

function requestBranchStampInfo() {
    showLoading();
    
    // Add Stampcard And Get Stampcard Detail Info
    echoss.Stampcard.addAndGetDetailinfo ({
        id          : CUST_ID, 
        funckey     : FUNCKEY
    }, function(result) {
    	console.log(result);
    	
        hideLoading();
        hisTransfer();
        reloadBranchStampInfo(result);
    }, function(errorCode, errorMessage) {
        hideLoading();
        showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
    });
}

var jsonData = null;
var hisData = null;
var checkNewPosArray = null;
var bCanCancelSavingUp = true;
var accuCnt = 0;
var reloadBranchStampInfoByStamping = false;	// for 'N' mark

function reloadBranchStampInfo(result) {
    if (checkNewPosArray == null) {
        var maxStampCount = 50;
        checkNewPosArray = new Array(maxStampCount);
        for (var i = 0; i < maxStampCount; i++) {
            checkNewPosArray[i] = 0;
        }
    }
    
    jsonData = result;
    accuCnt = jsonData.accuCount;
    
    $(".detail_info_title").html(jsonData.cardName);
    $(".detail_info_sub_title").html(jsonData.description);
    $(".detail_info_sub_title").show();
    $(".coupon_guide_right").html(jsonData.benefit);
    $(".stamp_card_num").val(jsonData.cardNo);

    if (jsonData.bgImgUrl == undefined || jsonData.bgImgUrl == '' || jsonData.bgImgUrl.length == 0) {
        $('.wrapper').css({
            'background': 'none',
            'background-color': '#ffffff'
        });
    } else {
        $('.wrapper').css({
            'background': 'url("' + jsonData.bgImgUrl + '") top left no-repeat',
            'background-size': '100% auto',
            'background-color': '#ffffff'
        });
    }

    var html = '<ul>';
    
    if (reloadBranchStampInfoByStamping && accuCnt > 0) {
    	reloadBranchStampInfoByStamping = false;
        for (var i = accuCnt - 1; i < checkNewPosArray.length; i++) {
            checkNewPosArray[i] = 0;
        }
        checkNewPosArray[accuCnt - 1] = 1;
    }
    
    var status = "";
    for (var i = 0 ; i < 50 ; i++) {
    	status += (checkNewPosArray[i] + ' ');
    }

    bCanCancelSavingUp = accuCnt > 0;
    for (var i = 0; i < jsonData.allCount; i++) {
        html += '	<li class="detail_area">';
        
        var indexedCpnInfo = null;
        for (var j = 0; j < jsonData.cardCpnList.length; j++) {
            var cpnObj = jsonData.cardCpnList[j];
            if (i == cpnObj.no - 1) {
                indexedCpnInfo = cpnObj;
                break;
            }
        }
        
        if (i < accuCnt) {
            if (indexedCpnInfo !== null)
                html += '<div class="stamp_mark coupon" style="background-image:url(\'' + cpnObj.onImgUrl + '\');">';
            else
                html += '<div class="stamp_mark on">';
            html += (checkNewPosArray[i] == 0 && isCnclStamp) ? '' : '<div class="new_badge"></div>';
            html += '	</div>';
            
        } else {
            if (indexedCpnInfo !== null)
                html += '<div class="stamp_mark coupon" style="background-image:url(\'' + cpnObj.offImgUrl + '\');">';
            else
                html += '<div class="stamp_mark off"></div>';
        }
        html += '</li>';

        if(i%5 == 4 && i+1 != jsonData.allCount) {
            html += '</br>';
        }
    }
    html += '</ul>';
    $(".stamp_area").html(html);

    $(".stamp_mark.off").css('background-image', 'url("' + jsonData.accuOffImgUrl + '")');
    $(".stamp_mark.on").css('background-image', 'url("' + jsonData.accuOnImgUrl + '")');
    
    var html = "";
    if (jsonData.custCpnList.length > 0) {
        for (var i = 0; i < jsonData.custCpnList.length; i++) {
            var issuedCpnInfo = jsonData.custCpnList[i];
            var cpnImgUrl = issuedCpnInfo.imgUrl;

            html += '<li class="coupon_div button" onclick="clickViewCouponDetail('+i+');return false;">';
            html += 		'<img class="coupon_img" src="'+cpnImgUrl+'" />';
            html += 		'<div class="coupon_brief_info">';
            html += 			'<p class="coupon_brief_info_title">' + issuedCpnInfo.name + '</p>';
            html += 			'<p class="coupon_brief_info_subtext"><span class="coupon_brief_info_subtitle">Issued date</span>' + dateStringWithDelim(issuedCpnInfo.issueDate, '-') + '</p>';
            html += 			'<p class="coupon_brief_info_subtext"><span class="coupon_brief_info_subtitle">Expiry date</span>' + dateStringWithDelim(issuedCpnInfo.expDate, '-', 'No expiry date') + '</p>';
            html +=			'</div>';
            html += 	'</li>';
        }
    }
    else {
        html += '<li class="coupon_brief_info_nostamp"><span>No coupon collected.</span></li>';
    }
    $(".contents_coupon_list").html(html);

  	canStamp = true;
    	
    if (jsonData.cpnIsuYn == true) {
        showAlert('popup_common', 'Notification', "You received a coupon.");
        jsonData.cpnIsuYn = false;
        return;
    }
}

function onHideCouponDetail() {
    echoss.Icon.setOtpData(
            {
                aprvData    : makeEchossServiceApproveKey(OTP_DIV_CODE_SAVE_UP, CUST_ID, FUNCKEY),
                funcCd      : echoss.Icon.OTP_FUNC_CODE.STAMP_CARD,
                isuDivCd    : echoss.Icon.OTP_ISSUE_TYPE.COLLECT,
                cntYn       : "Y",
            }
            , otpSuccess
            , otpFailed
        );

	echoss.Icon.showIcon();
    requestBranchStampInfo();
}


/******************************************************
 * 						STAMPING                      *
 ******************************************************/

/* Stamping Error */
echoss.Stamp.onError = function(code, message) {
    if (!canStamp || $('.popup_common').is(":visible") || ($('.popup_area').is(":visible") && !$('.alert_pop_stamp_cancel').is(":visible")))
        return;
    else
        showAlert('popup_common', 'Notification', message);
}

/* Stamping Success */
echoss.Stamp.onStamp = function(stampParams) {
    if (!canStamp || $('.popup_common').is(":visible") || ($('.popup_area').is(":visible") && !$('.alert_pop_stamp_cancel').is(":visible")))
        return;
    
    if (!$('.popup_coupon_wrapper').is(":visible") && !$('.alert_pop_stamp_cancel').is(":visible")) {
        canStamp = false;

        playSound();

        startStampAnimation();

        setTimeout(function() {
            // Collect Stamp
            echoss.Stampcard.collect ({
                    id          : CUST_ID,     
                    funckey     : FUNCKEY,
                    stampParams : stampParams,
                    sno         : '2'
            }, function(result) {
                    stopStampAnimation();
                    reloadBranchStampInfoByStamping = true;	// for 'N' mark
                    reloadBranchStampInfo(result);
            }, function(errorCode, errorMessage) {
                    stopStampAnimation();
                    if (errorCode !== echoss.Icon.HANDLE_ERROR_BY_ICON_CODE) {
                        showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
                    }
            });

            canStamp = true;
            isCnclStamp = false;
        }, 500);
    }
    else if ($('.popup_coupon_wrapper').is(":visible") ) {
        if( $("#useCompleteMark").is(":visible") )
            return;
        
        canStamp = false;
        playSound();
        startStampAnimation();
        setTimeout(function() {
            // Use Coupon
            echoss.Stampcard.useCoupon ({
                id          : CUST_ID,
                funckey     : FUNCKEY,
                issueNo     : ISSUE_NO,
                stampParams : stampParams
            }, function(result) {
                echoss.Stampcard.addAndGetDetailinfo ({
                    id          : CUST_ID,
                    funckey     : FUNCKEY
                }, function(result) {
                    stopStampAnimation();
                    $(".popup_coupon_complete").show();

                    hideLoading();
                    reloadBranchStampInfo(result);
                }, function(errorCode, errorMessage) {
                    stopStampAnimation();
                    $(".popup_coupon_complete").show();

                    hideLoading();
                    showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
                });
            }, function(errorCode, errorMessage) {
                stopStampAnimation();
                if (errorCode !== echoss.Icon.HANDLE_ERROR_BY_ICON_CODE) {
                    showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
                }
            });
                   
            canStamp = true;
            isCnclStamp = false;
        }, 500);
    }
    else if ($('.alert_pop_stamp_cancel').is(":visible")) {
        if(accuCnt == 0)
            return;
        
        canStamp = false;
        startStampAnimation();
        setTimeout(function() {
            // Cancel Collecting
            echoss.Stampcard.cancelCollecting ({
                id 		    : CUST_ID,
                funckey 	: FUNCKEY,
                stampParams : stampParams
            }, function(result) {
                stopStampAnimation();
                hidePopupView('alert_pop_stamp_cancel');
                reloadBranchStampInfo(result);
            }, function(errorCode, errorMessage) {
                stopStampAnimation();
                hidePopupView('alert_pop_stamp_cancel');
                if (errorCode !== echoss.Icon.HANDLE_ERROR_BY_ICON_CODE) {
                    showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
                }
            });
                   
            canStamp = true;
            isCnclStamp = true;
        }, 500);
    }
}


/******************************************************
 * 						Coupon Detail
 ******************************************************/
function clickViewCouponDetail(key) {
    var issuedCpnInfo = jsonData.custCpnList[key];
    ISSUE_NO = issuedCpnInfo.issueNo;
    
    var selectedCpnInfo = null;
    for (var i = 0 ; i < jsonData.cardCpnList.length ; i++) {
        var cpnInfo = jsonData.cardCpnList[i];
        if (issuedCpnInfo.code === cpnInfo.code) {
            selectedCpnInfo = cpnInfo;
            break;
        }
    }
    
    echoss.Icon.setOtpData(
        {
            aprvData    : makeEchossServiceApproveKey(OTP_DIV_CODE_USE_COUPON, CUST_ID, FUNCKEY, ISSUE_NO),
            funcCd      : echoss.Icon.OTP_FUNC_CODE.STAMP_CARD,
            isuDivCd    : echoss.Icon.OTP_ISSUE_TYPE.USE_COUPON,
            cntYn       : "N"
        }
        , otpSuccess
        , otpFailed
    );

    viewCouponDetail(issuedCpnInfo, issuedCpnInfo, jsonData.name);
}

/******************************************************
 * 						Cancel Stamp
 ******************************************************/
function doStampCancel() {
    if (!bCanCancelSavingUp) {
        showAlert('popup_common', 'Notification', 'You have no stamp.');
        return;
    }
    
    echoss.Icon.setOtpData(
        {
            aprvData    : makeEchossServiceApproveKey(OTP_DIV_CODE_CANCEL_SAVING_UP, CUST_ID, FUNCKEY),
            funcCd      : echoss.Icon.OTP_FUNC_CODE.STAMP_CARD,
            isuDivCd    : echoss.Icon.OTP_ISSUE_TYPE.CANCEL_COLLECT,
            cntYn       : "N",
        }
        , otpSuccess
        , otpFailed
    );
    
    showPopupView('alert_pop_stamp_cancel');
}

function closeCancel() {
    echoss.Icon.setOtpData(
        {
            aprvData    : makeEchossServiceApproveKey(OTP_DIV_CODE_SAVE_UP, CUST_ID, FUNCKEY),
            funcCd      : echoss.Icon.OTP_FUNC_CODE.STAMP_CARD,
            isuDivCd    : echoss.Icon.OTP_ISSUE_TYPE.COLLECT,
            cntYn       : "Y",
        }
        , otpSuccess
        , otpFailed
    );
}

/******************************************************
 * 						Stamp List
 ******************************************************/
function viewStampList() {
	showPopupView('stamp_list');
}

function closeStampList() {
	canStamp = true;
	 $('.stamp_list').hide();
}

function dateStringWithDelim(dateStr, delim, defaultStr) {
    if (defaultStr != undefined && dateStr.length <= 0)
        return defaultStr;
    var dateString = "";
    var year = dateStr.substr(0, 4);
    var month = dateStr.substr(4, 2);
    var day = dateStr.substr(6, 2);
    
    dateString = year + delim + month + delim + day;
    return dateString;
}

function dateTimeConvert2(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(0, 4);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);
    }
    
    return str1 + delim + str2 + delim + str3;
}

function dateTimeConvert3(str, type, delim) {
    var str1 = "";
    var str2 = "";
    var str3 = "";
    if (type == 'date') {
        str1 = str.substr(2, 2);
        str2 = str.substr(4, 2);
        str3 = str.substr(6, 2);
        return str1 + delim + str2 + delim + str3;
    } else {
        str1 = str.substr(0, 2);
        str2 = str.substr(2, 2);
        str3 = str.substr(4, 2);
        return str1 + delim + str2;
    }
}

/******************************************************
 * 						Transfer
 ******************************************************/
// 선물 팝업
function showPopupView(className, message, info, val) {
	canStamp = false;
	echoss.Icon.hideIcon();
	
	var html = '';
	if(!$('.popup_area').is(':visible') || $('.popup_area.alert_present').is(':visible')) {
		if(className !== 'receive_present') {
			$('.popup_area').remove();
			html += '<div class="popup_area">';
		}
	}
	
	if(className === 'gift_send') {
        html += '<div class="dimmed flex_center">';
        html += '  <div class="popup gift_send_pop">';
        html += '    <div class="popup_con_gift flex_column_center">';
        html += '      <p>Gifting Stamp</p>';
        html += '      <ul class="gift_menu flex_between_center">';
        html += '        <li class="on">';
        html += '          <a href="javascript:void(0)">Stamp</a>';
        html += '        </li>';
        html += '        <li>';
        html += '          <a href="javascript:void(0)">Coupon</a>';
        html += '        </li>';
        html += '      </ul>';
        html += '      <ul class="gift_content">';
        
        html += '        <li class="flex_column_center show">';
        html += '          <p class="notice">';
        html += '             Give a stamp to your friend\'s<br/>stamp card number.';
        html += '          </p>';
        html += '          <div class="number_box flex_center">';
        html += '            <input type="number" name="stpCardNo" placeholder="Stamp Card No."/>';
        html += '          </div>';
        html += '          <div class="select_number flex_between_center">';
        html += '            <p class="h3">Gift available Stamps</p>';
        html += '            <div class="flex_row_center">';
        html += '              <img class="btn_number" onclick="numDec();" src="images/btn/btn_minus.png"/>';
        
        var giftCnt = Number(jsonData.accuCount);
        if(giftCnt == 0) {
        	html += '              <input class="number" type="number" name="stpSendCnt" readonly disabled value="'+ giftCnt +'"/>';
        	html += '              <img class="btn_number opac" src="images/btn/btn_plus.png"/>';
        }
        else {
        	var tempCnt = 0;
        	if(jsonData.cardCpnList.length > 0) {
        		for(var i=0; i < jsonData.cardCpnList.length; i++) {
        			var no = Number(jsonData.cardCpnList[i].no);
        			if(no > tempCnt) {
        				if(giftCnt < no) {
        					break;
        				}
        				else {
        					tempCnt = no;
        				}
        			}
        		}
        	}
        	console.log("giftCnt : "+giftCnt+" / tempCnt : "+tempCnt);
        	giftCnt = Number(giftCnt - tempCnt);
        	
        	html += '              <input class="number" type="number" name="stpSendCnt" readonly disabled value="'+ giftCnt +'"/>';
        	html += '              <img class="btn_number" onclick="numAdd('+ giftCnt +');" src="images/btn/btn_plus.png"/>';
        }
        
        html += '            </div>';
        html += '          </div>';
        html += '          <p class="tip">';
        html += '            · Stamp / Coupon gifts can not be returned.<br/>';
        html += '            · Please input correct Stamp Card NO.';
        html += '          </p>';
        html += '        </li>';
        
        html += '        <li class="flex_column_center">';
        html += '          <p class="notice">';
        html += '            Give a Coupon to your friend\'s<br/>stamp card number.';
        html += '          </p>';
        html += '          <div class="number_box flex_center">';
        html += '            <input type="number" name="cpnCardNo" placeholder="Stamp Card No."/>';
        html += '          </div>';
        html += '          <div class="number_box select_box flex_center" onclick="showPopupView(\'gift_option_popup\');">';
        html += '            <input type="hidden" name="cpnIssueNo"/>';
        html += '            <input class="select_coupon_input" readonly disabled placeholder="Select the Coupon."/>';
        html += '            <img class="btn_down" src="images/btn/btn_down.png"/>';
        html += '          </div>';
        html += '          <p class="tip">';
        html += '            · Stamp / Coupon gifts can not be returned.<br/>';
        html += '            · Please input correct Stamp Card NO.';
        html += '          </p>';
        html += '        </li>';
        html += '        <li class="flex_column_center">';
        html += '          <div class="gift_send_content">';
        html += '            <p>To <span class="card_num">Stamp card NO.<span class="card_sender"></span></span><br/>';
        html += '            <span class="gift_num">Coupon 1</span> will send for a gift.</p>';
        html += '          </div>';
        html += '          <p class="notice">';
        html += '            Gifts sent can not be returned.<br/>';
        html += '            Do you want to send it?';
        html += '          </p>';
        html += '        </li>';
        
        html += '      </ul>';
        html += '    </div>';
        html += '    <ul class="popup_btn flex_between_center">';
        html += '      <li class="btn_left">';
        html += '        <a href="javascript:void(0);" onclick="hidePopupView(\''+ className +'\');">Cancel</a>';
        html += '      </li>';
        html += '      <li>';
        html += '        <a href="javascript:void(0);" onclick="sendGift('+ giftCnt +');">Send</a>';
        html += '      </li>';
        html += '    </ul>';
        html += '  </div>';
        html += '</div>';
        html += '</div>';
        
        $(html).insertAfter('.popup_common');
        
        $('.gift_menu a').on('click', function() {
            var menuIdx = $('.gift_menu a').index($(this));
            $('.gift_menu li').eq(menuIdx).addClass('on').siblings().removeClass('on');
            $('.gift_content li').eq(menuIdx).addClass('show').siblings().removeClass('show');
        });
	}
	else if(className === 'gift_option_popup') {
        html += '<div class="dimmed dimmed_gift_option_popup" onclick="hidePopupView(\'dimmed_gift_option_popup\');">';
        html += '  <div class="gift_option">';
        html += '    <ul class="coupon_list">';
        
        if(jsonData.custCpnList.length > 0) {
			for(var i = jsonData.custCpnList.length - 1; i >= 0; i--) {
				var obj = jsonData.custCpnList[i];
				
				html += '      <li>';
				html += '        <a data-issueNo="'+ obj.issueNo +'">'+ obj.name +'</a>';
				html += '      </li>';
			}
        }
        else {
        	html += '      <li>';
        	html += '        <p>There is no coupon to gift.</p>';
        	html += '      </li>';
        }
        
        html += '    </ul>';
        html += '  </div>';
        html += '</div>';
        
        $('.popup_area').append(html);
        $('.popup_area').addClass(className);
        $('.dimmed_gift_option_popup').fadeIn();
        
        $('.gift_option li a').on('click', function() {
            var optionIdx = $('.gift_option li a').index($(this));
            var text = $('.gift_option li a').eq(optionIdx).text();
            var value = $('.gift_option li a').eq(optionIdx).attr('data-issueNo');
            
            $('.select_coupon_input').val(text);
            $('input[name=cpnIssueNo]').val(value);
        });
    	
    	return;
	}
	else if(className === 'alert_present') {
        html += '<div class="dimmed flex_center">';
        html += '  <div class="popup alert_pop">';
        html += '    <p>';
        html += '      Sending  is complete.<br/>';
        html += '      Please check History for details.';
        html += '    </p>';
        html += '    <ul class="popup_btn flex_between_center">';
//        html += '      <li class="btn_left">';
//        html += '        <a href="javascript:void(0);" onclick="hidePopupView(\''+ className +'\');">Cancel</a>';
//        html += '      </li>';
        html += '      <li>';
        html += '        <a href="javascript:void(0);" onclick="hidePopupView(\''+ className +'\');">Confirm</a>';
        html += '      </li>';
        html += '    </ul>';
        html += '  </div>';
        html += '</div>';
        html += '</div>';
        
        $(html).insertAfter('.popup_common');
	}
	else if(className === 'stamp_list') {
		html += '<div class="dimmed flex_center">';
		html += '	<div class="popup stamp_list_pop">';
		html += '	  <div class="popup_con_history">';
		html += '	    <p>';
		html += '	      <strong>History</strong>';
		html += '	    </p>';
		html += '	    <div class="stamp_list_pop_info">';
		html += '	      <div class="flex_center">';
		html += '	        <p class="pop_list_title">Collect stamps</p>';
		
		var accuCnt = 0;
		if(jsonData.accuList.length > 0) {
			for(var i = jsonData.accuList.length - 1; i >= 0; i--) {
				accuCnt++;
			}
		}
		html += '	        <p class="pop_list_cont"><strong>'+ accuCnt +'</strong>/'+ jsonData.allCount +'</p>';
		
		html += '	      </div>';
		html += '	    </div>';
		html += '	    <div class="stamp_list_pop_cont">';
		html += '	      <table class="stamp_list_table">';
		html += '	        <colgroup>';
		html += '	          <col style="width: 13%;"/>';
		html += '	          <col style="width: 14%;"/>';
		html += '	          <col style="width: 14%;"/>';
		html += '	          <col style="width: 29%;"/>';
		html += '	          <col style="width: 30%;"/>';
		html += '	        </colgroup>';
		html += '	        <thead>';
		html += '	          <tr>';
		html += '	            <th scope="col">No.</th>';
		html += '	            <th scope="col">Sort</th>';
		html += '	            <th scope="col">Count</th>';
		html += '	            <th scope="col">Store</th>';
		html += '	            <th scope="col">Date</th>';
		html += '	          </tr>';
		html += '	        </thead>';
		html += '	        <tbody>';
		
		console.log(hisData);
		if(hisData.historyList.length > 0) {
			var gridCnt = 0;
			var hisLength = 0;
			for(var i = 0; i < hisData.historyList.length; i++) {
				var obj = hisData.historyList[i];
				if(obj.trsfCpnList.length > 0) {
					continue;
				}
				hisLength++;
			}
			for(var i = 0; i < hisData.historyList.length; i++) {
				var obj = hisData.historyList[i];
				
				if(obj.trsfCpnList.length > 0) {
					continue;
				}
				
				html += '<tr>';
				html += '	<td>'+ hisLength--; +'</td>';
				
				if(obj.divCd === '6' || obj.divCd === '7') {
					html += '<td>Gift</td>';
				}
				else {
					html += '<td>Collect</td>';
				}
				
				if(obj.divCd === '7') {
					html += '<td>-'+ obj.count +'</td>';
				}
				else {
					html += '<td>+'+ obj.count +'</td>';
				}
				
				html += '	<td>'+ obj.name +'</td>';
				html += '	<td style="text-align: left">';
				html += '		<p>'+ dateTimeConvert3(obj.date , 'date', '-') +'</p>';
				html += '		<p>'+ dateTimeConvert3(obj.time , 'time', ':') +'</p>';
				html += '	</td>';
				html += '</tr>';
				
				gridCnt++;
			}
			
			if(gridCnt == 0) {
				html += '<tr>';
				html += '	<td colspan="5">There is no history.</td>';
				html += '</tr>';
			}
		}
		else {
			html += '<tr>';
			html += '	<td colspan="5">There is no history.</td>';
			html += '</tr>';
		}
		
		html += '	        </tbody>';
		html += '	      </table>';
		html += '	    </div>';
		html += '	  </div>';
		html += '	  <ul class="popup_btn">';
		html += '	    <li><a href="javascript:void(0);" onclick="hidePopupView(\''+ className +'\');">Confirm</a></li>';
		html += '	  </ul>';
		html += '	</div>';
		html += '</div>';
		html += '</div>';
		
		$(html).insertAfter('.popup_common');
	}
	else if(className === 'receive_present') {
		var idx = $('.receive_present').length;
		
		html += '<div class="popup_area receive_present idx_'+ idx +'">';
        html += '<div class="dimmed flex_center">';
        html += '  <div class="popup receive_pop">';
        html += '    <div class="popup_con_receive flex_column_center">';
        html += '      <img src="images/gift.png"/>';
        html += '      <p class="title">Gift arrived.</p>';
        html += '      <p class="content">From <span class="card_num">Stamp card NO.'+ message +'</span><br/>';
        html += '        <span class="gift_num">'+ info +'</span> gift has arrived.<br/>';
        html += '        Please check History for details.';
        html += '      </p>';
        html += '    </div>';
        html += '    <ul class="popup_btn">';
        html += '      <li>';
        html += '        <a href="javascript:void(0);" onclick="hidePopupView(\'idx_'+ idx +'\');hisTransferOpen('+ val +');">Confirm</a>';
        html += '      </li>';
        html += '    </ul>';
        html += '  </div>';
        html += '</div>';
        html += '</div>';
        
        $(html).insertAfter('.popup_common');
        
        $('.idx_'+idx).fadeIn();
        return;
	}
	else if(className === 'alert_pop_stamp_cancel') {
		canStamp = true;
		echoss.Icon.showIcon();
		
		html += '<div class="dimmed"></div>';
		html += '<div class="popup cancel_pop">';
		html += '	<div class="popup_con stamp_cancel_popup_con">';
		html += '		<strong>To cancel collecting,</br>put the stamp</br>on your smartphone.</strong>';
		html += '		<br>';
		html += '		<p>The most recent collecting</br>will be canceled.</p>';
		html += '		<img class="img_stamping_png" src="images/icon/stamping.png">';
		html += '	</div>';
		html += '	<ul class="popup_btn">';
		html += '		<li><a href="javascript:void(0);" onclick="hidePopupView(\''+ className +'\');closeCancel();">Close</a></li>';
		html += '	</ul>';
		html += '</div>';
		html += '</div>';
		
		$(html).insertAfter('.popup_common');
	}
	else if(className === 'alert_message') {
        html += '<div class="dimmed flex_center dimmed_alert_message">';
        html += '  <div class="popup alert_pop">';
        html += '    <p>'+ message +'</p>';
        html += '    <ul class="popup_btn flex_between_center">';
        html += '      <li class="btn_center">';
        html += '        <a href="javascript:void(0);" onclick="hidePopupView(\'dimmed_alert_message\');">Confirm</a>';
        html += '      </li>';
        html += '    </ul>';
        html += '  </div>';
        html += '</div>';
        html += '</div>';
        
        $('.popup_area').append(html);
	}
	
	$('.popup_area').addClass(className);
	$('.'+className).fadeIn();
}

function hidePopupView(className) {
	$('.'+className).fadeOut();

	if(!$('.popup_area').is(':visible') || className === 'stamp_list' || className === 'gift_send' || className === 'alert_present' || className === 'receive_present' || className.indexOf("idx_") > -1) {
		canStamp = true;
		echoss.Icon.showIcon();
	}
}

// 선물 발송
var IS_TRANSFER = true;
var TO_ID = "";
var TO_VAL = "";
function sendGift(giftCnt) {
    var giftContentIdx = $('.gift_content li').index($('.gift_content li.show'));
    
    // 적립 선물
    if(giftContentIdx === 0) {
    	if(giftCnt == 0) {
    		showPopupView('alert_message', 'There is no stamp to give.');
    		return;
    	}
    	
    	if($('input[name=stpCardNo]').val() == null || $('input[name=stpCardNo]').val() == '') {
    		showPopupView('alert_message', 'Please input Stamp Card NO.');
    		return;
    	}
    	
    	$('.card_sender').html($('input[name=stpCardNo]').val());
    	$('.gift_num').html('Stamp '+ $('input[name=stpSendCnt]').val());
    	
    	IS_TRANSFER = true;
    	TO_ID = $('input[name=stpCardNo]').val();
    	TO_VAL = $('input[name=stpSendCnt]').val();
    }
    // 쿠폰 선물
    else if(giftContentIdx === 1) {
    	if($('input[name=cpnCardNo]').val() == null || $('input[name=cpnCardNo]').val() == '') {
    		showPopupView('alert_message', 'Please input Stamp Card NO.');
    		return;
    	}
    	if($('input[name=cpnIssueNo]').val() == null || $('input[name=cpnIssueNo]').val() == '') {
    		showPopupView('alert_message', 'Please select Coupon.');
    		return;
    	}
    	
    	var isResend = false;
    	var cpnShortNo = null;
    	var cpnCardNo = $('input[name=cpnCardNo]').val();
    	var issueNo = $('input[name=cpnIssueNo]').val();
    	
    	console.log("cpnCardNo : "+cpnCardNo);
    	console.log("issueNo : "+issueNo);
    	if(jsonData.custCpnList.length > 0) {
    		console.log("custCpnList");
    		for(var i=0; i < jsonData.custCpnList.length; i++) {
    			var custCpnList = jsonData.custCpnList[i];
    			if(custCpnList.issueNo == issueNo) {
    				cpnShortNo = custCpnList.cpnShortNo;
    				console.log("cpnShortNo : " + cpnShortNo);
    				break;
    			}
    		}
    	}
    	if(hisData.historyList.length > 0) {
    		console.log("historyList");
    		for(var i=0; i < hisData.historyList.length; i++) {
    			var historyList = hisData.historyList[i];
    			if(historyList.divCd == '6' && historyList.trsfCpnList.length > 0) {
    				console.log("historyList.trsfCpnList.length : " + historyList.trsfCpnList.length);
    				for(var j=0; j < historyList.trsfCpnList.length; j++) {
    					var trsfCpnList = historyList.trsfCpnList[j];
    					console.log("cpnShortNo : " + cpnShortNo);
    					console.log("trsfCpnList.cpnShortNo : " + trsfCpnList.cpnShortNo);
    					console.log("historyList.name : " + historyList.name);
    					console.log("cpnCardNo : " + cpnCardNo);
    					if(cpnShortNo == trsfCpnList.cpnShortNo && historyList.name == cpnCardNo) {
    						isResend = true;
    						break;
    					}
    				}
    			}
    		}
    	}
    	
    	console.log(isResend);
    	
    	if(isResend) {
    		showPopupView('alert_message', 'Stamp/Coupon gifts can not be returned.');
    		return;
    	}
    	
    	$('.card_sender').html($('input[name=cpnCardNo]').val());
    	$('.gift_num').html($('.select_coupon_input').val());
    	
    	IS_TRANSFER = false;
    	TO_ID = $('input[name=cpnCardNo]').val();
    	TO_VAL = $('input[name=cpnIssueNo]').val();
    }

    if(giftContentIdx < 2) {
        $('.gift_content li').eq(2).addClass('show').siblings().removeClass('show');
    }
    else if(giftContentIdx === 2) {
    	$('.gift_send').fadeOut();
    	$('.popup_area').remove();
    	getCustTransfer();
    }
}

// 스탬프 카드번호 고객 조회
function getCustTransfer() {
	showLoading();
	extras.stampcard.transferCardno({
		funckey 	: FUNCKEY,
		cardNo 		: TO_ID
	}, function(result) {
		if(result.id == null || result.id == '') {
			hideLoading();
			showAlert('popup_common', 'Notification', "Please check your friend's stamp card number.");
			return;
		}
		
		if(IS_TRANSFER) {
    		doStampTransfer(result.id);
    	}
    	else {
    		doCouponTransfer(result.id);
    	}
	}, function(errorCode, errorMessage) {
		hideLoading();
		showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
	});
}

// 스탬프 적립 이관
function doStampTransfer(toId) {
	extras.stampcard.transferStamps({
		funckey 	: FUNCKEY,
		fromId 		: CUST_ID,
		toId 		: toId,
		transferCnt : TO_VAL
	}, function(result) {
		resTransfer(result);
	}, function(errorCode, errorMessage) {
		hideLoading();
		showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
	});
}

// 쿠폰 이관
function doCouponTransfer(toId) {
	extras.stampcard.transferCoupon({
		funckey : FUNCKEY,
		fromId 	: CUST_ID,
		toId 	: toId,
		issueNo : TO_VAL
	}, function(result) {
		resTransfer(result);
	}, function(errorCode, errorMessage) {
		hideLoading();
		showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
	});
}

// 선물 결과
function resTransfer(result) {
	hideLoading();
	requestBranchStampInfo();
	showPopupView('alert_present');
}

// 이관 전체 내역 조회
function hisTransfer() {
	showLoading();
	extras.stampcard.historyTransfer({
		funckey : FUNCKEY,
		id 		: CUST_ID,
		sort 	: "2"
	}, function(result) {
		hisData = result;
		hideLoading();
		
		if(result.historyList.length > 0) {
			for(var i = 0; i < result.historyList.length; i++) {
				var obj = result.historyList[i];
				if(obj.divCd === '6' && obj.openYn === 'N') {
					if(obj.trsfCpnList.length > 0) {
						showPopupView('receive_present', obj.name, 'Coupon '+obj.trsfCpnList[0].name, obj.seqNo);
					}
					else {
						showPopupView('receive_present', obj.name, 'Stamp '+obj.count, obj.seqNo);
					}
				}
			}
	    }
	}, function(errorCode, errorMessage) {
		hideLoading();
		showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
	});
}

// 내역 확인
function hisTransferOpen(seqNo) {
	showLoading();
	extras.stampcard.transferHistoryOpen({
		id 		: CUST_ID,
		seqNo 	: seqNo
	}, function(result) {
		
	}, function(errorCode, errorMessage) {
		hideLoading();
		showAlert('popup_common', 'Notification', errorMessage + " (" + errorCode + ")");
	});
}