var TEST_MODE = true; // 테스트 모드(true:테스트, false:상용)

(function (VC, $, undefined) {

    // 상품 조회 (goods_code 가 있으면 단일조회)
    VC.A001 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.order_no  		    = request.order_no;
        params.goods_code           = request.goods_code;
        params.ext_id               = request.ext_id;

        handleAjax("POST", SERVER_URL+"/goods/issue/trxList", params, callbackSuccess, callbackFail);
    }

    // 상품 사용 (STAMP와 OTP동시 사용)
    VC.A002 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.ticket_type)
         || isEmptyParameter(request.cid)
         || isEmptyParameter(request.auth_div_cd)
         || isEmptyParameter(request.tickets)
         || isEmptyParameter(request.deal_yn)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.ticket_type          = request.ticket_type;  //티켓타입
        params.cid                  = request.cid;          //고객ID
        params.auth_div_cd          = request.auth_div_cd;  //인증 구분 1:스탬프, 2:OTP
        params.brand_id             = request.brand_id;     // 사용브랜드ID
        params.brand_name           = request.brand_name;     // 사용브랜드ID
        params.mcnt_id              = request.mcnt_id;     // 사용브랜드ID
        params.mcnt_name            = request.mcnt_name;     // 사용브랜드ID
        params.tickets              = request.tickets;      // 티켓리스트
        params.stamp_no             = request.stamp_no;      // 스탬프 번호
        params.deal_yn              = request.deal_yn;      // 딜여부

        handleAjax("POST", SERVER_URL+"/goods/multi/use", params, callbackSuccess, callbackFail);
    }

    // FB연동
    VC.A003 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.order_no)
         || isEmptyParameter(request.ticket_type)
         || isEmptyParameter(request.userID)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.order_no             = request.order_no;     // 거래번호
        params.ticket_type          = request.ticket_type;  // 티켓타입
        params.goods                = request.goods;        // 상품(List<Object>
        params.ext_id               = request.userID;       // FB USERID

        handleAjax("POST", SERVER_URL+"/goods/ext/cpnLink", params, callbackSuccess, callbackFail);
    }

    // 리스트 노출여부 변경
    VC.A004 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.ticket_type)
         || isEmptyParameter(request.ticket_info)     // 티켓번호 또는 핀번호
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.ticket_type          = request.ticket_type;
        params.ticket_info          = request.ticket_info;

        handleAjax("POST", SERVER_URL+"/goods/changeDisp", params, callbackSuccess, callbackFail);
    }

    // 북상품 조회 (goods_code 가 있으면 단일조회)
    VC.A005 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.order_no  		= request.order_no;
        params.goods_code       = request.goods_code;
        params.goods_seq_no     = request.goods_seq_no;
        params.ext_id           = request.ext_id;

        handleAjax("POST", SERVER_URL+"/books/issue/trxList", params, callbackSuccess, callbackFail);
    }

    // STAMP인증
    VC.A006 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.eq)
         || isEmptyParameter(request.s)
         || isEmptyParameter(request.p)
         || isEmptyParameter(request.c)
         || isEmptyParameter(request.version)
         || isEmptyParameter(request.brand_id)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.eq               = request.eq;
        params.s                = request.s;
        params.p                = request.p;
        params.c                = request.c;
        params.version          = request.version;
        params.brand_id         = request.brand_id;
        params.sc_key           = API_KEY;

        handleAjax("POST", SERVER_URL+"/manager/stampAuth", params, callbackSuccess, callbackFail);
    }

    // 단일 상품 목록 조회
    VC.A007 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.query_type)
         || isEmptyParameter(request.sort_type) //1:쿠폰북명 ASC-default, 2:등록일자 DESC
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.query_type       = request.query_type;
        params.sort_type        = request.sort_type; //1:쿠폰북명 ASC-default, 2:등록일자 DESC

        handleAjax("POST", SERVER_URL+"/goods/list", params, callbackSuccess, callbackFail);
    }

    // 북상품 목록 조회
    VC.A008 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.sort_type) //1:쿠폰북명 ASC-default, 2:등록일자 DESC
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.sort_type        = request.sort_type; //1:쿠폰북명 ASC-default, 2:등록일자 DESC

        handleAjax("POST", SERVER_URL+"/books/list", params, callbackSuccess, callbackFail);
    }

    // 페이퍼 스탬프 발급
    VC.A009 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.trx_no)
         || isEmptyParameter(request.paper_seq_no)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.cid              = request.cid;              // 페이스북 아이디
        params.trx_no           = request.trx_no;           // 생성한 난수 50자리까지 허용
        params.paper_seq_no     = request.paper_seq_no;     // 입력한 번호
        params.recv_info        = request.recv_info;        // ""

        handleAjax("POST", SERVER_URL+"/goods/paper/sendCoupon", params, callbackSuccess, callbackFail);
    }

    // 주문
    VC.A010 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.order_type)
         || isEmptyParameter(request.pay_type)
         || isEmptyParameter(request.buy_type)
         || isEmptyParameter(request.orders)
         || isEmptyParameter(request.delivery_yn)
         || isEmptyParameter(request.payments)
         || isEmptyParameter(request.trx_no)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.cid              = request.cid;
        params.order_type       = request.order_type;
        params.pay_type         = request.pay_type;
        params.buy_type         = request.buy_type;
        params.buyer_name       = request.buyer_name;
        params.orders           = request.orders;
        params.delivery_yn      = request.delivery_yn;
        params.payments         = request.payments;
        params.trx_no           = request.trx_no

        handleAjax("POST", SERVER_URL+"/goods/order", params, callbackSuccess, callbackFail);
    }

    // 발급
    VC.A011 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.order_no)
         || isEmptyParameter(request.payment_amt)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.cid              = request.cid;
        params.order_no         = request.order_no;
        params.payment_amt      = request.payment_amt;

        handleAjax("POST", SERVER_URL+"/goods/issue", params, callbackSuccess, callbackFail);
    }

    // 브라우저 체크
    VC.A012 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.order_no)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.order_no     = request.order_no;
        params.agent_info   = navigator.userAgent;
        params.brws_id      = localStorage.getItem("brwsId");

        handleAjax("POST", SERVER_URL+"/brws/check", params, callbackSuccess, callbackFail);
    }

    // TREEPAY용 해시키 획득을 위한 API
    VC.A013 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.pay_type)
         || isEmptyParameter(request.order_no)
         || isEmptyParameter(request.trade_mony)
         || isEmptyParameter(request.site_cd)
         || isEmptyParameter(request.user_id)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.pay_type                 = request.pay_type;
        params.order_no                 = request.order_no;
        params.trade_mony               = request.trade_mony;
        params.site_cd                  = SITE_CD;
        params.user_id                  = request.user_id;
        params.bill_end_ymd             = request.bill_end_ymd;
        params.bill_frequency           = request.bill_frequency;

        handleAjax("POST", SERVER_URL+"/treepay/hash", params, callbackSuccess, callbackFail);
        // handleAjax("POST", "http://61.35.35.203:45330/voucher/treepay/hash", params, callbackSuccess, callbackFail);
    }

    // 단일 상품 상제 조회
    VC.A014 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.goods_code)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.goods_code               = request.goods_code;

        handleAjax("POST", SERVER_URL+"/goods/detail", params, callbackSuccess, callbackFail);
    }

    // 북 상품 상세 조회
    VC.A015 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.goods_code)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.goods_code               = request.goods_code;

        handleAjax("POST", SERVER_URL+"/books/detail", params, callbackSuccess, callbackFail);
    }

    // 단일 상품 구매내역 상세 조회
    VC.A016 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.ticket_no)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.cid               = request.cid;
        params.ticket_no         = request.ticket_no;

        handleAjax("POST", SERVER_URL+"/goods/issue/detail", params, callbackSuccess, callbackFail);
    }

    // 북 상품 구매내역 상세 조회
    VC.A017 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.cid)
         || isEmptyParameter(request.ticket_no)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.cid               = request.cid;
        params.ticket_no         = request.ticket_no;

        handleAjax("POST", SERVER_URL+"/books/issue/detail", params, callbackSuccess, callbackFail);
    }

    // 상품 발급여부 상태 조회
    VC.A018 = function(request, callbackSuccess, callbackFail) {
        if (isEmptyParameter(request.order_no)
         || isEmptyParameter(callbackSuccess)
         || isEmptyParameter(callbackFail)) {
            callbackFail("E001", "You missed some parameter.");
            return;
        }

        var params = new Object();
        params.order_no         = request.order_no;

        handleAjax("POST", SERVER_URL+"/goods/trx/status", params, callbackSuccess, callbackFail);
    }

    function isEmptyParameter(parameter) {
		return parameter === undefined || parameter === null || parameter === '';
	}

    function handleAjax(type, url, params, callbackSuccess, callbackFail) {
        params.lang = LANGUAGE;
        params.channel = CHANNEL;
        console.log('[' + url + '] PARAMETER :: ', params);

    	$.ajax({
            type: type,
            url: url,
            contentType : "application/json",
    		data: JSON.stringify(params),
    		cache: false,
            crossDomain : true,
            success: function(data) {
        		if (data.resCd == "0000") {
    				callbackSuccess(data.result);
                    console.log('[' + url + '] RESULT :: ', data.result);
        		}
        		else {
        			callbackFail(data.resCd, data.resMsg);
        		}
            },
            error: function (xhr, textStatus, errorThrown) {
                callbackFail(textStatus, errorThrown);
            }
        });
    }
}(window.VC = window.VC = {}, jQuery));

function getCurrentDate() {
	var now = new Date();
	var yyyy = '' + now.getFullYear();
	var mm = (now.getMonth() + 1) > 9 ? '' + (now.getMonth() + 1) : '0' + (now.getMonth() + 1);
	var dd = now.getDate() > 9 ? '' + now.getDate() : '0' + now.getDate();
	return yyyy + mm + dd;
}
