var TEST_KOREA = 1;
var TEST_APSE2 = 2;
var LIVE_BOXCAFE = 3;
var LIVE_KOREA = 4;

var MESSAGE_KOREAN = 'ko';
var MESSAGE_ENGLISH = 'en';
var MESSAGE_THAILAND = 'th';


/******** TODO: 아래의 REGION값에 따라 환경전환 ********/
var REGION = TEST_KOREA;
var SDK_REGION = TEST_KOREA;
var LANGUAGE = MESSAGE_ENGLISH;
/******** TODO: 아래의 REGION값에 따라 환경전환 ********/


// 해당 값은 리전설정에 따라 자동으로 설정됩니다.
var API_KEY;
var APP_ID;
var SERVER_URL;
var ENCRYPT_KEY;
var CHANNEL;
var BRAND;
var SDK_URL;
var LANGUAGE_CODE_TYPE;
var BASE_URL;

// 리전별로 값을 설정합니다.
switch(REGION) {
    case TEST_KOREA :
        APP_ID = '1588754014514176'; // 페이스북 개발앱 아이디입니다. https://developer.facebook.com
        SERVER_URL = 'http://61.35.35.203:45330/voucher'; // 커머스 서버 주소입니다.
        ENCRYPT_KEY = 'fdbee11e56cb431aa7e3767c616c131c'; // 암호화키입니다. 랜덤값을 권장합니다.
        //CHANNEL = 'c475ccd1adbb4956aef350702fd09e10'; // 커머스 서버에 등록된 채널코드입니다.
        //CHANNEL = 'c563fb1df8e744b6a15c042f0fd75760'; // echoss demo 채널코드
        //CHANNEL = '51b6e65ab7e04cd2bd9c82cbca9dd3c9'; // 일본테스트채널코드
        CHANNEL = 'eab8347d42f0435bb24cfb9986a516be'; // 일본테스트채널코드1
        //BRAND = 'V00A002B293'; // 커머스 서버에 등록된 브랜드 코드입니다.
        //BRAND = 'V00A063B001'; // 일본테스트
        //BRAND = 'V00A064B001'; // 일본테스트1
        BASE_URL = './';
    break;

    case TEST_APSE2 :
        APP_ID = '1669898193056408';
        SERVER_URL = 'http://61.35.35.203:45330/voucher';
        ENCRYPT_KEY = 'fdbee11e56cb431aa7e3767c616c131c';
        CHANNEL = 'c475ccd1adbb4956aef350702fd09e10';
        BRAND = 'V00A002B293';
        BASE_URL = './';
    break;

    case LIVE_BOXCAFE :
        APP_ID = '1669898193056408';
        SERVER_URL = 'https://cp-api.apse2.12cmglobal.com/voucher';
        ENCRYPT_KEY = 'fdbee11e56cb431aa7e3767c616c131c';
        CHANNEL = '05caa0e41905449486007ebfc72d3b09';
        BRAND = 'V02A003B001';
        BASE_URL = './';
    break;

    case LIVE_KOREA :
        APP_ID = '1669898193056408';
        SERVER_URL = 'https://cp-inbound.echoss.co.kr/voucher';
        ENCRYPT_KEY = 'fbe7758574a24613b10ab493793c1846';
        CHANNEL = 'fbe7758574a24613b10ab493793c1846';
        BRAND = 'V00A001B002';
        BASE_URL = './';
    break;
}

// script key값입니다.
// 해당 키는 marketing platform admin에서 확인할 수 있습니다.
// 키가 정확하지 않다면 echoss sdk의 초기화가 진행되지 않습니다.
switch(SDK_REGION) {
    case TEST_KOREA :
        API_KEY = 'dad198f2dee6a44bcac29612fdbb55934';
    break;

    case TEST_APSE2 :
        API_KEY = 'd1fc14d830ceb4c26af0c1218f406875d';
    break;

    case LIVE_BOXCAFE :
        API_KEY = 'p8e60f7132bdd47cfb949ddcf0e958b27';
    break;

    case LIVE_KOREA :
        API_KEY = 'p9d3aa94deb714a5fb90030d2a486a6dc';
    break;
}

// echoss sdk를 사용하기위해서 initialize를 진행합니다.
// SDK_REGION값에 따라 자동으로 KOREA와 APSE2지역을 선택합니다
function echossInitialize() {
    switch(SDK_REGION) {
        case TEST_KOREA :
        case LIVE_KOREA :
            echoss.initialize(API_KEY, echoss.REGION_CODE_TYPE.KOREA);
        break;

        case TEST_APSE2 :
        case LIVE_BOXCAFE :
            echoss.initialize(API_KEY, echoss.REGION_CODE_TYPE.APSE2);
        break;
    }
}

// echoss sdk에서 사용하는 언어를 설정합니다.
// LANGUAGE값에 따라 자동으로 KOREAN, ENGLISH, THAI중 하나가 선택됩니다.
function setEchossSDKLanguage() {
    switch(LANGUAGE) {
        case MESSAGE_KOREAN :
            echoss.setLanguageCode(echoss.Common.LANGUAGE_CODE_TYPE.KOREAN); // 영어
        break;
        case MESSAGE_ENGLISH :
            echoss.setLanguageCode(echoss.Common.LANGUAGE_CODE_TYPE.ENGLISH); // 영어
        break;
        case MESSAGE_THAILAND :
            echoss.setLanguageCode(echoss.Common.LANGUAGE_CODE_TYPE.THAI); // 태국어
        break;
    }
}
