var params;
var processing = false;

window.addEventListener('load', function(e) {
	window.applicationCache.addEventListener('updateready', function(e) {
		if (window.applicationCache.status == window.applicationCache.UPDATEREADY) {
			// Browser downloaded a new app cache.
			// Swap it in and reload the page to get the new hotness.
			window.applicationCache.swapCache();
			// if (confirm('A new version of this site is available. Load it?')) {
			// window.location.reload();
			// }
		} else {
		// Manifest didn't changed. Nothing new to server.
		}
	}, false);
}, false);

$(document).ready(function () {
	params = getUrlParameter();
	checkRegionInfo();
	console.log('parameters ::' , params);

	$('.icon_back').on("click",function(){
		history.back();
	});
});

/**
* getUrlParameter
*
* @description : 현재 url의 ?로 표기된 parameter 리턴
* @author      : blog.byuli.com
* @version     : 20081115
* @return      : parameter의 object 형태로 리턴
*/
var getUrlParameter = function (){

	var ParameterObject = new Object();
	var locate = location.href;

	if(locate.indexOf("?")==-1){
		return ParameterObject;
	}

	var parameter = locate.split("?")[1];
	var paramAreay = parameter.split("&");
	for ( var i=0; i<paramAreay.length; i++ )
	{
		var tem = paramAreay[i].split("=");

		// 파라미터명이 encParams일 경우 암호화 해제를 진행합니다.
		if(tem[0] == 'encParams') {
			var paramString = paramAreay[i];
			var index = paramString.indexOf('=');
			var value = paramString.substring(index+1);

			var encObject = decordingParams(value);

			var keys = Object.getOwnPropertyNames(encObject);
			for (var keys in encObject) {
				ParameterObject[keys] = encObject[keys];
			}
		}

		ParameterObject[tem[0]] = tem[1];
	}

	delete ParameterObject.encParams;
	getUrlParameter = function () { return ParameterObject; }
	return ParameterObject;
};

// 파라미터를 UTF-8로 인코딩합니다.
function encordingParams(object) {
	 var jsonString = JSON.stringify(object);
	 var encryptString = encrypt(jsonString);
	 var encodeURIString = encodeURI(encryptString, 'UTF-8');

	 return encodeURIString;
}

// 인코딩된 파라미터를 디코딩합니다.
function decordingParams(paramsString) {
	var decodeURIString = decodeURIComponent(paramsString);
	var decryptString = decrypt(decodeURIString);
	var jsonObject = JSON.parse(decryptString);

	return jsonObject
}

// object를 ENCRYPT_KEY를 키로 사용해서 암호화를 진행합니다.
function encrypt(encryptObject) {
	return Encrypt(encryptObject, ENCRYPT_KEY);
}
// 암호화된 object를 ENCRYPT_KEY로 암호화해제를 진행합니다.
function decrypt(decryptObject) {
	return Decrypt(decryptObject, ENCRYPT_KEY);
}

//문자열 날짜 Format
function formatDateTime(str, type, delim) {

	var str1 = "";
	var str2 = "";
	var str3 = "";
	if (type == 'date') {
		str1 = str.substr(0, 4);
		str2 = str.substr(4, 2);
		str3 = str.substr(6, 2);
	} else {
		str1 = str.substr(0, 2);
		str2 = str.substr(2, 2);
		str3 = str.substr(4, 2);
	}

	return str1 + delim + str2 + delim + str3;
}

// 유효기간을 세팅합니다.
// type 0:유효기간 없음
//		1:발행일로부터 value 일
//		2:발행일로부터 value 개월
//		3:날자
function setShopExpire(type, value) {
	var returnString = '';
	if(type == 1 || type == 2) {
		returnString = MESSAGE_201 +value;
	} else if(type == 3) {
		returnString = formatDateTime(value, 'date', '-') + MESSAGE_202;
	} else {
		returnString = ''+MESSAGE_203;
	}

	return returnString;
}

// 숫자를 제외한 값 지우기
function clearNonNumber(str){
    var res;
    res = str.replace(/[^0-9]/g,"");
    return res;
}

// 현재날자 리턴
// ex) return '18222329819'
function makeCurrentTime() {
	var now = new Date();
	var timeString = '';

	var year = ''+now.getFullYear()
	timeString += year.substring(2, 4);
	timeString += lpad(2, now.getDate());
	timeString += lpad(2, now.getMinutes());
	timeString += lpad(2, now.getSeconds());
	timeString += lpad(3, now.getMilliseconds());

	return timeString;
}

// 현재날자 리턴
// ex) return '20180622'
function getCurrentDate() {
	var now = new Date();
	var timeString = '';

	timeString += lpad(4, now.getFullYear());
	timeString += lpad(2, now.getMonth() +1);
	timeString += lpad(2, now.getDate());

	return timeString;
}

// 거래번호를 생성합니다. 이 값은 날자와 랜덤값으로 이루어집니다.
// ex) return '1822235296028121';
function generatedTransactionCode() {
	var date = new Date();

	var code =
		makeCurrentTime() + Math.floor(Math.random() * 10000) + 1;
	return code;
}

// 파라미터로 받은 length길이의 랜덤 숫자를 생성합니다.
// getRandomNumber(10);
// ex) return '8406212735';
function getRandomNumber(length) {
	var chars = "0123456789";
	var string_length = length;
	var returnString = '';
	for (var i=0; i<string_length; i++) {
		var rnum = Math.floor(Math.random() * chars.length);
		returnString += chars.substring(rnum,rnum+1);
	}
	//document.randform.randomfield.value = returnString;
	return returnString;
}

// 파라미터로 받은 length길이만큼 formatString왼쪽에 0을 채웁니다.
// lpad(4, '2');
// ex) return '0002';
function lpad(length, formatString) {
	formatString = formatString.toString();
	var returnString = '';

	for(var i=0; i<length-formatString.length; i++) {
		returnString += '0';
	}
	returnString += formatString;

	return returnString;;
}

// 바우처의 만료일을 계산합니다.
// 파라미터 end의 값이 NONE이면 유효기간없음을 리턴하고
// 그 이외의 경우에는 'yyyy.mm.dd ~ yyyy.mm.dd'값이 리턴됩니다.
function formatVoucherExpireDate(start, end) {
	var returnString = '';
	if(end == "NONE") {
		returnString = MESSAGE_204;
	} else {
		returnString = formatDateTime(start, 'date', '.') + ' ~ ' + formatDateTime(end, 'date', '.');
	}

	return returnString;
}

// localStorage가 사용가능한지 확인합니다.
// 사용가능하면 true, 사용불가상태이면 false를 리턴합니다.
function hasStorage() {
    try {
        localStorage.setItem('test', 'test');
        localStorage.removeItem('test');
        return true;
    } catch (exception) {
        return false;
    }
}

var tabOn = function(target) {

	if(processing) {
		return;
	}
	processing = true;

	for(var i=1; i<=2; i++) {
		document.getElementById('list_tab0'+i).classList.remove('on');
		document.getElementById('list_content0'+i).classList.remove('on');

		if( target.id == 'list_tab0'+i ) {
			document.getElementById('list_tab0'+i).classList.add('on');
			document.getElementById('list_content0'+i).classList.add('on');
			continue;
		}
	}

	processing = false;
}


// selec box
var target = document.getElementById('selectBox');

function getSelected(target) {
	document.getElementById('selected_val').innerHTML = target.options[target.selectedIndex].value;

	var value = target.options[target.selectedIndex].value;
	$('#goods_price').html(parseInt(basePrice * value));
	$('#goods_sales_price').html(parseInt(baseSalesPrice * value));
}

// 컨펌팝업을 호출합니다.
// 팝업내용, 왼쪽버튼명, 오른쪽버튼명, 왼쪽버튼콜백함수, 오른쪽버튼콜백함수를 파라미터로 받습니다.
// 이미 컴펌팝업이 노출되어있으면 작동하지 않습니다.
function showConfirm(description, leftBtn, rightBtn, leftFunc, rightFunc) {
	if($('.popup_wrap').length > 0) {
		return;
	}

	var popup_wrap = document.createElement("div");
	popup_wrap.className = "popup_wrap";

	var html = '';
	html += '<div class="popup_wrap">';
	html += '	<div class="popup_upper">';
	html += '		<div class="popup_content">';
	html += '			<p class="popup_desc">' + description + '</p>';
	html += '		</div>';
	html += '		<div class="common_btn_bar">';
	html += '			<div class="common_btn_bar_inner">';
	html += '				<div id="pop_left_btn" class="left_btn">';
	html += '					<span>' + leftBtn + '</span>';
	html += '				</div>';
	html += '				<div id="pop_right_btn" class="right_btn">';
	html += '					<span>' + rightBtn + '</span>';
	html += '				</div>';
	html += '			</div>';
	html += '		</div>';
	html += '	</div>';
	html += '</div>';

	popup_wrap.innerHTML = html;
	document.body.appendChild(popup_wrap);

	document.getElementById("pop_left_btn").addEventListener("click", function(){
		popup_wrap.remove();
		leftFunc();
	});
	document.getElementById("pop_right_btn").addEventListener("click", function(){
		popup_wrap.remove();
		rightFunc();
	});
}

// 팝업을 호출합니다.
// 팝업내용, 버튼명, 버튼콜백함수를 파라미터로 받습니다.
// 이미 팝업이 노출되어있으면 작동하지 않습니다.
function showAlert(description, buttonText, buttonFunc) {
	if($('.popup_wrap').length > 0) {
		return;
	}

	var popup_wrap = document.createElement("div");
	popup_wrap.className = "popup_wrap";

	var html = '';
	html += '<div class="popup_wrap">';
	html += '	<div class="popup_upper">';
	html += '		<div class="popup_content">';
	html += '			<p class="popup_desc">' + description + '</p>';
	html += '		</div>';
	html += '		<div class="common_btn_bar">';
	html += '			<div class="common_btn_bar_inner">';
	html += '				<div id="pop_confirm_btn" class="one_btn">';
	html += '					<span>' + buttonText + '</span>';
	html += '				</div>';
	html += '			</div>';
	html += '		</div>';
	html += '	</div>';
	html += '</div>';

	popup_wrap.innerHTML = html;
	document.body.appendChild(popup_wrap);

	document.getElementById("pop_confirm_btn").addEventListener("click", function(){
		popup_wrap.remove();
		buttonFunc();
	});
}

/* terms of service popup */
// 서비스 이용안내를 노출시킵니다. 팝업과 같은 기능을 수행합니다.
function showterms(description, buttonText, buttonFunc) {
	var popup_wrap = document.createElement("div");
	popup_wrap.className = "popup_wrap";

	var html = '';
	html += '<div class="popup_wrap">';
	html += '	<div class="popup_upper">';
	html += '		<div class="popup_content">';
	html += '			<p class="popup_desc">' + description + '</p>';
	html += '		</div>';
	html += '		<div class="common_btn_bar">';
	html += '			<div class="common_btn_bar_inner">';
	html += '				<div id="termspop_btn" class="one_btn">';
	html += '					<span>' + buttonText + '</span>';
	html += '				</div>';
	html += '			</div>';
	html += '		</div>';
	html += '	</div>';
	html += '</div>';

	popup_wrap.innerHTML = html;
	document.body.appendChild(popup_wrap);

	document.getElementById("termspop_btn").addEventListener("click", function(){
		popup_wrap.remove();
		buttonFunc();
	});
}

/* privacy policy popup */
// 개인정보약관을 노출시킵니다. 팝업과 같은 기능을 수행합니다.
function showpolicy(description, buttonText, buttonFunc) {
	var popup_wrap = document.createElement("div");
	popup_wrap.className = "popup_wrap";

	var html = '';
	html += '<div class="popup_wrap">';
	html += '	<div class="popup_upper">';
	html += '		<div class="popup_content">';
	html += '			<p class="popup_desc">' + description + '</p>';
	html += '		</div>';
	html += '		<div class="common_btn_bar">';
	html += '			<div class="common_btn_bar_inner">';
	html += '				<div id="policypop_btn" class="one_btn">';
	html += '					<span>' + buttonText + '</span>';
	html += '				</div>';
	html += '			</div>';
	html += '		</div>';
	html += '	</div>';
	html += '</div>';

	popup_wrap.innerHTML = html;
	document.body.appendChild(popup_wrap);

	document.getElementById("policypop_btn").addEventListener("click", function(){
		popup_wrap.remove();
		buttonFunc();
	});
}

// 이벤트 알럿을 노출시킵니다.
// 알럿에 노출되는 이미지는 images/event_1.png 파일입니다.
function showEventAlert() {
	var html = '';

	var event_wrap = document.createElement("div");
	event_wrap.className = "event_popup";

	html += '<div class="event_popup">';
	html += '	<div class="bg_shadow">';
	html += '		<div class="modal_box">';
	html += '			<p class="title">Event</p>';
	html += '			<img class="event_img" alt="" src="images/event_1.png"/>';
	html += '			<div class="btn_modal" id="event_close">Close</div>';
	html += '		</div>';
	html += '	</div>';
	html += '</div>';

	event_wrap.innerHTML = html;
	document.body.appendChild(event_wrap);

	document.getElementById("event_close").addEventListener("click", function(){
		event_wrap.remove();
	});
}

/* Element Remove ProtoType */
Element.prototype.remove = function() {
	this.parentElement.removeChild(this);
}
NodeList.prototype.remove = HTMLCollection.prototype.remove = function() {
	for(var i = this.length - 1; i >= 0; i--) {
		if(this[i] && this[i].parentElement) {
			this[i].parentElement.removeChild(this[i]);
		}
	}
}


// 현재 리전을 콘솔에 노출합니다.
// 개발용이며 상용서버에 업로드시 삭제를 권장합니다.
function checkRegionInfo() {
	var currentRegion;
	switch(REGION) {
		case TEST_KOREA :
		   currentRegion = 'TEST_KOREA';
		break;

		case TEST_APSE2 :
			currentRegion = 'TEST_APSE2';
		break;

		case LIVE_BOXCAFE :
			currentRegion = 'LIVE_BOXCAFE';
		break;
	}

	var currentSDKRegion;
	switch(SDK_REGION) {
		case TEST_KOREA :
		   currentSDKRegion = 'TEST_KOREA';
		break;

		case TEST_APSE2 :
			currentSDKRegion = 'TEST_APSE2';
		break;

		case LIVE_BOXCAFE :
			currentSDKRegion = 'LIVE_BOXCAFE';
		break;
	}

	var currentSetLanguage;
	switch(LANGUAGE) {
		case MESSAGE_KOREAN :
		   currentSetLanguage = 'MESSAGE_KOREAN';
		break;
		case MESSAGE_ENGLISH :
			currentSetLanguage = 'MESSAGE_ENGLISH';
		break;
		case MESSAGE_THAILAND :
			currentSetLanguage = 'MESSAGE_THAILAND';
		break;
	}
	console.log('current region info >> [region : ' +currentRegion +'] [SDK region : ' +currentSDKRegion +'] [LANGUAGE : ' +currentSetLanguage +']');
}
